 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib game
#hive 1

vfile parent;
lists entities,entitiestohit;
listvf entitiesvf;
listi entitiesabove;
listf entitiesdist;
int state_open;

public void reset() {
	state_open=0;
	parent.setMaster("reset",0);
	//reset listeners
	clearListeners(ON_TICK);
	clearListeners(ON_EVENT);
	clearListeners(ON_ENTITYENTER);
	clearListeners(ON_ENTITYLEAVE);
	clearListeners(ON_TIMEOUT_FRAMES);
}
void init()
{
	//set entity tag
	debugLog("Loading trap: "+getTag());
	this.setChannel("prox.radius",5.0);
	entities=lists();
	entitiestohit=lists();
	entitiesvf=listvf();
	entitiesabove=listi();
	entitiesdist=listf();
	parent=vfopen(this.parentPath(),"r");
	reset();
}
public void regEvents() {
	addListener(ON_ENTITYENTER,"e_enter");
	addListener(ON_ENTITYLEAVE,"e_leave");
}
public string isLoaded() {
	return "1";
}
void playSound() {
	["hero"->playTicToc(parent.getPos().xz())];
}

void e_enter(string _tag) {
	if (_tag=="rock") return;
	if (_tag.length() == 0) return;

	int i;
	int hasbelow=0;
	int hasabove=0;
	int num=entities.num();
	for (i=0;i<num;i++) {
		if (entitiesabove.get(i) == 0 )	hasbelow=1;
		else hasabove=1;
	}	


	float3 rot=parent.getRot();	
	vfile e=vfopenEntityByTag(_tag);
	entities.push(_tag);
	entitiesvf.push( e );
	
	float3 norm=parent.getPos()-e.getPos();
	
	int above=0;
	if (int(rot.h())==0 || int(rot.h())==180) {
		if ( abs(norm.x())>abs(norm.z()) ) above=1;
	}
	else {
		if ( abs(norm.z())>abs(norm.x()) ) above=1;
	}
	
	entitiesabove.push(above);
	entitiesdist.push(5.0);
	
	if (above) {
		if (state_open) {
			parent.setMaster("down",0);
			state_open=0;
			playSound();
			if (hasbelow){
				num = entities.num();
				entitiestohit.clear(); 
				for (i=0;i<num;i++) {
					if (entitiesabove.get(i)==0 && entities.get(i)!=_tag) { //if the entity is below						
						string entag= entities.get(i);						
						vfile vf=entitiesvf.get(i);
						float dist=(vf.getPos()-this.getWorld().getPos()).xz().length();
						if (dist < 1.2)  entitiestohit.push(entag);							
						else {
							if (entag!="hero") [entag->doValidateLog(getTag())];
						}
					}
				}
				addListener(ON_TIMEOUT_FRAMES,"6","bridgehit");
			}
		}
	}
	else { //if not above
		if (!state_open) {
			//check if we have anyone above			
			if (!hasabove) {
				//clearListeners(ON_TIMEOUT_FRAMES);
				parent.setMaster("up",0);
				state_open=1;
				playSound();
			} else {
				[_tag->doValidateLog(getTag())];
			}
		}
	}
	
	if (entities.num()==1) addListener(ON_TICK,"tick");
}
void bridgehit(string _tag){	
	int num = entitiestohit.num();
	int i;
	for (i=0;i<num;i++) {
		sendEvent("HIT" , entitiestohit.get(i) );
	}
}
void e_leave(string _tag) {
	int index=entities.findIndex(_tag);
	entities.delIndex(index);
	entitiesvf.delIndex(index);
	entitiesabove.delIndex(index);
	entitiesdist.delIndex(index);
	if (entities.num()==0) clearListeners(ON_TICK);
	else {
		int i;
		int above=0;
		int num=entitiesabove.num();
		for (i=0;i<num;i++) {
			if (entitiesabove.get(i)) {
				above=1;
				break;
			}
		}
		if (above) {
			if (state_open) {
				parent.setMaster("down",0);
				state_open=0;
				playSound();				
			}			
		}
		else {
			if (!state_open) {
				parent.setMaster("up",0);
				state_open=1;
				playSound();				
			}			
		}
	}
	[_tag->setBaseY(2.33)];
	[_tag->setSpeedTrap(1.0)];
}
void cbBridgeDown() { 
	int i;
	int num=entities.num();
	for (i=0;i<num;i++) { 
		vfile vf=entitiesvf.get(i);
		if (entitiesabove.get(i)==0) {
			float dist=(vf.getPos()-this.getWorld().getPos()).xz().length();
			string tag=entities.get(i);
			if (dist<=3.0) {
				sendEvent("HIT",tag);
			}
		}
	}
}
void tick() {
	int i;
	vfile vf;
	float dist;
	int num=entities.num();
	int tagsabove= 0;
	int tagsbelow= 0;
	for (i=0;i<num;i++) {
		vf=entitiesvf.get(i);
		if (entitiesabove.get(i)) {
			tagsabove ++;
			dist=(vf.getPos()-this.getWorld().getPos()).xz().length();
			string tag=entities.get(i);
			if (dist<=2.0) {
				[tag->setBaseY(4.03)];
				[tag->setSpeedTrap(0.75)];
			}
			else {
				[tag->setBaseY(2.33 + (1.0-((dist-2.0)/2.8))*1.7)];
				if (dist<=entitiesdist.get(i)) {
					[tag->setSpeedTrap(0.4)];
				}
				else {
					[tag->setSpeedTrap(1.2)];
				}
			}
			entitiesdist.set(i,dist);
		}
		else tagsbelow ++;
	}
	if (state_open==0){
		if (tagsabove == 0 && tagsbelow >0){
			parent.setMaster("up",0);
			state_open=1;
			playSound();
			for (i=0;i<entities.num();i++) {
				string entag = entities.get(i);
				if (entag!="hero") [entag->doValidateLog(getTag())];
			}
		}
	}
}
public void saveState() {
}
public void loadState() {
}
public int validate(float _heading) {
	if (entities.num()==0) return 1;
	//below
	int i,num;
	if (minAngle(_heading,parent.getRot().h())<=5 || minAngle(_heading,180.0+parent.getRot().h())<=5) {
		num=entitiesabove.num();
		for (i=0;i<num;i++) {
			if (entitiesabove.get(i)) return 0;
		}
	}
	else { //from above
		return 1;
		 // num=entitiesabove.num();
		 // for (i=0;i<num;i++) {
			// if (entitiesabove.get(i)==0) {
				// return 0;
			// }
		// }
	}
	return 1;
}

