 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib game
#hive 1

vfile duck1,duck2,duck3,parent;
Resource res;
int loaded=0;
int cross_open,cross_actual_open;
int incoming;
string mainclip;

void defaults() {
	duck1.show();
	duck2.show();
	duck3.show();
	
	duck1.setMaster("cycleA01",0);
	duck2.setMaster("cycleA01",1);
	duck3.setMaster("cycleA01",2);

	parent=vfopen(this.parentPath(),"r");
	this.setChannel("prox.radius",3.5);	
	
	incoming=0;
	mainclip="";
	
	clearListeners(ON_TICK);
	clearListeners(ON_EVENT);	
	clearListeners(ON_TIMEOUT_FRAMES);
	clearListeners(ON_ENTITYENTER);
	clearListeners(ON_ENTITYLEAVE);
}

void init()
{
	//set entity tag
	debugLog("Loading trap: "+getTag());
	res=Resource("levelsets/city/duck.hvfs","resLoaded");	
}
void resLoaded() {
	duck1=res.use("duck.actor","");
	duck2=res.use("duck.actor","");
	duck3=res.use("duck.actor","cbActorLoaded");
}
void cbActorLoaded() {
	loaded=1;
	defaults();
}
public void reset() {
	defaults();
}
public string isLoaded() {
	return string(loaded);
}
void e_enter() {
	incoming++;
}
void e_leave() {
	incoming--;
}
public void regEvents() {
	addListener(ON_ENTITYENTER,"e_enter");
	addListener(ON_ENTITYLEAVE,"e_leave");
	cross_open=0;
	cross_actual_open=0;
	fCall("cycleA");
}

void playSound() {
	["hero"->playTicToc(parent.getPos().xz())];
}

void resetListeners() {
	delListener(ON_TIMEOUT_FRAMES,"cbCrossOpened");
	delListener(ON_TIMEOUT_FRAMES,"cycleA");
	delListener(ON_TIMEOUT_FRAMES,"cycleB");
	delListener(ON_TIMEOUT_FRAMES,"crossAtoB");
	delListener(ON_TIMEOUT_FRAMES,"crossBtoA");
}

void cbDuck2() {
	duck2.setMaster(mainclip,0);
}
void cbDuck3() {
	duck3.setMaster(mainclip,0);
}
float setDuckMaster(string _clip) {
	mainclip=_clip;
	float ret=duck1.setMaster(_clip,0);
	addListener(ON_TIMEOUT_FRAMES,"30","cbDuck2");
	addListener(ON_TIMEOUT_FRAMES,"65","cbDuck3");
	return ret;
}

void cycleA() {
	resetListeners();
	if (!cross_open) {
		addListener(ON_TIMEOUT_FRAMES,string(parent.setMaster("up",0)/2),"cbCrossOpened");
		cross_open=1;
		playSound();
	}
	addListener(ON_TIMEOUT_FRAMES,string(setDuckMaster("cycleA01")),"crossAtoB");
}
void crossAtoB() {
	resetListeners();
	if ((rand(100)<70) && (incoming<=0)) {
		if (cross_open) {
			parent.setMaster("down",0);
			cross_open=0;
			cross_actual_open=0;
			playSound();			
		}
		addListener(ON_TIMEOUT_FRAMES,string(setDuckMaster("crossAtoB02")+40),"cycleB");
	}
	else {
		cycleA();
	}
}
void cycleB() {
	resetListeners();
	if (!cross_open) {
		addListener(ON_TIMEOUT_FRAMES,string(parent.setMaster("up",0)/2),"cbCrossOpened");
		cross_open=1;
		playSound();
	}
	addListener(ON_TIMEOUT_FRAMES,string(setDuckMaster("cycleB01")),"crossBtoA");
}
void crossBtoA() {
	resetListeners();
	if ((rand(100)<70) && (incoming<=0)) {
		if (cross_open) {
			parent.setMaster("down",0);
			cross_open=0;
			cross_actual_open=0;
			playSound();			
		}
		addListener(ON_TIMEOUT_FRAMES,string(setDuckMaster("crossBtoA02")+40),"cycleA");
	}
	else {
		cycleB();
	}
}
void cbCrossOpened() {
	cross_actual_open=1;
}
public int validate(float _heading) {
	return cross_actual_open;
}
