 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib game
#hive 1

Resource res;
vfile clunny,water,bunny;
int loaded=0;
float CONST_MIN_ANGLE=130.0;
float CONST_MAX_ANGLE=230.0;
float timeout;

public void reset() {
	clunny.setScale(float3(0.6,0.6,0.6));
	clunny.setPos(float3(0.1,2.63,-3.7));
	clunny.setRot(hpr(180.0,0.0,0.0));
	clunny.show();
	water.show();
	this.setChannel("prox.radius",14.0);
	water.setService("emit.rate",0.0);
	clunny.setMaster("idle",1);
	timeout=0;
	
	clearListeners(ON_TICK);
	clearListeners(ON_EVENT);
	clearListeners(ON_ENTITYENTER);
	clearListeners(ON_ENTITYLEAVE);
	clearListeners(ON_TIMEOUT_FRAMES);
}

void init() {
	debugLog("Loading trap: "+getTag());
	res=Resource("levelsets/city/enemy.city.faucet.hvfs","resLoaded");
}
void resLoaded() {
	water=res.use("water","waterLoaded");
	clunny=res.use("enemy.faucet.actor","clunnyLoaded");
}
void clunnyLoaded() {
	loaded=1;
	reset();
}
public string isLoaded() {
	return string(loaded);
}
public void regEvents() {
	addListener(ON_ENTITYENTER,"e_enter");
	addListener(ON_ENTITYLEAVE,"e_leave");
}
void e_enter(string _tag) {
	if (_tag=="hero") {
		bunny=vfOpenEntityByTag(_tag);
		water.setService("emit.rate",1.0);
		clearListeners(ON_TIMEOUT_FRAMES);
		addListener(ON_TIMEOUT_FRAMES,string(clunny.setMaster("faucet",0)),"cbIdle");
		water.setRot(hpr( CONST_MIN_ANGLE+ float(rand(3))*((CONST_MAX_ANGLE-CONST_MIN_ANGLE)/3.0),0.0,0.0));
		addListener(ON_TICK,"tick");
		timeout=180*((water.getRot().h()-CONST_MIN_ANGLE)/(CONST_MAX_ANGLE-CONST_MIN_ANGLE));
	}
}
void e_leave(string _tag) {
	if (_tag=="hero") {
		if (bunny) {
			bunny=0;
			clearListeners(ON_TICK);
			clearListeners(ON_TIMEOUT_FRAMES);
			addListener(ON_TIMEOUT_FRAMES,string(clunny.setMaster("faucet",0)),"cbIdle");
			addListener(ON_TIMEOUT_FRAMES,"20","cbIdleWater");
		}
	}
}
void cbIdleWater() {
	water.setService("emit.rate",0.0);
}
void cbIdle() {
	clunny.setMaster("idle",1);
}
void tick() {
	timeout+=fElapsed()*1.5;
	if (timeout>=360.0) timeout-=360.0;
	water.setRot(hpr( CONST_MIN_ANGLE+ abs(cos(radians(timeout)))*(CONST_MAX_ANGLE-CONST_MIN_ANGLE),0.0,0.0));
	if (bunny) {
		float3 pos=bunny.getPos();
		if (pos.y()<3.0) {
			//find water position
			float3 cpos1=water.getWorld().mul(float3(0,0,-4.4));
			float3 cpos2=water.getWorld().mul(float3(0,0,-2.4));
			cpos1.y(pos.y());
			cpos2.y(pos.y());
			if ( length(cpos1-pos)<1.0 || length(cpos2-pos)<1.0 ) {
				sendEvent("WATER","hero");
				e_leave("hero");
			}
		}
	}
}


