 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib game
#hive 1

lists entities;
listvf entitiesvf;
float bunny_deep=0.0;
float bunny_deep_delay=0.0;

void init()
{
	//set entity tag
	debugLog("Loading trap: "+getTag());
	this.setChannel("prox.radius",3.0);
	entities=lists();
	entitiesvf=listvf();
}
public void regEvents() {
	addListener(ON_ENTITYENTER,"e_enter");
	addListener(ON_ENTITYLEAVE,"e_leave");
	addListener(ON_EVENT,"JUMP","e_jump");
}
public string isLoaded() {
	return "1";
}
void e_jump() {	
	bunny_deep_delay=60.0;
}
void e_enter(string _tag) {
	if (_tag=="rock") return;
	entities.push(_tag);
	entitiesvf.push( vfopenEntityByTag(_tag) );
	if (entities.num()==1) addListener(ON_TICK,"tick");
	if (_tag=="hero") {
		bunny_deep_delay=0.0;
		bunny_deep=0.0;
	}
}
void e_leave(string _tag) {
	if (_tag=="rock") return;

	int index=entities.findIndex(_tag);
	entities.delIndex(index);
	entitiesvf.delIndex(index);
	if (entities.num()==0) clearListeners(ON_TICK);
	[_tag->setBaseY(2.33)];
	[_tag->setSpeedTrap(1.0)];
	[_tag->setTimeScale(1.0)];
	if (_tag=="hero") ["hero"->setJumpScale(1.0)];
}
public void reset() {}

void tick() {
	int i;
	vfile vf;
	float dist,speed,timescale;
	int num=entities.num();
	string tag;
	
	for (i=0;i<num;i++) {
		vf=entitiesvf.get(i);
		dist=(vf.getPos()-this.getWorld().getPos()).xz().length();
		tag=entities.get(i);
		if (tag=="hero") {	
			["hero"->setBaseY(2.33 - bunny_deep - (1.0-(dist/3.0))*1.0 )];		
			if ((dist/3.0)<0.5) {
				if (bunny_deep<0.2) { ["hero"->setJumpScale(1.0)];	}
				else { ["hero"->setJumpScale(0.0)];	}
				
				speed=0.02;
				if (bunny_deep_delay>0.0) {
					if (bunny_deep_delay>55.0) {
						bunny_deep=max(-0.2,bunny_deep-fElapsed()*0.2);
						["hero"->setTimeScale(1.0)];
					}			
					else {
						bunny_deep=min(1.0,bunny_deep+fElapsed()*0.02);
						["hero"->setTimeScale(0.5)];
					}
					bunny_deep_delay-=fElapsed();					
				}
				else {
					bunny_deep=min(1.0,bunny_deep+fElapsed()*0.2);
					["hero"->setTimeScale(0.5)];
				}
			}
			else {
				speed=max(0.1,dist/3.0);
				["hero"->setJumpScale(1)];
				[tag->setTimeScale(max(0.5,speed))];
			}
		}
		else {
			speed=max(0.1,dist/3.0);		
			[tag->setBaseY(2.33 - (1.0-(dist/3.0))*1.5 )];
			[tag->setTimeScale(max(0.5,speed))];
		}
		[tag->setSpeedTrap(speed)];
	}
}
