 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib game
#hive 1
String APPNAME = "bunnymaze";

Resource res;
vfile actor,parent;
int loaded=0;

int incoming,state;

int CONST_STATE_RESET=0;
int CONST_STATE_LEFT=1;
int CONST_STATE_RIGHT=2;

lists l_entities;

void defaults() {
	l_entities=lists();
	incoming=0;
	state=CONST_STATE_RESET;
	actor.show();
	actor.setMaster("reset",0);
	actor.setRot(hpr(180.0,0.0,0.0));
	actor.setPos(float3(0.0,1.0,-1.8));
	actor.setScale(float3(0.8,0.8,0.8));
	
	parent=vfopen(this.parentPath(),"r");
	this.setChannel("prox.radius",6.0);	
	
	//reset listeners
	clearListeners(ON_TICK);
	clearListeners(ON_EVENT);
	clearListeners(ON_ENTITYENTER);
	clearListeners(ON_ENTITYLEAVE);
	clearListeners(ON_TIMEOUT_FRAMES);
}

void init()
{
	//set entity tag
	debugLog("Loading trap: "+getTag());
	res=Resource("levelsets/docks/sign.hvfs","resLoaded");
}
void resLoaded() {
	actor=res.use("sign.actor","cbActorLoaded");
}
void cbActorLoaded() {
	loaded=1;
	defaults();
}
public void savestate() {
	appPropertySet(APPNAME,getTag()+"_STATE",string(state));
}
public void loadstate() {
	state=int(appPropertyGet(APPNAME,getTag()+"_STATE",string(state)));
	if (state==CONST_STATE_RIGHT) actor.setMaster("right",0);
	else if (state==CONST_STATE_LEFT) actor.setMaster("left",0);		
}
public void regEvents() {
	addListener(ON_ENTITYENTER,"e_enter");
	addListener(ON_ENTITYLEAVE,"e_leave");
}
public void reset() {
	defaults();
}
public string isLoaded() {
	return string(loaded);
}
void e_enter(string _tag) {
	if (_tag.startsWithNoCase("rock")) return;
	//check if entity is facing sign
	vfile vf=vfopenEntityByTag(_tag);
	if (minAngle(vf.getRot().h(),parent.getRot().h())<20) {	
		l_entities.push(_tag);
		if (l_entities.num()==1) {
			clearListeners(ON_TIMEOUT_FRAMES);
			state=1+rand(2);
			int frames=0;
			if (state==CONST_STATE_RIGHT) frames=int(actor.setMaster("right",0));
			else frames=int(actor.setMaster("left",0));
			if (_tag=="hero") {
				["hero"->playTrapSound()];
			}
			float3 pos=;
			["hero"->playTicTocShort(parent.getPos().xz())];
		}
		string dir=[_tag->getdir() as string];
		if (state==CONST_STATE_RIGHT) {
			if (dir=="N") {
				[_tag->setForceNext("E")];
			}
			else if (dir=="S") {
				[_tag->setForceNext("W")];
			}
			else if (dir=="E") {
				[_tag->setForceNext("S")];
			}
			else if (dir=="W") {
				[_tag->setForceNext("N")];
			}
		}
		else {
			if (dir=="N") {
				[_tag->setForceNext("W")];
			}
			else if (dir=="S") {
				[_tag->setForceNext("E")];
			}
			else if (dir=="E") {
				[_tag->setForceNext("N")];
			}
			else if (dir=="W") {
				[_tag->setForceNext("S")];
			}
		}
	}
}
void e_leave(string _tag) {
	if (_tag.startsWithNoCase("rock")) return;
	int index=l_entities.findIndex(_tag);
	if (index<l_entities.num()) {
		l_entities.delIndex(index);
		if (l_entities.num()==0) {	
			state=CONST_STATE_RESET;
			addListener(ON_TIMEOUT_FRAMES,string(2*getFPS()),"cbReset");
		}
		[_tag->resetForceNext()];	
	}
}
void cbReset() {
	actor.setMaster("reset",0);
}
