 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib game
#hive 1
String APPNAME = "bunnymaze";

vfile log,parent;
float TARGET_H;
float TURN_SPEED;
lists l_inside;

void defaults() {
	TURN_SPEED=5.0;
	TARGET_H=0.0;
	l_inside.clear();
	this.setChannel("prox.radius",3.8);
	this.setPos(float3(0,3.5,0));
	log.setRot(float3(0,0,0));
	
	clearListeners(ON_TICK);
	clearListeners(ON_EVENT);	
	clearListeners(ON_TIMEOUT_FRAMES);
	clearListeners(ON_ENTITYENTER);
	clearListeners(ON_ENTITYLEAVE);
}

void init()
{
	//set entity tag
	debugLog("Loading trap: "+getTag());
	parent=vfopen(this.parentPath(),"r");
	log=vfopen(this.path()+"/../trunk","r");
	l_inside=lists();
	defaults();
}
public void reset() {
	defaults();
} 
void doAutoRot() {
	delListener(ON_TIMEOUT_FRAMES,"cbAutoRot");
	addListener(ON_TIMEOUT_FRAMES,string( (2+rand(1))*getFps() ),"cbAutoRot");
}
public void regEvents() {
	addListener(ON_ENTITYENTER,"e_enter");
	addListener(ON_ENTITYLEAVE,"e_leave");
	addListener(ON_TICK,"tick");
	doAutoRot();
}
public void savestate() {
	appPropertySet(APPNAME,getTag()+"_HEADING",string(TARGET_H));
}
public void loadstate() {
	TARGET_H=float(appPropertyGet(APPNAME,getTag()+"_HEADING",string(TARGET_H)));
	log.setRot(float3(0,TARGET_H,0));
}
public string isLoaded() {
	return "1";
}
void e_enter(string _tag) {
	if (_tag.startsWithNoCase("rock")) {
		if (log.getRot().h == TARGET_H) { //if not rotating
			delListener(ON_TIMEOUT_FRAMES,"cbAutoRot");
			fCall("cbAutoRot");
		}
		return;
	}
	if ([_tag->doValidateLog(getTag()) as int]) {
		l_inside.push(_tag);
	}
	else {
		if (_tag!="hero") l_inside.push(_tag);
	}
}
void e_leave(string _tag) {
	if (_tag.startsWithNoCase("rock")) return;
	if (l_inside.num()==0) return;
	l_inside.delIndex( l_inside.findIndex(_tag) );
	if (l_inside.num()==0) {
		TURN_SPEED=5.0;
		TARGET_H+=90;
		if (TARGET_H>=360) TARGET_H-=360;
		float2 pos=parent.getPos().xz();
		["hero"->playTicToc(pos)];
		["hero"->playSplash(pos)];
		doAutoRot();
	}
}
void cbAutoRot() {
	if (l_inside.num()==0) {
		//TURN_SPEED=1.5;
		TURN_SPEED=2.5;
		TARGET_H+=90;
		if (TARGET_H>=360) TARGET_H-=360;
		float2 pos=parent.getPos().xz();
		["hero"->playTicToc(pos)];
		["hero"->playSplash(pos)];
	}
	doAutoRot();
}
void tick() {
	float3 rot=log.getRot();
	//if (rot.h != TARGET_H) 
	rot.h(turnangle(rot.h,TARGET_H,TURN_SPEED*fElapsed()));	
	rot.p( cos(radians(fcyclic()*4.0))*2.0 );
	rot.r( sin(radians(fcyclic()*2.0))*2.0 );
	log.setRot(rot);
	log.setPos(float3(0.0,0.15+abs(sin(radians(fcyclic())))*0.1,0.0));
}
public int validate(float _heading) {
	if (minAngle(TARGET_H,log.getRot().h())>5) return 0;
	return (int(minAngle(log.getRot().h(),_heading))<3) || (int(minAngle(log.getRot().h()+180.0,_heading))<3);
}
