 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib game
#hive 1

lists entities;
listvf entitiesvf;

void init()
{
	//set entity tag
	debugLog("Loading trap: "+getTag());
	this.setChannel("prox.radius",3.0);
	entities=lists();
	entitiesvf=listvf();
}
public void regEvents() {
	addListener(ON_ENTITYENTER,"e_enter");
	addListener(ON_ENTITYLEAVE,"e_leave");
}
public string isLoaded() {
	return "1";
}
public void reset() {}
void e_enter(string _tag) {
	if (_tag=="rock") return;
	entities.push(_tag);
	entitiesvf.push( vfopenEntityByTag(_tag) );
	if (entities.num()==1) addListener(ON_TICK,"tick");
	["hero"->playSplash(this.getWorld().getPos().xz())];
}
void e_leave(string _tag) {
	if (_tag=="rock") return;
	int index=entities.findIndex(_tag);
	entities.delIndex(index);
	entitiesvf.delIndex(index);
	if (entities.num()==0) clearListeners(ON_TICK);
	[_tag->setBaseY(2.33)];
	[_tag->setSpeedTrap(1.0)];
}
void tick() {
	int i;
	vfile vf;
	float dist;
	int num=entities.num();
	string tag;
	for (i=0;i<num;i++) {
		tag=entities.get(i);
		vf=entitiesvf.get(i);
		dist=(vf.getPos()-this.getWorld().getPos()).xz().length();
		[tag->setBaseY(2.33 - (1.0-(dist/3.0))*1.5 )];
		[tag->setSpeedTrap(max(0.2,dist/3.0))];
	}
}
public void saveState() {
}
public void loadState() {
}
