 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib game
#hive 1

int crack_state=0;
vfile actor;
lists entities;
listvf entitiesvf;
float bunny_deep=0.0;
float bunny_deep_delay=0.0;
int disabled = 0;
String APPNAME = "bunnymaze";

public void reset() {  
	crack_state=0;
	actor.setMaster("reset",0);
	this.setPos(float3(0.0,2.0,0.0));
	disabled = 0;
}
void init()
{ 	
	debugLog("Loading trap: "+getTag());
	this.setChannel("prox.radius",2.9);
	actor=vfopen(this.path()+"/../","r");
	actor.onComplete("reset");
	entities=lists();
	entitiesvf=listvf();
	bunny_deep=0.0;
	bunny_deep_delay=0.0;
	reset();
}
public string isLoaded() { 
	return "1";
}
public void regEvents() {  
	addListener(ON_ENTITYENTER,"e_enter");
	addListener(ON_ENTITYLEAVE,"e_leave");
	addListener(ON_EVENT,"JUMP","e_jump");
	addListener(ON_EVENT,"VICTORY","e_disable");
	addListener(ON_EVENT,"FAIL","e_disable");
}

void e_jump() {
	bunny_deep_delay=60.0;
}


public void savestate() {
	appPropertySet(APPNAME,getTag()+"_CRACKED",string(crack_state));
}
public void loadstate() {
	crack_state=int(appPropertyGet(APPNAME,getTag()+"_CRACKED",string(crack_state)));
	if (crack_state==2) {
		actor.setMaster("crack",0);
	}
	else if (crack_state==2) {
		actor.setMaster("collapse",0);
	}
}
public int validate() {
	return (crack_state<2);	
	//return 0;
}
void e_disable(){
	print("disabled");
	disabled = 1;
}
int testbreak(vfile vf){
	float dist=(vf.getPos()-this.getWorld().getPos()).xz().length();
	if (dist < 1.7){
		bunny_deep_delay=0.0;
		bunny_deep=0.0;
		crack_state=2;
		actor.setMaster("collapse",0);
		["hero"->playSound(actor.getPos().xz(),"trap-bridgecollapse.audio"];
		//delListener(ON_TICK,"tick_normal");
		//addListener(ON_TICK,"tick_cracked");
		return 1;
	}
	return 0;
}
void e_enter(string _tag) {
	if (_tag=="rock" || _tag=="banana") return;
	entities.push(_tag);
	entitiesvf.push( vfopenEntityByTag(_tag) );	
	if (crack_state == 0) {		
		if (_tag=="hero") {
			int broke = 0;
			float y= [_tag->getJumpY() as float];
			if ([_tag->isJumping() as int]){
				broke = testbreak(vfopenEntityByTag(_tag));				
			} 
			if (broke){
				delListener(ON_TICK,"tick_normal");
				addListener(ON_TICK,"tick_cracked");				
				["hero"->playSound(actor.getPos().xz(),"trap-bigsplash.audio"];
			} else { // if not jumping
				addListener(ON_TICK,"tick_normal");
				delListener(ON_TICK,"tick_cracked");
				actor.setMaster("shake",0);
				["hero"->playSound(actor.getPos().xz(),"trap-bridgewobble.audio"];
			}									
		} else { //not hero
			[_tag->doValidateLog(getTag())];
		}
	}	
	else if (crack_state == 2) {
		if (_tag=="hero") {
			bunny_deep_delay=0.0;
			bunny_deep=0.0;
			delListener(ON_TICK,"tick_normal");
			addListener(ON_TICK,"tick_cracked");
			["hero"->playSound(actor.getPos().xz(),"trap-bigsplash.audio"];
		} else { //not hero
			[_tag->doValidateLog(getTag())];
		}
		return;  
	}
}
void e_leave(string _tag) {
	if (_tag=="rock" || _tag=="banana") return;
	int index=entities.findIndex(_tag);
	entities.delIndex(index);
	entitiesvf.delIndex(index);
	if (entities.num()==0) {
		delListener(ON_TICK,"tick_normal");
		delListener(ON_TICK,"tick_cracked");
		}
	[_tag->setSpeedTrap(1.0)];
	[_tag->setBaseY(2.33)];
	[_tag->setJumpScale(1.0)];	
}
void tick_normal() {	
	int i;
	int num=entities.num();
	string tag;	
	for (i=0;i<num;i++) {
		tag=entities.get(i);
		[tag->setSpeedTrap(0.8)];
		if (tag == "hero"){
			if (["hero"->isJumping() as int] ){
				if (testbreak(entitiesvf.get(i) )){
					[tag->setSpeedTrap(1.0)];
				}
			}
		}
	}
}
void tick_cracked() {
	if (disabled){
		["hero"->setTimeScale(1.0)];
		["hero"->setSpeedTrap(1.0)];
		["hero"->setBaseY(2.33)];		
		return;
	}
	int i;
	vfile vf;
	float dist,speed,timescale;
	int num=entities.num();
	string tag;
	for (i=0;i<num;i++) {
		float MAX_DEEP = 2.0;
		vf=entitiesvf.get(i);
		dist=(vf.getPos()-this.getWorld().getPos()).xz().length();
		tag=entities.get(i);
		if (tag=="hero") {		
			["hero"->setBaseY(2.33 - bunny_deep - (1.0-(dist/3.0))*1.0 )];
			if (bunny_deep<0.2) { ["hero"->setJumpScale(1.0)];	}
			else { ["hero"->setJumpScale(0.0)];	}
			speed=0.01;
			if (bunny_deep_delay>0.0) { 
				if (bunny_deep_delay>55.0) {
					bunny_deep=max(-0.2,bunny_deep-fElapsed()*0.3);
					["hero"->setTimeScale(1.0)];
				}			
				else {
					bunny_deep=min(MAX_DEEP,bunny_deep+fElapsed()*0.02);
					["hero"->setTimeScale(0.6)];
				}
				bunny_deep_delay-=fElapsed();
			}
			else {
				bunny_deep=min(MAX_DEEP,bunny_deep+fElapsed()*0.3);
				["hero"->setTimeScale(0.6)];
			}
			[tag->setSpeedTrap(speed)];		
		} 
		else {
			["hero"->setBaseY(2.33 - (1.0-(dist/3.0))*1.0 )];
		}
	}
}

