 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib game
#hive 1

Resource res;
vfile actor,parent,ball,bunny;
int loaded=0;
float on_target;
float3 velocity;
lists entities;
listvf entitiesvf;

void defaults() {
	actor.show();
	actor.setMaster("idle",0);
	actor.setRot(hpr(180.0,0.0,0.0));
	actor.setPos(float3(-0.6,4.66,-3.4));
	actor.setScale(float3(1.4,1.4,1.4));
	
	ball.show();
	ball.tempHide();
	
	parent=vfopen(this.parentPath(),"r");
	this.setChannel("prox.radius",12.0);	
	
	on_target=-1;
	
	//reset listeners
	clearListeners(ON_TICK);
	clearListeners(ON_TIMEOUT_FRAMES);
	clearListeners(ON_ENTITYENTER);
	clearListeners(ON_ENTITYLEAVE);
}

void init()
{
	//set entity tag
	debugLog("Loading trap: "+getTag());
	res=Resource("levelsets/traps/penguin.hvfs","resLoaded");	
	entities=lists();
	entitiesvf=listvf();
}
void resLoaded() {
	actor=res.use("penguin.actor","cbActorLoaded");
	ball=res.use("snowball","");
}
void cbActorLoaded() {
	loaded=1;
	defaults();
}
public void savestate() {
}
public void loadstate() {
}
public void reset() {
	defaults();
}
public string isLoaded() {
	return string(loaded);
}
void cbThrow() {
	float frames=actor.setMaster("snowball",0);
	addListener(ON_TIMEOUT_FRAMES,string(frames),"cbIdle");
	addListener(ON_TIMEOUT_FRAMES,string(frames*0.75),"cbBall");
}
void cbIdle() {
	addListener(ON_TIMEOUT_FRAMES,string(actor.setMaster("idle",0) - float(rand(int(getFps())))),"cbThrow");
}
void cbBall() {
	on_target=-1;
	ball.tempShow();
	ball.setPos(float3(0,5.7,-3.5));
	ball.setScale(float3(3.5,3.5,3.5));	
	velocity=float3(0,abs(noise())*2,-1);
	float3 rot=actor.getRot();
	velocity.roth(h(rot));
	velocity.normalize();
	float3 pos=;
	["hero"->playPenguin(parent.getPos().xz(),"ball")];
}
public void regEvents() {
	addListener(ON_ENTITYENTER,"e_enter");
	addListener(ON_ENTITYLEAVE,"e_leave");
	addListener(ON_TICK,"tick");
	cbIdle();
}
void e_enter(string _tag) {
	entities.push(_tag);
	entitiesvf.push( vfopenEntityByTag(_tag) );
}
void e_leave(string _tag) {
	int index=entities.findIndex(_tag);
	entities.delIndex(index);
	entitiesvf.delIndex(index);
}
void tick() {
	if (on_target>0.0) {
		on_target-=fElapsed();
		if (on_target<=0.0) {
			ball.setPos(ball.getPos()+float3(0,-50,0));
			ball.tempHide();
		}
		else {
			float s=(on_target/20.0)*3.5;
			ball.setScale(float3(s,s,s));
			
			float3 r=ball.getRot();
			r.p(	r.p()+fElapsed()*20 );
			if (r.p()>360) r.p( r.p()-360 );
			ball.setRot(r);
		}
		return;
	}
	float3 pos=ball.getPos();
	if (pos.y()<0.0) {
		ball.tempHide();
		return;
	}
	if (pos.y()<2.5) {
		on_target=20.0;
		return;
	}
	velocity=velocity+float3(0,-0.05,0)*fElapsed();
	pos=pos+velocity*fElapsed()*0.5;
	ball.setPos(pos);
	
	float3 rot=ball.getRot();
	rot.p(	rot.p()+fElapsed()*20 );
	if (rot.p()>360) rot.p( rot.p()-360 );
	ball.setRot(rot);
	
	pos=ball.getWorld().getPos();
	int i;
	int num=entitiesvf.num();
	for (i=0;i<num;i++) {
		float3 epos=entitiesvf.get(i).getPos();
		if ( length( (epos - pos).xz() )<2.0 ) {
			if ( (pos.y()>(epos.y()+0.5)) && (pos.y()<(epos.y()+3.0)) ) {
				on_target=20.0;
				sendEvent("SNOWBALL",entities.get(0)); 
			}
		}
	}
}

