 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib game
#hive 1
String APPNAME = "bunnymaze";
Resource res;
vfile actor;
int bLoaded=0;
float DEACTIVE_TIMEOUT,DEACTIVE_TIMEOUT_FLOATING;
float3 dirnorm;

void defaults() {
	this.setChannel("prox.radius",0.2);
	actor.setScale(float3(0.55,0.55,0.55));
	actor.setPos(float3(0,0,0));
	actor.show();
	actor.tempShow();
	actor.setMaster("tpose",0);
	DEACTIVE_TIMEOUT=0.0;
	DEACTIVE_TIMEOUT_FLOATING=0.0;
	dirnorm=float3(0,0,0);
	clearListeners(ON_TICK);
	clearListeners(ON_EVENT);	
	clearListeners(ON_TIMEOUT_FRAMES);
	clearListeners(ON_ENTITYENTER);
	clearListeners(ON_ENTITYLEAVE);	
}

void init(){
	//set entity tag
	debugLog("Loading trap: "+getTag());	
	res=Resource("levelsets/traps/banana.hvfs","cbResLoaded");	
}
void cbResLoaded() {
	actor = res.use("banana.actor","cbLoaded");
}
void cbLoaded() {
	bLoaded=1;
	defaults();
}
public void regEvents() {
	addListener(ON_EVENT,"TRAP","e_trap");
}
public string isLoaded() {
	return string(bLoaded);
}
public void reset() {
	debugLog("Reset "+getTag());
	defaults();
}
void e_trap(float _heading) {
	if (DEACTIVE_TIMEOUT>0.0) { return; }
	dirnorm=float3(0,0,-1);
	dirnorm.roth(_heading);
	DEACTIVE_TIMEOUT=24*getFPS();
	DEACTIVE_TIMEOUT_FLOATING=-4.0;
	actor.setMaster("fly",0);
	addListener(ON_TICK,"tick");
}
public void savestate() {
	appPropertySet(APPNAME,getTag()+"_TIMEOUT",string(DEACTIVE_TIMEOUT));
	appPropertySet(APPNAME,getTag()+"_FLOATING",string(DEACTIVE_TIMEOUT_FLOATING));
	appPropertySet(APPNAME,getTag()+"_DIRNORM",string(dirnorm));
}
public void loadstate() {
	DEACTIVE_TIMEOUT=float(appPropertyGet(APPNAME,getTag()+"_TIMEOUT",string(DEACTIVE_TIMEOUT)));
	DEACTIVE_TIMEOUT_FLOATING=float(appPropertyGet(APPNAME,getTag()+"_FLOATING",string(DEACTIVE_TIMEOUT_FLOATING)));
	dirnorm=float3(appPropertyGet(APPNAME,getTag()+"_DIRNORM",string(dirnorm)));
	if (DEACTIVE_TIMEOUT>0.0) {
		actor.setMaster("fly",0);
		addListener(ON_TICK,"tick");
	}
}
public string isActive() {
	return string(DEACTIVE_TIMEOUT<=0.0);
}
void tick() {
	DEACTIVE_TIMEOUT-=fElapsed();
	DEACTIVE_TIMEOUT_FLOATING+=fElapsed();
	if (DEACTIVE_TIMEOUT<=0.0) {
		clearListeners(ON_TICK);
		actor.setPos(float3(0,0,0));
		actor.tempShow();
		actor.setMaster("reset",0);
		return;
	}
	if (DEACTIVE_TIMEOUT_FLOATING<30.0) {
		actor.setPos( (dirnorm*(max(0.0,DEACTIVE_TIMEOUT_FLOATING))*0.8));
	}
	else {
		actor.setPos(float3(0,0,0));
		actor.tempHide();
	}
}
