 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib game
#hive 1
String APPNAME = "bunnymaze";
Resource res;
vfile actor;
int bLoaded=0;
int bActive;

void defaults() {
	bActive=1;
	actor.setScale(float3(0.6,0.6,0.6));
	actor.setRot(hpr(float(rand(360)),0.0,0.0));
	actor.show();
	clearListeners(ON_TICK);
	clearListeners(ON_TIMEOUT_FRAMES);
	clearListeners(ON_ENTITYENTER);
	clearListeners(ON_ENTITYLEAVE);
}

void init()
{
	//set entity tag
	debugLog("Loading trap: "+getTag());
	this.setChannel("prox.radius",1.5);
	
	res=Resource("levelsets/traps/skull.hvfs","cbResLoaded");	
}
void cbResLoaded() {
	actor = res.use("skull","reset");
} 
public void reset() {
	if (bLoaded) {
		debugLog("Reset "+getTag());
	}
	else {
		bLoaded=1;
		debugLog(getTag()+" loaded");
	}
	defaults();
}
public void regEvents() {
	addListener(ON_EVENT,"TRAP","e_trap");
}
public string isLoaded() {
	return string(bLoaded);
}
void e_trap(float _heading) {
	if (!actor.isVisible()) return;
	bActive=0;
	actor.hide();
	clearListeners(ON_TICK);
	addListener(ON_TIMEOUT_FRAMES,string(12*getFPS()),"cbReveal");
}
void cbReveal() {
	actor.show();
	actor.setScale(float3(0,0,0));
	addListener(ON_TICK,"tick");
}
public void savestate() {
	appPropertySet(APPNAME,getTag()+"_ACTIVE",string(actor.isVisible()));
}
public void loadstate() {
	if (!int(appPropertyGet(APPNAME,getTag()+"_ACTIVE",string(actor.isVisible())))) {
		actor.hide();
		clearListeners(ON_TICK);
		addListener(ON_TIMEOUT_FRAMES,string(6*getFPS()),"cbReveal");
	}
}
public string isActive() {
	return string(bActive);
}
void tick() {
	float scale=actor.getScale().x();
	if (scale<0.6) {
		scale=min(0.6,scale+fElapsed()*0.05);
		actor.setScale(float3(scale,scale,scale));
	}
	else {
		clearListeners(ON_TICK);
		bActive=1;
	}
}
