 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib gui
#hive 1

Layout HUD;
Widget RICHEDIT;

//grid size
int GRID_SIZE,GRID_DIFFICULTY;

int CONST_TILE_STRAIGHT=0;
int CONST_TILE_CORNER=1;
int CONST_TILE_CROSS=2;
int CONST_TILE_T=3;
int CONST_TILE_DEADEND=4;
int CONST_TILE_TOTAL=5;

//trap ids
int CONST_PU_CLOCK=1;
int CONST_PU_SHOES=2;
int CONST_PU_POTION=3;
int CONST_PU_ROCK=4;
int CONST_PU_CHEST=5;
int CONST_TRAP_BANANA=6;
int CONST_TRAP_GOPHER=7;
int CONST_TRAP_SKULL=8;

int CONST_TILETRAP_NONE=0;
int CONST_TILETRAP_POND=1;
int CONST_TILETRAP_LOG=2;
int CONST_TILETRAP_QUICKSAND=3;
int CONST_TILETRAP_SIGN=4;
int CONST_TILETRAP_PIER=5;
int CONST_TILETRAP_LIGHTHOUSE=6;
int CONST_TILETRAP_CRACK=7;
int CONST_TILETRAP_PENGUINSIT=8;
int CONST_TILETRAP_SNOWSPOT=9;
int CONST_TILETRAP_BRIDGE=10;
int CONST_TILETRAP_DUCK=11;
int CONST_TILETRAP_FAUCET=12;
int CONST_TILETRAP_HILL=13;
int CONST_TILETRAP_JBRIDGE=14;
int CONST_TILETRAP_JTRUNK=15;

listi getCollectibles(string _theme,int _level) {
	listi t=listi();
	int i;
	listi l_clocks=listi();
	listi l_shoes=listi();
	listi l_potions=listi();
	listi l_rocks=listi();	
	listi l_chest=listi();
	listi l_gophers=listi();
	listi l_bananas=listi();
	listi l_skull=listi();
	if (_theme=="forest") {
		l_clocks.push(0);//1
		l_clocks.push(0);//2
		l_clocks.push(3);//3
		l_clocks.push(1);//4
		l_clocks.push(1);//5
		l_clocks.push(1);//6
		l_clocks.push(1);//7
		l_clocks.push(2);//8
		l_clocks.push(2);//9
		l_clocks.push(2);//10
		l_clocks.push(3);//11
		l_clocks.push(3);//12
		l_clocks.push(3);//13
		l_clocks.push(4);//14
		l_clocks.push(4);//15
		l_clocks.push(5);//16
		l_clocks.push(6);//17
		l_clocks.push(6);//18
		l_clocks.push(7);//19
		l_clocks.push(7);//20
		l_clocks.push(8);//21
		
		l_shoes.push(0);//1
		l_shoes.push(0);//2
		l_shoes.push(0);//3
		l_shoes.push(0);
		l_shoes.push(0);//5
		l_shoes.push(0);
		l_shoes.push(0);//7
		l_shoes.push(1);//8
		l_shoes.push(0);//9
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		
		l_potions.push(0);
		l_potions.push(0);
		l_potions.push(0);
		l_potions.push(0);
		l_potions.push(0);
		l_potions.push(0);
		l_potions.push(2);//7
		l_potions.push(0);//8
		l_potions.push(0);//9
		l_potions.push(0);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		
		l_rocks.push(0);
		l_rocks.push(0);
		l_rocks.push(0);
		l_rocks.push(0);
		l_rocks.push(0);
		l_rocks.push(0);
		l_rocks.push(0);//7
		l_rocks.push(0);//8
		l_rocks.push(1);//9
		l_rocks.push(1);
		l_rocks.push(1);
		l_rocks.push(1);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(2);
		
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(1);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(0);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(3);
		
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(0);
		l_bananas.push(2);
		l_bananas.push(2);
		l_bananas.push(3);
		l_bananas.push(3);
		
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);		
		
		
	}
	else if (_theme=="docks") {
		l_clocks.push(2);
		l_clocks.push(2);
		l_clocks.push(2);
		l_clocks.push(3);
		l_clocks.push(3);
		l_clocks.push(3);
		l_clocks.push(3);
		l_clocks.push(3);
		l_clocks.push(4);
		l_clocks.push(5);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(7);
		l_clocks.push(8);
		l_clocks.push(8);
		l_clocks.push(10);
		l_clocks.push(10);
	
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(2);//10
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(3);
		l_shoes.push(3);
	
		l_potions.push(0);
		l_potions.push(0);
		l_potions.push(0);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(3);
		l_potions.push(3);

		l_rocks.push(1);
		l_rocks.push(1);
		l_rocks.push(1);
		l_rocks.push(1);
		l_rocks.push(1);
		l_rocks.push(1);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(2);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);
		l_gophers.push(0);		
		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(1);		
		l_bananas.push(1);		
		l_bananas.push(2);		
		l_bananas.push(2);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(2);		
		l_bananas.push(2);		
		l_bananas.push(3);		
		l_bananas.push(3);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(2);		
		l_bananas.push(2);		
		l_bananas.push(3);		
		l_bananas.push(3);	
		
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);		
		
	}
	else if (_theme=="desert") {
		l_clocks.push(2);
		l_clocks.push(3);
		l_clocks.push(3);
		l_clocks.push(3);
		l_clocks.push(4);
		l_clocks.push(5);
		l_clocks.push(6);
		l_clocks.push(5);
		l_clocks.push(5);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(7);
		l_clocks.push(7);
		l_clocks.push(7);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(7);
		l_clocks.push(8);
		l_clocks.push(9);
		l_clocks.push(9);
		l_clocks.push(9);
		
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(3);
		l_shoes.push(3);
		l_shoes.push(3);
		
		l_potions.push(0);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(2);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		
		l_rocks.push(1);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(2);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(2);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(2);
		l_chest.push(2);
		l_chest.push(2);
		
		l_gophers.push(0);
		l_gophers.push(1);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(0);
		l_gophers.push(2);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(0);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(4);		
		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(1);		
		l_bananas.push(2);		
		l_bananas.push(2);		
		l_bananas.push(2);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(2);		
		l_bananas.push(3);		
		l_bananas.push(3);		
		l_bananas.push(4);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(2);		
		l_bananas.push(3);		
		l_bananas.push(3);		
		l_bananas.push(4);		
		
		l_skull.push(0);		
		l_skull.push(0);		
		l_skull.push(0);		
		l_skull.push(0);		
		l_skull.push(0);		
		l_skull.push(0);		
		l_skull.push(0);		
		l_skull.push(0);		
		l_skull.push(0);		
		l_skull.push(0);		
		l_skull.push(0);		
		l_skull.push(0);		
		l_skull.push(0);		
		l_skull.push(0);		
		l_skull.push(6);		
		l_skull.push(4);		
		l_skull.push(4);		
		l_skull.push(4);		
		l_skull.push(4);		
		l_skull.push(5);		
		l_skull.push(5);		
	}	
	else if (_theme=="snow") {
		l_clocks.push(3);
		l_clocks.push(3);
		l_clocks.push(4);
		l_clocks.push(4);
		l_clocks.push(5);
		l_clocks.push(5);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(7);
		l_clocks.push(7);
		l_clocks.push(8);
		l_clocks.push(8);
		l_clocks.push(9);
		l_clocks.push(7);
		l_clocks.push(7);
		l_clocks.push(8);
		l_clocks.push(8);
		l_clocks.push(9);
		l_clocks.push(9);
		l_clocks.push(11);
		
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(3);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(3);
		l_shoes.push(3);
		l_shoes.push(3);
		
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(3);
		l_potions.push(3);
		l_potions.push(3);
		
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(4);
		l_rocks.push(4);
		
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(2);
		l_chest.push(2);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		
		l_gophers.push(0);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(0);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(0);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(3);		
		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(2);		
		l_bananas.push(2);		
		l_bananas.push(3);		
		l_bananas.push(3);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(3);		
		l_bananas.push(3);		
		l_bananas.push(4);		
		l_bananas.push(4);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(3);		
		l_bananas.push(3);		
		l_bananas.push(4);		
		l_bananas.push(4);		
		
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);		
	}	
	else if (_theme=="city") {	
		l_clocks.push(3);
		l_clocks.push(3);
		l_clocks.push(4);
		l_clocks.push(5);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(7);
		l_clocks.push(7);
		l_clocks.push(7);
		l_clocks.push(7);
		l_clocks.push(7);
		l_clocks.push(8);
		l_clocks.push(8);
		l_clocks.push(8);
		l_clocks.push(8);
		l_clocks.push(9);
		l_clocks.push(9);
		l_clocks.push(11);
		
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(3);
		l_shoes.push(3);
		
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(3);
		l_potions.push(3);
		
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(3);
		l_rocks.push(2);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(4);
		
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(2);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		
		l_gophers.push(0);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(0);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(4);
		l_gophers.push(4);
		l_gophers.push(4);
		l_gophers.push(0);
		l_gophers.push(4);
		l_gophers.push(4);
		l_gophers.push(4);
		l_gophers.push(5);
		l_gophers.push(5);
		l_gophers.push(5);		
		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(2);		
		l_bananas.push(2);		
		l_bananas.push(3);		
		l_bananas.push(3);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(3);		
		l_bananas.push(3);		
		l_bananas.push(4);		
		l_bananas.push(4);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(4);		
		l_bananas.push(4);		
		l_bananas.push(5);		
		l_bananas.push(5);		
		
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);		
	} 
	else if (_theme=="jungle") {
		l_clocks.push(3);
		l_clocks.push(3);
		l_clocks.push(4);
		l_clocks.push(5);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(6);
		l_clocks.push(7);
		l_clocks.push(7);
		l_clocks.push(7);
		l_clocks.push(7);
		l_clocks.push(7);
		l_clocks.push(8);
		l_clocks.push(8);
		l_clocks.push(8);
		l_clocks.push(9);
		l_clocks.push(9);
		l_clocks.push(10);
		l_clocks.push(10);
		l_clocks.push(11);
		
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(1);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(3);
		l_shoes.push(3);
		l_shoes.push(3);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(2);
		l_shoes.push(3);
		l_shoes.push(3);
		l_shoes.push(4);
		l_shoes.push(4);
		
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(1);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(2);
		l_potions.push(3);
		l_potions.push(3);
		
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(2);
		l_rocks.push(3);
		l_rocks.push(2);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(3);
		l_rocks.push(4);
		
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(2);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(1);
		l_chest.push(0);
		l_chest.push(1);
		l_chest.push(1);
		
		l_gophers.push(0);
		l_gophers.push(1);
		l_gophers.push(1);
		l_gophers.push(1);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(0);
		l_gophers.push(1);
		l_gophers.push(1);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(0);
		l_gophers.push(2);
		l_gophers.push(2);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(3);
		l_gophers.push(3);		
		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(1);		
		l_bananas.push(1);		
		l_bananas.push(2);		
		l_bananas.push(2);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(2);		
		l_bananas.push(2);		
		l_bananas.push(3);		
		l_bananas.push(3);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(0);		
		l_bananas.push(3);		
		l_bananas.push(3);		
		l_bananas.push(3);		
		l_bananas.push(3);		
		
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);
		l_skull.push(0);		
	}
	
	
	
	
	for (i=0;i<l_clocks.get(_level-1);i++) t.push(CONST_PU_CLOCK);
	for (i=0;i<l_shoes.get(_level-1);i++) t.push(CONST_PU_SHOES);
	for (i=0;i<l_potions.get(_level-1);i++) t.push(CONST_PU_POTION);
	for (i=0;i<l_chest.get(_level-1);i++) t.push(CONST_PU_CHEST);
	for (i=0;i<l_rocks.get(_level-1);i++) t.push(CONST_PU_ROCK);
	for (i=0;i<l_gophers.get(_level-1);i++) t.push(CONST_TRAP_GOPHER);
	for (i=0;i<l_bananas.get(_level-1);i++) t.push(CONST_TRAP_BANANA);
	for (i=0;i<l_skull.get(_level-1);i++) t.push(CONST_TRAP_SKULL);
	
	return t;
}
listi getThemeTraps(string _theme,int _level) {
	listi t=listi();
	int i,l_pond=0,l_log=0,l_pier=0,l_sign=0,l_lighthouse=0,l_sand=0,l_crack=0,l_penguinsit=0,l_snowspot=0,l_bridge=0,l_duck=0,l_faucet=0,l_hill=0,l_jbridge=0, l_jtrunk=0;
	if (_theme=="forest") {
		if (_level==1) {
		}
		else if (_level==2) {
		}
		else if (_level==3) {
		}
		else if (_level==4) {
			l_pond=4;
		}
		else if (_level==5) {
		}
		else if (_level==6) {
		}
		else if (_level==7) {
		}
		else if (_level==8) {
		}
		else if (_level==9) {
			l_pond=1;
		}
		else if (_level==10) {
			l_pond=3;
		}
		else if (_level==11) {
			l_pond=3;
		}
		else if (_level==12) {
			l_pond=4;
		}
		else if (_level==13) {
			l_pond=4;
		}
		else if (_level==14) {
			l_pond=4;
		}
		else if (_level==15) {
			l_pond=5;
			l_log=1;
		}
		else if (_level==16) {
			l_pond=5;
			l_log=2;
		}
		else if (_level==17) {
			l_pond=5;
			l_log=2;
		}
		else if (_level==18) {
			l_pond=5;
			l_log=2;
		}
		else if (_level==19) {
			l_pond=6;
			l_log=3;
		}
		else if (_level==20) {
			l_pond=6;
			l_log=3;
		}
		else if (_level==21) {
			l_pond=6;
			l_log=4;
		}		
	}
	else if (_theme=="docks") {
		if (_level==1) {
		}
		else if (_level==2) {
			l_lighthouse=2;
		}
		else if (_level==3) {
			l_lighthouse=2;
		}
		else if (_level==4) {
			l_lighthouse=1;		
		}
		else if (_level==5) {
			l_lighthouse=1;
		}
		else if (_level==6) {
			l_lighthouse=2;
		}
		else if (_level==7) {
			l_lighthouse=2;
		}
		else if (_level==8) {
			l_pier=2;
		}
		else if (_level==9) {
			l_pier=2;
		}
		else if (_level==10) {
			l_pier=2;
		}
		else if (_level==11) {
			l_lighthouse=1;
			l_pier=2;
		}
		else if (_level==12) {
			l_lighthouse=1;
			l_pier=3;
		}
		else if (_level==13) {
			l_lighthouse=2;
			l_pier=3;
		}
		else if (_level==14) {
			l_lighthouse=2;
			l_pier=3;
		}
		else if (_level==15) {
			l_pier=3;
			l_sign=6;
		}
		else if (_level==16) {
			l_lighthouse=1;
			l_pier=4;
			l_sign=4;
		}
		else if (_level==17) {
			l_lighthouse=1;
			l_pier=4;
			l_sign=4;
		}
		else if (_level==18) {
			l_lighthouse=2;
			l_pier=4;
			l_sign=5;
		}
		else if (_level==19) {
			l_lighthouse=2;
			l_pier=5;
			l_sign=5;
		}
		else if (_level==20) {
			l_lighthouse=3;
			l_pier=5;
			l_sign=6;
		}
		else if (_level==21) {
			l_lighthouse=4;
			l_pier=5;
			l_sign=6;
		}			
	}
	else if (_theme=="desert") {
		if (_level==1) {
		}
		else if (_level==2) {
		}
		else if (_level==3) {
		}
		else if (_level==4) {
		}
		else if (_level==5) {
		}
		else if (_level==6) {
		}
		else if (_level==7) {
		}
		else if (_level==8) {
			l_sand=3;
		}
		else if (_level==9) {
			l_sand=3;
		}
		else if (_level==10) {
			l_sand=3;
		}
		else if (_level==11) {
			l_sand=3;
		}
		else if (_level==12) {
			l_sand=3;
		}
		else if (_level==13) {
			l_sand=4;
		}
		else if (_level==14) {
			l_sand=4;
		}
		else if (_level==15) {
			l_sand=5;
		}
		else if (_level==16) {
			l_sand=5;
		}
		else if (_level==17) {
			l_sand=6;
		}
		else if (_level==18) {
			l_sand=6;
		}
		else if (_level==19) {
			l_sand=7;
		}
		else if (_level==20) {
			l_sand=8;
		}
		else if (_level==21) {
			l_sand=8;
		}			
	}	
	else if (_theme=="snow") {
		if (_level==1) {
			l_penguinsit=1;
		}
		else if (_level==2) {
			l_penguinsit=2;
		}
		else if (_level==3) {
			l_penguinsit=2;
		}
		else if (_level==4) {
			l_penguinsit=1;
		}
		else if (_level==5) {
			l_penguinsit=1;
			l_snowspot=1;
		}
		else if (_level==6) {
			l_snowspot=1;
		}
		else if (_level==7) {
			l_snowspot=2;
		}
		else if (_level==8) {
			l_snowspot=2;
			l_penguinsit=3;
		}
		else if (_level==9) {
			l_penguinsit=1;
			l_snowspot=3;			
		}
		else if (_level==10) {
			l_penguinsit=1;
			l_snowspot=3;			
		}
		else if (_level==11) {
			l_penguinsit=1;
			l_snowspot=4;			
		}
		else if (_level==12) {
			l_penguinsit=1;
			l_snowspot=4;			
		}
		else if (_level==13) {
			l_snowspot=5;
		}
		else if (_level==14) {
			l_snowspot=5;		
		}
		else if (_level==15) {
			l_crack=10;
			l_penguinsit=2;
			l_snowspot=3;			
		}
		else if (_level==16) {
			l_crack=4;
			l_snowspot=4;
			l_penguinsit=2;
		}
		else if (_level==17) {
			l_crack=5;
			l_snowspot=5;
			l_penguinsit=2;			
		}
		else if (_level==18) {
			l_crack=5;
			l_penguinsit=1;
			l_snowspot=6;
		}
		else if (_level==19) {
			l_crack=6;
			l_penguinsit=1;
			l_snowspot=6;			
		}
		else if (_level==20) {
			l_crack=6;
			l_penguinsit=2;
			l_snowspot=8;			
		}
		else if (_level==21) {
			l_crack=8;
			l_penguinsit=4;
			l_snowspot=10;			
		}			
	}
	else if (_theme=="jungle") {
		if (_level==1) {
		}
		else if (_level==2) {
		}
		else if (_level==3) {
		}
		else if (_level==4) {
		}
		else if (_level==5) {
		}
		else if (_level==6) {
		}
		else if (_level==7) {
		}
		else if (_level==8) {
			l_jtrunk=7;
		}
		else if (_level==9) {
			l_jtrunk=4;
		}
		else if (_level==10) {
			l_jtrunk=5;
		}
		else if (_level==11) {
			l_jtrunk=6;		
		}
		else if (_level==12) {
			l_jtrunk=7;
		}
		else if (_level==13) {
			l_jtrunk=8;
		}
		else if (_level==14) {
			l_jtrunk=8;
		}
		else if (_level==15) {
			l_jbridge=8;
		}
		else if (_level==16) {
			l_jtrunk=1;
			l_jbridge=6;
		}
		else if (_level==17) {
			l_jtrunk=3;
			l_jbridge=4;
		}
		else if (_level==18) {
			l_jtrunk=4;
			l_jbridge=6;
		}
		else if (_level==19) {
			l_jtrunk=5;
			l_jbridge=7;
		}
		else if (_level==20) {
			l_jtrunk=6;
			l_jbridge=7;
		}
		else if (_level==21) {
			l_jtrunk=6;
			l_jbridge=10;
		}			
	}	
		
	for (i=0;i<l_pond;i++) t.push(CONST_TILETRAP_POND);
	for (i=0;i<l_log;i++) t.push(CONST_TILETRAP_LOG);
	for (i=0;i<l_pier;i++) t.push(CONST_TILETRAP_PIER);
	for (i=0;i<l_sign;i++) t.push(CONST_TILETRAP_SIGN);
	for (i=0;i<l_lighthouse;i++) t.push(CONST_TILETRAP_LIGHTHOUSE);
	for (i=0;i<l_sand;i++) t.push(CONST_TILETRAP_QUICKSAND);
	for (i=0;i<l_crack;i++) t.push(CONST_TILETRAP_CRACK);
	for (i=0;i<l_penguinsit;i++) t.push(CONST_TILETRAP_PENGUINSIT);
	for (i=0;i<l_snowspot;i++) t.push(CONST_TILETRAP_SNOWSPOT);
	for (i=0;i<l_bridge;i++) t.push(CONST_TILETRAP_BRIDGE);
	for (i=0;i<l_duck;i++) t.push(CONST_TILETRAP_DUCK);
	for (i=0;i<l_faucet;i++) t.push(CONST_TILETRAP_FAUCET);
	for (i=0;i<l_hill;i++) t.push(CONST_TILETRAP_HILL);
	for (i=0;i<l_jbridge;i++) t.push(CONST_TILETRAP_JBRIDGE);
	for (i=0;i<l_jtrunk;i++) t.push(CONST_TILETRAP_JTRUNK);
	
	return t;
}
int findUnvisitedNeighbor(listf2 MAZE,float2 _cell) {
	listi ret=listi();
	int num = int(_cell.y) + int(_cell.x)*GRID_SIZE;
	if (_cell.x != 0) { if ( MAZE.get(num-GRID_SIZE).x() == 0) ret.push(num-GRID_SIZE); } //up unvisited
	if (_cell.x != GRID_SIZE-1) { if (MAZE.get(num+GRID_SIZE).x() == 0) ret.push(num+GRID_SIZE); } //down unvisited
	if (_cell.y != 0) { if (MAZE.get(num-1).x() == 0) ret.push(num-1); } //left unvisited
	if (_cell.y != GRID_SIZE-1) { if (MAZE.get(num+1).x() == 0) ret.push(num+1); } //right unvisited

	int fin = -1;
	if (ret.num() != 0) { fin = ret.get(rand(ret.num())); }

	return fin;
}
void breakRandomWall(listf2 MAZE,int _num, int _dir) {
	float2 my_cell = MAZE.get(_num);
	int my_walls = int(my_cell.y);
	if (my_walls == 0) { return; }
	int nb_num;

	if (_dir == 0) nb_num = _num+1; //right
	else if (_dir == 1) nb_num = _num-1; //left
	else if (_dir == 2) nb_num = _num+GRID_SIZE; //down
	else if (_dir == 3) nb_num = _num-GRID_SIZE; //up
	else { return; }

	float2 nb_cell = MAZE.get(nb_num);
	int nb_walls = int(nb_cell.y);
	if (nb_walls == 0) { return; }

	if (_dir == 0) //right
	{
		bitunset(my_walls,0);
		my_cell.y(float(my_walls));
		MAZE.set(_num,my_cell);
		bitunset(nb_walls,1);
		nb_cell.y(float(nb_walls));
		MAZE.set(nb_num,nb_cell);
	}
	else if (_dir == 1) //left
	{
		bitunset(my_walls,1);
		my_cell.y(float(my_walls));
		MAZE.set(_num,my_cell);
		bitunset(nb_walls,0);
		nb_cell.y(float(nb_walls));
		MAZE.set(nb_num,nb_cell);
	}
	else if (_dir == 2) //down
	{
		bitunset(my_walls,2);
		my_cell.y(float(my_walls));
		MAZE.set(_num,my_cell);
		bitunset(nb_walls,3);
		nb_cell.y(float(nb_walls));
		MAZE.set(nb_num,nb_cell);
	}
	else if (_dir == 3) //up
	{
		bitunset(my_walls,3);
		my_cell.y(float(my_walls));
		MAZE.set(_num,my_cell);
		bitunset(nb_walls,2);
		nb_cell.y(float(nb_walls));
		MAZE.set(nb_num,nb_cell);
	}
}
void randomLabyrinth(string _theme,int _level,listf4 TILE_TYPES) {
	TILE_TYPES.clear();

	//initiate random seed
	srand(_level);	
	
	if (_theme=="forest") {
		if ((_level==4)) srand(_level+100);
	}
	if (_theme=="docks") {
		if ((_level==17) || (_level==19)) srand(_level+100);
	}
	if (_theme=="desert") {
		if ((_level==9) || (_level==16) || (_level==18)) srand(_level+100);
	}
	if (_theme=="snow") {
		srand(_level+879);	
	}
	if (_theme=="city") {
		srand(_level+1452);	
	}
	
	listf2 MAZE=listf2(); 
	listf2 stack=listf2(); //x,y
	int total = GRID_SIZE*GRID_SIZE;

	int x=0;
	int y=0;
	for (x=0; x<GRID_SIZE; x++) {
		for (y=0; y<GRID_SIZE; y++) {
			float2 cell = float2(0,15); //unvisited,all walls up!
			MAZE.push(cell);
		}
	}

	int start_x = rand(GRID_SIZE);
	int start_y = rand(GRID_SIZE);
	float2 currentCell = float2(start_x,start_y);
	int num = start_y + start_x*GRID_SIZE;
	float2 tmp_cell = MAZE.get(num);
	tmp_cell.x(1.0); //just visited!
	MAZE.set(num,tmp_cell);
	int visited = 1;

	while (visited < total)	{
		int cur_num = int(currentCell.y) + int(currentCell.x)*GRID_SIZE;
		int nb_num = findUnvisitedNeighbor(MAZE,currentCell);
		//found!
		if (nb_num != -1) { 
			float2 cur_cell = MAZE.get(cur_num);
			float2 nb_cell = MAZE.get(nb_num);
			int dir = (nb_num-cur_num);
			//right
			if (dir == 1) {
				int cur_walls = int(cur_cell.y);
				bitunset(cur_walls,0);
				cur_cell.y(float(cur_walls));
				MAZE.set(cur_num,cur_cell);
				int nb_walls = int(nb_cell.y);
				bitunset(nb_walls,1);
				nb_cell.y(float(nb_walls));
				nb_cell.x(1.0); //just visited!
				MAZE.set(nb_num,nb_cell);
				stack.push(currentCell);
				currentCell.y(currentCell.y+1.0);
			}
			//left
			else if (dir == -1) {
				int cur_walls = int(cur_cell.y);
				bitunset(cur_walls,1);
				cur_cell.y(float(cur_walls));
				MAZE.set(cur_num,cur_cell);
				int nb_walls = int(nb_cell.y);
				bitunset(nb_walls,0);
				nb_cell.y(float(nb_walls));
				nb_cell.x(1.0); //just visited!
				MAZE.set(nb_num,nb_cell);
				stack.push(currentCell);
				currentCell.y(currentCell.y-1.0);
			}
			//down
			else if (dir == GRID_SIZE) {
				int cur_walls = int(cur_cell.y);
				bitunset(cur_walls,2);
				cur_cell.y(float(cur_walls));
				MAZE.set(cur_num,cur_cell);
				int nb_walls = int(nb_cell.y);
				bitunset(nb_walls,3);
				nb_cell.y(float(nb_walls));
				nb_cell.x(1.0); //just visited!
				MAZE.set(nb_num,nb_cell);
				stack.push(currentCell);
				currentCell.x(currentCell.x+1.0);
			}
			//up
			else if (dir == ((-1)*GRID_SIZE)) {
				int cur_walls = int(cur_cell.y);
				bitunset(cur_walls,3);
				cur_cell.y(float(cur_walls));
				MAZE.set(cur_num,cur_cell);
				int nb_walls = int(nb_cell.y);
				bitunset(nb_walls,2);
				nb_cell.y(float(nb_walls));
				nb_cell.x(1.0); //just visited!
				MAZE.set(nb_num,nb_cell);
				stack.push(currentCell);
				currentCell.x(currentCell.x-1.0);
			}
			visited++;
		}
		//backtrack!
		else {
			stack.pop(currentCell);
		}
	}
	//break extra walls!
	for (x=1; x<GRID_SIZE-1; x++) {
		for (y=1; y<GRID_SIZE-1; y++) {
			breakRandomWall(MAZE,x*GRID_SIZE + y,rand(4));
		}
	}

	listi tiles_straight=listi();
	listi tiles_cross=listi();
	listi tiles_t=listi();
	listi tiles_corner=listi();

	int max_cross2 = 2;
	for (x=0; x<GRID_SIZE; x++) {
		for (y=0; y<GRID_SIZE; y++) {
			float2 c = MAZE.get(x*GRID_SIZE + y);
			if (c.y == 0) 		{ TILE_TYPES.push(float4(CONST_TILE_CROSS,0,CONST_TILETRAP_NONE,0));  tiles_cross.push(TILE_TYPES.num()-1);	}
			else if (c.y == 1) 	{ TILE_TYPES.push(float4(CONST_TILE_T,270,CONST_TILETRAP_NONE,0)); tiles_t.push(TILE_TYPES.num()-1); }
			else if (c.y == 2) 	{ TILE_TYPES.push(float4(CONST_TILE_T,90,CONST_TILETRAP_NONE,0)); tiles_t.push(TILE_TYPES.num()-1); }
			else if (c.y == 3) 	{ TILE_TYPES.push(float4(CONST_TILE_STRAIGHT,90,CONST_TILETRAP_NONE,0)); tiles_straight.push(TILE_TYPES.num()-1); }
			else if (c.y == 4) 	{ TILE_TYPES.push(float4(CONST_TILE_T,180,CONST_TILETRAP_NONE,0)); tiles_t.push(TILE_TYPES.num()-1); }
			else if (c.y == 5) 	{ TILE_TYPES.push(float4(CONST_TILE_CORNER,180,CONST_TILETRAP_NONE,0)); tiles_corner.push(TILE_TYPES.num()-1); }
			else if (c.y == 6) 	{ TILE_TYPES.push(float4(CONST_TILE_CORNER,90,CONST_TILETRAP_NONE,0)); tiles_corner.push(TILE_TYPES.num()-1); }
			else if (c.y == 7) 	{ TILE_TYPES.push(float4(CONST_TILE_DEADEND,90,CONST_TILETRAP_NONE,0)); }
			else if (c.y == 8) 	{ TILE_TYPES.push(float4(CONST_TILE_T,0,CONST_TILETRAP_NONE,0)); tiles_t.push(TILE_TYPES.num()-1); }
			else if (c.y == 9) 	{ TILE_TYPES.push(float4(CONST_TILE_CORNER,270,CONST_TILETRAP_NONE,0)); tiles_corner.push(TILE_TYPES.num()-1); }
			else if (c.y == 10) { TILE_TYPES.push(float4(CONST_TILE_CORNER,0,CONST_TILETRAP_NONE,0)); tiles_corner.push(TILE_TYPES.num()-1); }
			else if (c.y == 11) { TILE_TYPES.push(float4(CONST_TILE_DEADEND,270,CONST_TILETRAP_NONE,0)); }
			else if (c.y == 12) { TILE_TYPES.push(float4(CONST_TILE_STRAIGHT,0,CONST_TILETRAP_NONE,0));  tiles_straight.push(TILE_TYPES.num()-1); }
			else if (c.y == 13) { TILE_TYPES.push(float4(CONST_TILE_DEADEND,180,CONST_TILETRAP_NONE,0)); }
			else if (c.y == 14) { TILE_TYPES.push(float4(CONST_TILE_DEADEND,0,CONST_TILETRAP_NONE,0)); }
			else errLog("unknown tile");
		}
	}
	
	listi tiletraps=getThemeTraps(_theme,_level);
	tiletraps.shuffle();tiletraps.shuffle();tiletraps.shuffle();
	if (tiletraps.num()>0) {
		tiles_straight.shuffle();tiles_straight.shuffle();tiles_straight.shuffle();
		tiles_cross.shuffle();tiles_cross.shuffle();tiles_cross.shuffle();
		tiles_t.shuffle();tiles_t.shuffle();tiles_t.shuffle();
		tiles_corner.shuffle();tiles_corner.shuffle();tiles_corner.shuffle();
		int type,i;
		float4 val;
		for (i=0;i<tiletraps.num();i++) {
			type=tiletraps.get(i);
			if (type==CONST_TILETRAP_POND) {
				if (tiles_straight.num()) {
					val=TILE_TYPES.get( tiles_straight.get(0) );
					val.z( float(type) );
					TILE_TYPES.set( tiles_straight.get(0), val );
					tiles_straight.delIndex(0);
				}
			}
			else if (type==CONST_TILETRAP_LOG) {
				if (tiles_cross.num()) {
					val=TILE_TYPES.get( tiles_cross.get(0) );
					val.z( float(type) );
					TILE_TYPES.set( tiles_cross.get(0), val );
					tiles_cross.delIndex(0);
				}
			}
			else if (type==CONST_TILETRAP_LIGHTHOUSE) {
				if (tiles_cross.num()) {
					val=TILE_TYPES.get( tiles_cross.get(0) );
					val.z( float(type) );
					TILE_TYPES.set( tiles_cross.get(0), val );
					tiles_cross.delIndex(0);
				}
			}
			else if (type==CONST_TILETRAP_QUICKSAND) {
				if (tiles_straight.num()) {
					val=TILE_TYPES.get( tiles_straight.get(0) );
					val.z( float(type) );
					TILE_TYPES.set( tiles_straight.get(0), val );
					tiles_straight.delIndex(0);
				}
			}		
			else if (type==CONST_TILETRAP_CRACK) {
				if (tiles_straight.num()) {
					val=TILE_TYPES.get( tiles_straight.get(0) );
					val.z( float(type) );
					TILE_TYPES.set( tiles_straight.get(0), val );
					tiles_straight.delIndex(0);
				}
			}		
			else if (type==CONST_TILETRAP_SIGN) {
				if (tiles_t.num()) {
					val=TILE_TYPES.get( tiles_t.get(0) );
					val.z( float(type) );
					TILE_TYPES.set( tiles_t.get(0), val );
					tiles_t.delIndex(0);
				}
			}		
			else if (type==CONST_TILETRAP_PENGUINSIT) {
				if (tiles_t.num()) {
					val=TILE_TYPES.get( tiles_t.get(0) );
					val.z( float(type) );
					TILE_TYPES.set( tiles_t.get(0), val );
					tiles_t.delIndex(0);
				}
			}		
			else if (type==CONST_TILETRAP_PIER) {
				if (tiles_straight.num()) {
					val=TILE_TYPES.get( tiles_straight.get(0) );
					val.z( float(type) );
					TILE_TYPES.set( tiles_straight.get(0), val );
					tiles_straight.delIndex(0);
				}
			}	
			else if (type==CONST_TILETRAP_SNOWSPOT) {
				if (tiles_corner.num()) {
					val=TILE_TYPES.get( tiles_corner.get(0) );
					val.z( float(type) );
					TILE_TYPES.set( tiles_corner.get(0), val );
					tiles_corner.delIndex(0);
				}
			}
			else if (type==CONST_TILETRAP_BRIDGE) {
				if (tiles_cross.num()) {
					val=TILE_TYPES.get( tiles_cross.get(0) );
					val.z( float(type) );
					TILE_TYPES.set( tiles_cross.get(0), val );
					tiles_cross.delIndex(0);
				}
			}			
			else if (type==CONST_TILETRAP_DUCK) {
				if (tiles_straight.num()) {
					val=TILE_TYPES.get( tiles_straight.get(0) );
					val.z( float(type) );
					TILE_TYPES.set( tiles_straight.get(0), val );
					tiles_straight.delIndex(0);
				}
			}		
			else if (type==CONST_TILETRAP_HILL) {
				if (tiles_straight.num()) {
					val=TILE_TYPES.get( tiles_straight.get(0) );
					val.z( float(type) );
					TILE_TYPES.set( tiles_straight.get(0), val );
					tiles_straight.delIndex(0);
				}
			}	
			else if (type==CONST_TILETRAP_FAUCET) {
				if (tiles_t.num()) {
					val=TILE_TYPES.get( tiles_t.get(0) );
					val.z( float(type) );
					TILE_TYPES.set( tiles_t.get(0), val );
					tiles_t.delIndex(0);
				}
			}
			else if (type==CONST_TILETRAP_JBRIDGE) {
				if (tiles_t.num()) {
					val=TILE_TYPES.get( tiles_straight.get(0) );
					val.z( float(type) );
					TILE_TYPES.set( tiles_straight.get(0), val );
					tiles_straight.delIndex(0);
				}
			}	
			else if (type==CONST_TILETRAP_JTRUNK) {
				if (tiles_t.num()) {
					val=TILE_TYPES.get( tiles_straight.get(0) );
					val.z( float(type) );
					TILE_TYPES.set( tiles_straight.get(0), val );
					tiles_straight.delIndex(0);
				}
			}	
		}
	}
}


void init()  {
	setTag("bakery");

	HUD=Layout();
	HUD.show();
	
	Widget panel=Widget(HUD,UI_PANEL);
	panel.setSize("100%","100%");
	panel.setParam(PARAM_COLOR,"20,20,20,255");
	
	RICHEDIT=Widget(HUD,UI_RICHEDIT);
	RICHEDIT.setSize("90%","80%");
	RICHEDIT.setPos("5%","10%");
	RICHEDIT.setParam(PARAM_HIDEBACKGROUND,"1");
	
	int theme_total=6;
	
	Widget Button=Widget(HUD,UI_PUSHBUTTON);
	Button.setSize(string(100/theme_total)+"%","10%");
	Button.setPos(string((100/theme_total)*0)+"%","90%");
	Button.setParam(PARAM_TEXT,"Bake forest");
	Button.setParam(PARAM_ONCLICK,"cbForest");
	Button.setParam(PARAM_COLOR,"100,200,100,255");
	
	Button=Widget(HUD,UI_PUSHBUTTON);
	Button.setSize(string(100/theme_total)+"%","10%");
	Button.setPos(string((100/theme_total)*1)+"%","90%");
	Button.setParam(PARAM_TEXT,"Bake docks");
	Button.setParam(PARAM_ONCLICK,"cbDocks");
	Button.setParam(PARAM_COLOR,"150,150,200,255");

	Button=Widget(HUD,UI_PUSHBUTTON);
	Button.setSize(string(100/theme_total)+"%","10%");
	Button.setPos(string((100/theme_total)*2)+"%","90%");
	Button.setParam(PARAM_TEXT,"Bake desert");
	Button.setParam(PARAM_ONCLICK,"cbDesert");
	Button.setParam(PARAM_COLOR,"200,200,100,255");
	
	Button=Widget(HUD,UI_PUSHBUTTON);
	Button.setSize(string(100/theme_total)+"%","10%");
	Button.setPos(string((100/theme_total)*3)+"%","90%");
	Button.setParam(PARAM_TEXT,"Bake snow");
	Button.setParam(PARAM_ONCLICK,"cbSnow");
	Button.setParam(PARAM_COLOR,"255,255,255,255");
	
	Button=Widget(HUD,UI_PUSHBUTTON);
	Button.setSize(string(100/theme_total)+"%","10%");
	Button.setPos(string((100/theme_total)*4)+"%","90%");
	Button.setParam(PARAM_TEXT,"Bake city");
	Button.setParam(PARAM_ONCLICK,"cbCity");
	Button.setParam(PARAM_COLOR,"255,255,255,255");	
	
	Button=Widget(HUD,UI_PUSHBUTTON);
	Button.setSize(string(100/theme_total)+"%","10%");
	Button.setPos(string((100/theme_total)*5)+"%","90%");
	Button.setParam(PARAM_TEXT,"Bake jungle");
	Button.setParam(PARAM_ONCLICK,"cbJungle");
	Button.setParam(PARAM_COLOR,"200,255,200,255");	
}
void log(string _log) {
	errLog(_log);
	RICHEDIT.setParam(PARAM_ADDTEXT_STD,_log);
}
public string getLevel(string _theme,int _level) {
	listf4 TILE_TYPES=listf4();
	//get constants
	GRID_SIZE=[_theme+".levels"->getGridSize(_level) as int];
	GRID_DIFFICULTY=[_theme+".levels" -> getDifficulty(_level) as int];
	//create labyrinth with traps
	randomLabyrinth(_theme,_level,TILE_TYPES);
	//find collectibles and generic traps
	listi collectibles=getCollectibles(_theme,_level);
	//position collectibles and traps
	listi spawntiles=listi();		
	int i;
	for (i=0; i<TILE_TYPES.num(); i++) { 
		if (i!=(TILE_TYPES.num()-GRID_SIZE)) {
			float4 c = TILE_TYPES.get(i);
			if ( int(c.z())==CONST_TILETRAP_NONE && int(c.x())!=CONST_TILE_DEADEND ) spawntiles.push(i);
		}
	}
	collectibles.shuffle();collectibles.shuffle();
	for (i=0;i<collectibles.num();i++) {
		if (spawntiles.num()>0) {
			int found=0;			
			while(!found) {
				int tt=(rand(GRID_SIZE)*GRID_SIZE)+rand(GRID_SIZE);
				if (spawntiles.findIndex(tt)<spawntiles.num()) {
					float4 c=TILE_TYPES.get( spawntiles.get(spawntiles.findIndex(tt)) );
					c.w( float(collectibles.get(i)) );
					TILE_TYPES.set( spawntiles.get(spawntiles.findIndex(tt)), c );
					spawntiles.delIndex(spawntiles.findIndex(tt));
					found=1;
				}
			}
		}
	}
		
	string line;

	for (i=0; i<TILE_TYPES.num(); i++) {  
		float4 c = TILE_TYPES.get(i);
		int ttype=int(c.x()); 
		if (ttype==CONST_TILE_STRAIGHT) line+="I";
		else if (ttype==CONST_TILE_CORNER) line+="L";
		else if (ttype==CONST_TILE_CROSS) line+="X";
		else if (ttype==CONST_TILE_T) line+="T";
		else if (ttype==CONST_TILE_DEADEND) line+="D";
		else line+="U";
		line+=":"+string(int(c.y()))+":"; 
			
		//trap
		ttype=int(c.z()); 
		int generic_trap=int(c.w()); 			
		if (ttype==CONST_TILETRAP_POND) line+="POND;"; 
		else if (ttype==CONST_TILETRAP_LOG) line+="LOG;";
		else if (ttype==CONST_TILETRAP_QUICKSAND) line+="QSAND;";
		else if (ttype==CONST_TILETRAP_CRACK) line+="CRACK;";
		else if (ttype==CONST_TILETRAP_SIGN) line+="SIGN;";
		else if (ttype==CONST_TILETRAP_PENGUINSIT) line+="PENGUINSIT;";
		else if (ttype==CONST_TILETRAP_PIER) line+="PIER;";
		else if (ttype==CONST_TILETRAP_LIGHTHOUSE) line+="LHOUSE;";	
		else if (ttype==CONST_TILETRAP_SNOWSPOT) line+="SNOWSPOT;";		
		else if (ttype==CONST_TILETRAP_BRIDGE) line+="BRIDGE;";	
		else if (ttype==CONST_TILETRAP_DUCK) line+="DUCK;";	
		else if (ttype==CONST_TILETRAP_FAUCET) line+="FAUCET;";	
		else if (ttype==CONST_TILETRAP_HILL) line+="HILL;";	
		else if (ttype==CONST_TILETRAP_JBRIDGE) line+="JBRIDGE;";	
		else if (ttype==CONST_TILETRAP_JTRUNK) line+="JTRUNK;";	
		else if (generic_trap==CONST_PU_CLOCK) line+="CLOCK;";	
		else if (generic_trap==CONST_PU_SHOES) line+="SHOES;";	
		else if (generic_trap==CONST_PU_POTION) line+="POTION;";	
		else if (generic_trap==CONST_PU_ROCK) line+="ROCK;";	
		else if (generic_trap==CONST_PU_CHEST) line+="CHEST;";	
		else if (generic_trap==CONST_TRAP_BANANA) line+="BANANA;";	
		else if (generic_trap==CONST_TRAP_GOPHER) line+="GOPHER;";	
		else if (generic_trap==CONST_TRAP_SKULL) line+="SKULL;";	
		else line+="-;"; 
	}
	
	return line;
}
void bake(string _theme) {
	int LEVEL;
	for (LEVEL=1;LEVEL<=21;LEVEL++) {
		log("else if (_level=="+string(LEVEL)+") return \""+getLevel(_theme,LEVEL)+"\";");		
	}	
}
void cbForest() {
	log("");
	log("");
	log("Baking forest:");
	bake("forest");
	log("");
	log("");
}
void cbDocks() {
	log("");
	log("");
	log("Baking docks:");
	bake("docks");
	log("");
	log("");
}
void cbDesert() {
	log("");
	log("");
	log("Baking desert:");
	bake("desert");
	log("");
	log("");
}
void cbSnow() {
	log("");
	log("");
	log("Baking snow:");
	bake("snow");
	log("");
	log("");
}
void cbCity() {
	log("");
	log("");
	log("Baking city:");
	bake("city");
	log("");
	log("");
}

void cbJungle() {
	log("");
	log("");
	log("Baking Jungle:");
	bake("jungle");
	log("");
	log("");
}


