 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/
 
#using stdlib game

#hive 1

//if script is used for preloading
input int PRELOADER=0;

float speed = 0.8;

vfile rock;
Resource res;
float3 GOTO_POS;
float elapsed=0.0;
float jump_y=3.0;
float BASE_Y;

public void reset() {
	debugLog("Reset rock");
	elapsed=0.0;
	BASE_Y=2.33;
	jump_y=3.0;
	rock.hide();
	rock.setPos( float3(0,0.6,0) );
	clearListeners(ON_TICK);
}
void init()
{
	if (PRELOADER) {
		debugLog("Preloading Rock n Roll");
		setTag("dummy");
		res=Resource("levelsets/generic/rock.hvfs","");	
		return;
	}
	
	debugLog("Loading Rock n Roll");
	//set entity tag
	setTag("rock");
	this.setChannel("prox.radius",0.5);
	res=Resource("levelsets/generic/rock.hvfs","cbResLoaded");	
}
void cbResLoaded() {
	rock=res.use("rock.mesh","cbRockLoaded");
}
void cbRockLoaded() {
	addListener(ON_EVENT,"GOTO","e_goto");
	addListener(ON_ENTITYENTER,"e_enter");
	reset();
}
void e_goto(float3 _from,float3 _to) {
	this.setPos(_from);
	this.show();
	rock.show();
	addListener(ON_TICK,"tick");
	GOTO_POS=_to;
	GOTO_POS.y( 2.33 );
}
void tick() {
	float3 rot=rock.getRot();
	rot.x( normalizeAngle(rot.x()-fElapsed()*45.0) );
	rock.setRot(rot);
	
	float3 oldp=this.getPos();
	oldp.y( BASE_Y );
	if ( (oldp-GOTO_POS).xz().length() <= (fElapsed()*speed) ) {
		clearListeners(ON_TICK);
		this.hide();
		rock.hide();
		elapsed=0;
		jump_y=3;
		sendEvent("ROCK_OFF","ui.play");
	}
	else {
		elapsed+=fElapsed()*0.1;
		jump_y=MAX(0,jump_y-fElapsed()*0.05);
		this.setRot( oldp.lookat(GOTO_POS) );
		float3 norm=GOTO_POS-oldp;
		norm.normalize();
		this.setPos( oldp + (norm*(fElapsed()*speed)) +float3(0.0,abs(cos(elapsed))*jump_y,0.0) );
	}
}
void e_enter(string _tag) {
	if (!this.isVisible()) { return; }
	if (_tag.startsWithNoCase("penguinsit")) return;
	
	if (_tag.startsWithNoCase("enemy") || _tag.startsWithNoCase("hedgehog") || _tag.startsWithNoCase("gopher") || _tag.startsWithNoCase("penguin")) {
		if (![_tag->isHit() as int]) {
			if (_tag.startsWithNoCase("hedgehog")) sendEvent("FORCE_HIT",_tag);
			else sendEvent("HIT",_tag);
			sendEvent("ENEMY_ISROCKED","ui.play");
			["hero"->playHitSound(this.getPos().xz())];
		}
	}	
}
public int doValidateLog(string _tag) {
	return 1;
}
public void setBaseY(float _y) { BASE_Y=_y; }
public void setSpeedTrap(float _y) {  }
