 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib
#hive 1

String APPNAME = "bunnymaze";

//last loaded theme
string CURRENTTHEME;
//TILE positions
listf3 TILES_POS;
//TILE types
listi TILE_TYPES;
listi TILE_ROTS;
listi TILE_TRAPS;

//carrot & PU vfiles
listvf LISTVF_CARROTS,LISTVF_ENTITIES;
listvf LISTVF_DEADEND;
listf3 LISTPOS_ENTITIES;
//grid size
int GRID_SIZE,GRID_DIFFICULTY;
//current LEVEL number
int LEVEL;
//tile size
int CONST_TILESIZE=10;
//total carrots
int TOTAL_CARROTS=0;
//required time
int REQUIRED_TIME=0;
//current time
int CURRENT_TIME=0;
//current score
int CURRENT_SCORE=0;
//bonus items
int BONUS_JUMP,BONUS_PUP,BONUS_TIME;
int PU1_STACK,PU2_STACK,PU3_STACK;
int COUNTER_LOSE;
float TIMEOUT_PU1,TIMEOUT_PU2,TIMEOUT_PU3;
int PICK_SHOES,PICK_POTION,PICK_ROCK,PICK_CLOCK,PICK_CHEST;
int USE_SHOES,USE_POTION,USE_ROCK;
int EGG_JUMPS_INROW,EGG_CARROTS_INROW,EGG_SQUASH_INROW;

float CONST_PERC_STAR1 = 0.5; 
float CONST_PERC_STAR2 = 1.0;
float CONST_PERC_STAR3 = 1.5;

int CONST_TILE_STRAIGHT=0;
int CONST_TILE_CORNER=1;
int CONST_TILE_CROSS=2;
int CONST_TILE_T=3;
int CONST_TILE_DEADEND=4;
int CONST_TILE_TOTAL=5;

//event reply
string REPLY_TAG,REPLY_EVENT;

//trap ids if >100 then moving
int CONST_PU_CLOCK=101;
int CONST_PU_SHOES=102;
int CONST_PU_POTION=103;
int CONST_PU_ROCK=104;
int CONST_PU_CHEST=105;
int CONST_TRAP_BANANA=106;
int CONST_TRAP_GOPHER=107;
int CONST_TRAP_SKULL=108;

int CONST_TILETRAP_NONE=0;
int CONST_TILETRAP_POND=1;
int CONST_TILETRAP_LOG=2;
int CONST_TILETRAP_QUICKSAND=3;
int CONST_TILETRAP_SIGN=4;
int CONST_TILETRAP_PIER=5;
int CONST_TILETRAP_LIGHTHOUSE=6;
int CONST_TILETRAP_CRACK=7;
int CONST_TILETRAP_PENGUINSIT=8;
int CONST_TILETRAP_SNOWSPOT=9;
int CONST_TILETRAP_BRIDGE=10;
int CONST_TILETRAP_DUCK=11;
int CONST_TILETRAP_FAUCET=12;
int CONST_TILETRAP_HILL=13;
int CONST_TILETRAP_JBRIDGE=14;
int CONST_TILETRAP_JTRUNK=15;

listf3 CONST_CLUNNY_SPAWN,CONST_HEDGEHOG_SPAWN,CONST_PENGUIN_SPAWN;//X,Z,SPEED


/////////// INTERFACE WITH OTHER SCRIPTS ////////////

public int getRequiredTime() { return REQUIRED_TIME; }
public int getTotalCarrots() { return TOTAL_CARROTS; }
public int getRequiredCarrots() { return TOTAL_CARROTS*CONST_PERC_STAR1; }
public int getCurrentTime() { return CURRENT_TIME; }
public int getCurrentScore() { return CURRENT_SCORE; }
public int getBonusJump() { return BONUS_JUMP; }
public int getBonusPUP() { return BONUS_PUP; }
public int getBonusTime() { return BONUS_TIME; }
public int getStackPU1() { return PU1_STACK; }
public int getStackPU2() { return PU2_STACK; }
public int getStackPU3() { return PU3_STACK; }
public int getCounterLose() { return COUNTER_LOSE; }
public float getTimeoutPU1() { return TIMEOUT_PU1; }
public float getTimeoutPU2() { return TIMEOUT_PU2; }
public float getTimeoutPU3() { return TIMEOUT_PU3; }
public int getEggCarrotsInRow() { return EGG_CARROTS_INROW; }
public int getEggJumpsInRow() { return EGG_JUMPS_INROW; }
public int getEggSquashInRow() { return EGG_SQUASH_INROW; }

public int getLevel() { return LEVEL; }
public string getTheme() { return CURRENTTHEME; }

public void setCurrentScore(int _score) { CURRENT_SCORE=_score; }
public void setCurrentTime(int _sec) { CURRENT_TIME=_sec; }
public void setBonusJump(int _bonus) { BONUS_JUMP=_bonus; }
public void setBonusPUP(int _bonus) { BONUS_PUP=_bonus; }
public void setBonusTime(int _bonus) { BONUS_TIME=_bonus; }
public void setStackPU1(int _stack) { PU1_STACK=_stack; }
public void setStackPU2(int _stack) { PU2_STACK=_stack; }
public void setStackPU3(int _stack) { PU3_STACK=_stack; }
public void setCounterLose(int _c) { COUNTER_LOSE=_c; }
public void setTimeoutPU1(float _c) { TIMEOUT_PU1=_c; }
public void setTimeoutPU2(float _c) { TIMEOUT_PU2=_c; }
public void setTimeoutPU3(float _c) { TIMEOUT_PU3=_c; }
public void setEggCarrotsInRow(int _v) { EGG_CARROTS_INROW=_v; }
public void setEggJumpsInRow(int _v) { EGG_JUMPS_INROW=_v; }
public void setEggSquashInRow(int _v) { EGG_SQUASH_INROW=_v; }

public void incPick_SHOES() { PICK_SHOES++; }
public void incPick_POTION() { PICK_POTION++; }
public void incPick_ROCK() { PICK_ROCK++; }
public void incPick_CHEST() { PICK_CHEST++; }
public void incPick_CLOCK() { PICK_CLOCK++; }
public void incUse_SHOES() { USE_SHOES++; }
public void incUse_POTION() { USE_POTION++; }
public void incUse_ROCK() { USE_ROCK++; }

public int getPick_SHOES() { return PICK_SHOES; }
public int getPick_POTION() { return PICK_POTION; }
public int getPick_ROCK() { return PICK_ROCK; }
public int getPick_CHEST() { return PICK_CHEST; }
public int getPick_CLOCK() { return PICK_CLOCK; }
public int getUse_SHOES() { return USE_SHOES; }
public int getUse_POTION() { return USE_POTION; }
public int getUse_ROCK() { return USE_ROCK; }

public int getPUStackBonus() { return int(round(MAX(1.0,1.0+0.3*(float(GRID_SIZE)+(0.5*float(GRID_DIFFICULTY)))))); }

/////////// IMPLEMENTATION ///////////
void init() { 
	setTag("sc.loader"); 
	CURRENTTHEME="";
	LEVEL=0;
	//TILE_TYPES=listf4();
	TILE_TYPES=listi();
	TILE_ROTS = listi();
	TILE_TRAPS = listi();
	
	TILES_POS=listf3();
  
	CONST_CLUNNY_SPAWN=listf3();
	CONST_HEDGEHOG_SPAWN=listf3();
	CONST_PENGUIN_SPAWN=listf3();

	addListener(ON_EVENT,"LOADLEVEL","e_loadlevel");
	addListener(ON_EVENT,"RESUME","e_resume");
	addListener(ON_EVENT,"ENABLE_ENTITIES","e_enableentities");
}
float3 tileToPos(int _x,int _z) {
	return float3(CONST_TILESIZE*_x,0.0,CONST_TILESIZE*_z)-float3((GRID_SIZE-1)*float(CONST_TILESIZE)/2.0, 0 ,(GRID_SIZE-1)*float(CONST_TILESIZE)/2.0);
}
int posToTile(float _f) {
	return int((_f+((GRID_SIZE-1)*float(CONST_TILESIZE)/2.0))/float(CONST_TILESIZE));
}
public int getMazeDim() { return GRID_SIZE; }

public int getDefaultTime(float dif,float gridsize){
	return int(ceil(16.0 + max(0.1,3 - 0.28*dif)*gridsize*gridsize*0.3));
}

public float getLeftPos() {
	float3 f=tileToPos(0,0);
	return f.x()-(CONST_TILESIZE*0.5);
}
public float getRightPos() {
	float3 f=tileToPos(GRID_SIZE-1,0);
	return f.x()+(CONST_TILESIZE*0.5);
}
public float getTopPos() {
	float3 f=tileToPos(0,0);
	return f.z()-(CONST_TILESIZE*0.5);;
}
public float getBottomPos() {
	float3 f=tileToPos(0,GRID_SIZE-1);
	return f.z()+(CONST_TILESIZE*0.5);;
}
public float getInterval() {
	return float(CONST_TILESIZE)/3.0;
}

int toTileType(int _index) {
	//return int(TILE_TYPES.get(_index).x());
	return TILE_TYPES.get(_index);
}
int toTileAngle(int _index) {
	return TILE_ROTS.get(_index);
}
int toTileTrap(int _index) {
	return TILE_TRAPS.get(_index);
}

void createLabyrinth() {
	//read tiletypes from per theme script
	int i,num;
	string stype;
	lists l_tiles=lists();
	lists l_tile=lists();
	string levelstring = [CURRENTTHEME+".levels" -> getTileTypes(LEVEL) as string];
	levelstring.split(";",l_tiles);
	
	TILE_TYPES.clear();
	TILE_ROTS.clear();
	TILE_TRAPS.clear();
	
	num=l_tiles.num();
	
	int TTP,TTR,TROT;
	for (i=0;i<num;i++) {
		l_tile.clear();
		string curtile = l_tiles.get(i);
		//curtile.sanitizeArg();
		curtile.split(":",l_tile);
		
		//type
		stype=l_tile.get(0);
		if (stype=="I") 	 TTP = CONST_TILE_STRAIGHT;
		else if (stype=="L") TTP = CONST_TILE_CORNER;
		else if (stype=="X") TTP = CONST_TILE_CROSS;
		else if (stype=="T") TTP = CONST_TILE_T;
		else if (stype=="D") TTP = CONST_TILE_DEADEND;
		else {
			errLog("ERROR: UNKNOWN TILE! in level "+CURRENTTHEME+"."+LEVEL+" :: "+curtile);
			errLog(" styp : "+stype);
			errLog(" rot  : "+l_tile.get(1) );
			errLog(" trp  : "+l_tile.get(2) );
			TTP = CONST_TILE_CROSS;
		}
		
		//angle
		int ang;
		ang = int(l_tile.get(1)) );
		if ((ang != 0) && ( ang != 270 ) && (ang != 90 ) && (ang != 180)){
			warnLog(" sc.loader WRONG ANGLE @" +l_tile.get(0)+" : " + l_tile.get(1) + " : " + l_tile.get(2) );
		}
		
		TROT = int(l_tile.get(1));
		
		//trap or collectible
		stype=l_tile.get(2);			
		if (stype=="-") 			  TTR = CONST_TILETRAP_NONE;
		else if (stype=="POND") 	  TTR = CONST_TILETRAP_POND;
		else if (stype=="LOG") 		  TTR = CONST_TILETRAP_LOG;
		else if (stype=="QSAND") 	  TTR = CONST_TILETRAP_QUICKSAND;
		else if (stype=="CRACK") 	  TTR = CONST_TILETRAP_CRACK;
		else if (stype=="SIGN") 	  TTR = CONST_TILETRAP_SIGN;
		else if (stype=="PENGUINSIT") TTR = CONST_TILETRAP_PENGUINSIT;
		else if (stype=="PIER") 	  TTR = CONST_TILETRAP_PIER;
		else if (stype=="LHOUSE") 	  TTR = CONST_TILETRAP_LIGHTHOUSE;
		else if (stype=="SNOWSPOT")   TTR = CONST_TILETRAP_SNOWSPOT;
		else if (stype=="BRIDGE") 	  TTR = CONST_TILETRAP_BRIDGE;
		else if (stype=="DUCK") 	  TTR = CONST_TILETRAP_DUCK;
		else if (stype=="FAUCET") 	  TTR = CONST_TILETRAP_FAUCET;
		else if (stype=="HILL") 	  TTR = CONST_TILETRAP_HILL; 
		else if (stype=="JBRIDGE") 	  TTR = CONST_TILETRAP_JBRIDGE;
		else if (stype=="JTRUNK") 	  TTR = CONST_TILETRAP_JTRUNK;
		else if (stype=="CLOCK") 	  TTR = CONST_PU_CLOCK;
		else if (stype=="SHOES") 	  TTR = CONST_PU_SHOES;
		else if (stype=="POTION") 	  TTR = CONST_PU_POTION;
		else if (stype=="ROCK") 	  TTR = CONST_PU_ROCK;
		else if (stype=="CHEST") 	  TTR = CONST_PU_CHEST;
		else if (stype=="BANANA") 	  TTR = CONST_TRAP_BANANA;
		else if (stype=="GOPHER") 	  TTR = CONST_TRAP_GOPHER;
		else if (stype=="SKULL") 	  TTR = CONST_TRAP_SKULL;
		else 						  TTR = CONST_TILETRAP_NONE;
		
		TILE_TYPES.push(TTP);
		TILE_TRAPS.push(TTR);
		TILE_ROTS.push(TROT);
	}
 

	TILES_POS.clear();

	int tile_variations=2;
	int theme_snow=0;
	
	listvf ctypes=listvf();		
	
	string VFPATH =  "/assets/"+CURRENTTHEME;
	ctypes.push(vfopen(VFPATH+"/straight1","r"));
	ctypes.push(vfopen(VFPATH+"/corner1","r"));
	ctypes.push(vfopen(VFPATH+"/cross1","r"));
	ctypes.push(vfopen(VFPATH+"/t1","r"));
	ctypes.push(vfopen(VFPATH+"/deadend","r"));	
	ctypes.push(vfopen(VFPATH+"/straight2","r"));
	ctypes.push(vfopen(VFPATH+"/corner2","r"));
	ctypes.push(vfopen(VFPATH+"/cross2","r"));
	ctypes.push(vfopen(VFPATH+"/t2","r"));
	ctypes.push(vfopen(VFPATH+"/deadend","r"));

	if (CURRENTTHEME=="snow") {
		tile_variations=3;
		theme_snow=1;
		ctypes.push(vfopen(VFPATH+"/straight3","r"));
		ctypes.push(vfopen(VFPATH+"/corner3","r"));
		ctypes.push(vfopen(VFPATH+"/cross3","r"));
		ctypes.push(vfopen(VFPATH+"/t3","r"));
		ctypes.push(vfopen(VFPATH+"/deadend","r"));
	}
	
	//copy skydome
	if (CURRENTTHEME!="docks") {	
		for (i=0;i<4;i++) {
			system("cp "+VFPATH+"/filler /sector/skydome/filler"+string(i));
			system("chpos 0,3.44,0 /sector/skydome/filler"+string(i));
			system("chrot "+string(i*90)+",0,0 /sector/skydome/filler"+string(i));
			system("chscale "+string(GRID_SIZE*10)+","+string(GRID_SIZE*10)+","+string(GRID_SIZE*10)+" /sector/skydome/filler"+string(i));
		}
		if (CURRENTTHEME=="city") {
			for (i=0;i<4;i++) {
				system("chpos 0,2.68,0 /sector/skydome/filler"+string(i));
			}
		}
	}
	
	vfile seaplane;
	if (CURRENTTHEME == "docks")
	{
		seaplane=vfopen("/assets/docks/plane","r");
	}

	//create grid from tiles!
	vfile vf,vf2;
	string TID;
	int j,ttype,ttrap;
	float tangle;
	int counter=0,trapcounter=0;
	float3 tpos;
	LISTVF_DEADEND.clear();
	for (i=0; i<GRID_SIZE; i++)	{
		for (j=0; j<GRID_SIZE; j++) {
			ttype=toTileType(GRID_SIZE*i + j);
			ttrap=toTileTrap(GRID_SIZE*i + j);
			tangle=float(toTileAngle(GRID_SIZE*i + j));
			tpos = tileToPos(j,i); //correct pos!
			TILES_POS.push(tpos);
			counter++;
			if (ttrap!=CONST_TILETRAP_NONE && ttrap<100) {
				TID = string(trapcounter);
				if (ttrap==CONST_TILETRAP_LOG) {
					system("ln -r /assets/forest/log /sector/corridors/log"+TID);
					vf=vfopen("/sector/corridors/log"+TID,"r");
					vf.setRot(hpr(tangle,0.0,0.0));					
					vf2=vfopen(spawnTrigger("/sector/corridors/log"+TID+"/log.script","levelsets/forest/log.hs","log"+TID,PROXSHAPE_SPHERE2D,0.0),"r");
				}
				else if (ttrap==CONST_TILETRAP_POND) {
					system("ln -r /assets/forest/pond /sector/corridors/pond"+TID);
					vf=vfopen("/sector/corridors/pond"+TID,"r");
					vf.setRot(hpr(tangle+float( 180*rand(2) ),0.0,0.0));					
					vf2=vfopen(spawnTrigger("/sector/corridors/pond"+TID+"/pond.script","levelsets/forest/pond.hs","pond"+TID,PROXSHAPE_SPHERE3D,0.0),"r");
					vf2.setPos(float3(0.0,1.5,0.0));
				}
				else if (ttrap==CONST_TILETRAP_QUICKSAND) {
					system("ln -r /assets/desert/quicksand /sector/corridors/quicksand"+TID);
					vf=vfopen("/sector/corridors/quicksand"+TID,"r");
					vf.setRot(hpr(tangle+float( 180*rand(2) ),0.0,0.0));		
					vf2=vfopen(spawnTrigger("/sector/corridors/quicksand"+TID+"/quicksand.script","levelsets/desert/quicksand.hs","quicksand"+TID,PROXSHAPE_SPHERE3D,0.0),"r");
					vf2.setPos(float3(0.0,0.0,0.0));
				}		
				else if (ttrap==CONST_TILETRAP_CRACK) {
					system("cp /assets/snow/crack.actor /sector/corridors/crack"+TID);
					vf=vfopen("/sector/corridors/crack"+TID,"r");
					vf.setRot(hpr(tangle+float( 180*rand(2) ),0.0,0.0));					
					vf2=vfopen(spawnTrigger("/sector/corridors/crack"+TID+"/crack.script","levelsets/snow/crack.hs","crack"+TID,PROXSHAPE_SPHERE3D,0.0),"r");
				}		
				else if (ttrap==CONST_TILETRAP_LIGHTHOUSE) {
					system("ln -r /assets/docks/lighthouse /sector/corridors/lighthouse"+TID);
					vf=vfopen("/sector/corridors/lighthouse"+TID,"r");
					vf.setRot(hpr(tangle,0.0,0.0));					
					vf2=vfopen(spawnTrigger("/sector/corridors/lighthouse"+TID+"/lighthouse.script","levelsets/docks/lighthouse.hs","lighthouse"+TID,PROXSHAPE_SPHERE2D,0.0),"r");
				}	
				else if (ttrap==CONST_TILETRAP_SIGN) {
					vf=vfmakelink(ctypes.get(ttype),"/sector/corridors/");
					vf.setRot(hpr(tangle,0.0,0.0));					
					vf2=vfopen(spawnTrigger(vf.path()+"/sign"+TID+".script","levelsets/docks/sign.hs","sign"+TID,PROXSHAPE_SPHERE2D,0.0),"r");
				}
				else if (ttrap==CONST_TILETRAP_PENGUINSIT) {
					vf=vfmakelink(vfopen("/assets/snow/ttrap.actor","r"),"/sector/corridors/");
					vf.setRot(hpr(tangle,0.0,0.0));					
					vf2=vfopen(spawnTrigger(vf.path()+"/penguinsit"+TID+".script","levelsets/snow/penguinsit.hs","penguinsit"+TID,PROXSHAPE_SPHERE2D,0.0),"r");
				}				
				else if (ttrap==CONST_TILETRAP_PIER) {
					system("ln -r /assets/docks/pier /sector/corridors/pier"+TID);
					vf=vfopen("/sector/corridors/pier"+TID,"r");
					vf.setRot(hpr(tangle,0.0,0.0));
					vf2=vfopen(spawnTrigger("/sector/corridors/pier"+TID+"/pier.script","levelsets/docks/pier.hs","pier"+TID,PROXSHAPE_SPHERE2D,0.0),"r");
				}		
				else if (ttrap==CONST_TILETRAP_SNOWSPOT) {
					system("ln -r /assets/snow/snowspot /sector/corridors/snowspot.tile"+TID);
					vf=vfopen("/sector/corridors/snowspot.tile"+TID,"r");
					vf.setRot(hpr(tangle,0.0,0.0));
					vf2=vfopen(spawnTrigger("/sector/corridors/snowspot.tile"+TID+"/snowspot.script","levelsets/snow/snowspot.hs","snowspot"+TID,PROXSHAPE_SPHERE3D,0.0),"r");
				}
				else if (ttrap==CONST_TILETRAP_BRIDGE) {
					system("cp /assets/city/bridge.actor /sector/corridors/bridge"+TID);
					vf=vfopen("/sector/corridors/bridge"+TID,"r");
					vf.setRot(hpr(tangle,0.0,0.0));
					vf2=vfopen(spawnTrigger("/sector/corridors/bridge"+TID+"/bridge.script","levelsets/city/bridge.hs","bridge"+TID,PROXSHAPE_SPHERE2D,0.0),"r");
				}			
				else if (ttrap==CONST_TILETRAP_DUCK) {
					system("cp /assets/city/ducktrap.actor /sector/corridors/duck"+TID);
					vf=vfopen("/sector/corridors/duck"+TID,"r");
					vf.setRot(hpr(tangle,0.0,0.0));
					vf2=vfopen(spawnTrigger("/sector/corridors/duck"+TID+"/duck.script","levelsets/city/duck.hs","duck"+TID,PROXSHAPE_SPHERE2D,0.0),"r");
				}		
				else if (ttrap==CONST_TILETRAP_FAUCET) {
					system("ln -r /assets/city/faucet1 /sector/corridors/faucet"+TID);
					vf=vfopen("/sector/corridors/faucet"+TID,"r");
					vf.setRot(hpr(tangle,0.0,0.0));					
					vf2=vfopen(spawnTrigger("/sector/corridors/faucet"+TID+"/faucet.script","levelsets/city/faucet.hs","faucet"+TID,PROXSHAPE_SPHERE2D,0.0),"r");
				}						
				else if (ttrap==CONST_TILETRAP_HILL) {
					system("ln -r /assets/city/hill /sector/corridors/hill"+TID);
					vf=vfopen("/sector/corridors/hill"+TID,"r");					
					vf.setRot(hpr(tangle,0.0,0.0));					
					vf2=vfopen(spawnTrigger("/sector/corridors/hill"+TID+"/hill.script","levelsets/city/hill.hs","hill"+TID,PROXSHAPE_SPHERE2D,0.0),"r");
				}
				else if (ttrap==CONST_TILETRAP_JBRIDGE) {					
					system("cp /assets/jungle/bridge.actor /sector/corridors/jbridge"+TID);
					vf=vfopen("/sector/corridors/jbridge"+TID,"r");
					vf.setRot(hpr(tangle+float( 180*rand(2) ),0.0,0.0));					
					vf2=vfopen(spawnTrigger("/sector/corridors/jbridge"+TID+"/jbridge.script","levelsets/jungle/jbridge.hs","jbridge"+TID,PROXSHAPE_SPHERE3D,0.0),"r");
				}
				else if (ttrap==CONST_TILETRAP_JTRUNK) {							
					system("cp /assets/jungle/trunk.actor /sector/corridors/jtrunk"+TID);
					vf=vfopen("/sector/corridors/jtrunk"+TID,"r");
					vf.setRot(hpr(tangle,0.0,0.0));
					vf2=vfopen(spawnTrigger("/sector/corridors/jtrunk"+TID+"/jtrunk.script","levelsets/jungle/jtrunk.hs","jtrunk"+TID,PROXSHAPE_SPHERE2D,0.0),"r");
				}
				vf.setPos(tpos);
				LISTVF_ENTITIES.push(vf2);					
				LISTPOS_ENTITIES.push(vf2.getPos());					
				trapcounter++;
				
				
			}
			else if (ttype==CONST_TILE_DEADEND) {
				vf=vfclone(ctypes.get(ttype+rand(tile_variations)*CONST_TILE_TOTAL),"/sector/corridors/");
				vf.setPos(tpos);
				vf.setRot(hpr(tangle,0.0,0.0));
				LISTVF_DEADEND.push(vf);
				
				
			}
			else {
				vf=vfmakelink(ctypes.get(ttype+rand(tile_variations)*CONST_TILE_TOTAL),"/sector/corridors/");
				vf.setPos(tpos);
				vf.setRot(hpr(tangle,0.0,0.0));
				
				
			}
		}
	}

	if (CURRENTTHEME == "docks") {
		vf=vfmakelink(seaplane,"/sector/corridors/");
		vf.setPos(float3(0.0,0.5,0.0));
		vf.setRot(hpr(0.0,0.0,0.0));
	}
}
float3 getSlotPos(float3 _topleft, int _i, int _j) {
	return _topleft + float3(float(_j)*float(CONST_TILESIZE)/3.0,0.0,float(_i)*(float(CONST_TILESIZE)/3.0));
}
void getSlots(int _tiletype, int _tileangle, float3 _pos, listf3 _slots)
{
	_slots.clear();
	float3 topleft = _pos + float3((-1.0)*(float(CONST_TILESIZE)/3.0),2.5,(-1.0)*(float(CONST_TILESIZE)/3.0));
	if (_tiletype == CONST_TILE_STRAIGHT) {
		if (_tileangle == 0) { _slots.push(getSlotPos(topleft,1,1)); _slots.push(getSlotPos(topleft,1,0)); _slots.push(getSlotPos(topleft,1,2)); }
		else if (_tileangle == 90) { _slots.push(getSlotPos(topleft,1,1)); _slots.push(getSlotPos(topleft,0,1)); _slots.push(getSlotPos(topleft,2,1)); }
	}
	else if (_tiletype == CONST_TILE_CORNER) {
		if (_tileangle == 0) { _slots.push(getSlotPos(topleft,1,1)); _slots.push(getSlotPos(topleft,1,2)); _slots.push(getSlotPos(topleft,2,1)); }
		else if (_tileangle == 90) { _slots.push(getSlotPos(topleft,1,1)); _slots.push(getSlotPos(topleft,0,1));  _slots.push(getSlotPos(topleft,1,2)); }
		else if (_tileangle == 180) { _slots.push(getSlotPos(topleft,1,1)); _slots.push(getSlotPos(topleft,0,1)); _slots.push(getSlotPos(topleft,1,0));  }
		else if (_tileangle == 270) { _slots.push(getSlotPos(topleft,1,1)); _slots.push(getSlotPos(topleft,1,0));  _slots.push(getSlotPos(topleft,2,1)); }
	}
	else if (_tiletype == CONST_TILE_CROSS) {
		if (_tileangle == 0) {
			_slots.push(getSlotPos(topleft,1,1));
			_slots.push(getSlotPos(topleft,0,1)); _slots.push(getSlotPos(topleft,1,0)); 
			_slots.push(getSlotPos(topleft,1,2)); _slots.push(getSlotPos(topleft,2,1));
		}
	}
	else if (_tiletype == CONST_TILE_T) {
		if (_tileangle == 0) { _slots.push(getSlotPos(topleft,1,1)); _slots.push(getSlotPos(topleft,1,0));  _slots.push(getSlotPos(topleft,1,2)); _slots.push(getSlotPos(topleft,2,1)); }
		else if (_tileangle == 90) { _slots.push(getSlotPos(topleft,1,1)); _slots.push(getSlotPos(topleft,0,1)); _slots.push(getSlotPos(topleft,1,2)); _slots.push(getSlotPos(topleft,2,1)); }
		else if (_tileangle == 180) { _slots.push(getSlotPos(topleft,1,1)); _slots.push(getSlotPos(topleft,0,1)); _slots.push(getSlotPos(topleft,1,0));  _slots.push(getSlotPos(topleft,1,2)); }
		else if (_tileangle == 270) { _slots.push(getSlotPos(topleft,1,1)); _slots.push(getSlotPos(topleft,0,1)); _slots.push(getSlotPos(topleft,1,0));  _slots.push(getSlotPos(topleft,2,1)); }
	}
	else if (_tiletype == CONST_TILE_DEADEND) {
		if (_tileangle == 0) { _slots.push(getSlotPos(topleft,1,2)); }
		else if (_tileangle == 90) { _slots.push(getSlotPos(topleft,0,1)); }
		else if (_tileangle == 180) { _slots.push(getSlotPos(topleft,1,0)); }
		else if (_tileangle == 270) { _slots.push(getSlotPos(topleft,2,1)); }
	}
}
void resetCounters() {
	debugLog("Resetting counters...");
	CURRENT_SCORE=0;
	CURRENT_TIME=getRequiredTime();
	BONUS_JUMP=0;
	BONUS_PUP=0;
	BONUS_TIME=0;
	PU1_STACK=0;
	PU2_STACK=0;
	PU3_STACK=0;
	COUNTER_LOSE=0;
	TIMEOUT_PU1=0;
	TIMEOUT_PU2=0;
	TIMEOUT_PU3=0;
	PICK_SHOES=0;
	PICK_POTION=0;
	PICK_ROCK=0;
	PICK_CLOCK=0;
	PICK_CHEST=0;
	USE_SHOES=0;
	USE_POTION=0;
	USE_ROCK=0;
	EGG_JUMPS_INROW=0;
	EGG_CARROTS_INROW=0;
	EGG_SQUASH_INROW=0;
}
void spawnBalls()
{
	int i,j,num;
	float2 slot_pos;
	
	TOTAL_CARROTS=0;
	resetCounters();

	vfile fcarrot=vfopen("/assets/carrot","r");
	vfile fclock=vfopen("/assets/pu_clock","r");
	vfile fshoe=vfopen("/assets/pu_shoe","r");
	vfile frock=vfopen("/assets/pu_rock","r");
	vfile fpotion=vfopen("/assets/pu_potion","r");
	vfile fchest=vfopen("/assets/pu_chest","r");

	LISTVF_CARROTS=listvf();

	//spawn powerups
	listi used_slot=listi();
	int trap_counter=1;
	listf3 slots=listf3();	
	float3 tpos;
	int ttrap;
	int isentity;	
	num=TILE_TYPES.num();
	if (TILE_TRAPS.num() != TILE_TYPES.num() ) errLog("ERROR: TILES NOT ALIGNED");
	if (TILE_ROTS.num() != TILE_TYPES.num() ) errLog("ERROR: TILES NOT ALIGNED");
	
	for (i=0;i<num;i++) {
		if (TILE_TRAPS.get(i)>=100) { // if is moving powerup
			tpos = TILES_POS.get(i);
			getSlots(toTileType(i),toTileAngle(i),tpos,slots);
			int rnd_slot=rand(slots.num());
			int type=TILE_TRAPS.get(i);
			vfile f;
			isentity=0;
			if (type==CONST_PU_CLOCK) {
				rnd_slot=0;
				f=vfmakelink(fclock,"/sector/carrots/");
				f.copyServices(fclock);
			}
			else if (type==CONST_PU_SHOES) { 
				rnd_slot=0;
				f=vfmakelink(fshoe,"/sector/carrots/");
				f.copyServices(fshoe);
			}
			else if (type==CONST_PU_POTION) {
				rnd_slot=0;
				f=vfmakelink(fpotion,"/sector/carrots/");
				f.copyServices(fpotion);
			}
			else if (type==CONST_PU_ROCK) {
				rnd_slot=0;
				f=vfmakelink(frock,"/sector/carrots/");
				f.copyServices(frock);
			}
			else if (type==CONST_PU_CHEST) {
				rnd_slot=0;
				f=vfmakelink(fchest,"/sector/carrots/");
				f.copyServices(fchest);
			}
			else if (type==CONST_TRAP_BANANA) {
				f=vfopen(spawnTrigger("/sector/carrots/trap"+string(trap_counter),"levelsets/traps/banana.hs","banana"+string(trap_counter),PROXSHAPE_SPHERE3D,0.0),"r");
				isentity=1;
				trap_counter++;
			}
			else if (type==CONST_TRAP_SKULL) {
				f=vfopen(spawnTrigger("/sector/carrots/trap"+string(trap_counter),"levelsets/traps/skull.hs","skull"+string(trap_counter),PROXSHAPE_SPHERE3D,0.0),"r");
				isentity=1;
				trap_counter++;
			}
			else if (type==CONST_TRAP_GOPHER) {
				f=vfopen(spawnTrigger("/sector/carrots/trap"+string(trap_counter),"levelsets/traps/gopher.hs","gopher"+string(trap_counter),PROXSHAPE_SPHERE3D,0.0),"r");
				isentity=1;
				trap_counter++;
			}
			else {
				errLog("Invalid collectible id");
			}
			used_slot.push((i*1000)+rnd_slot);
			f.setPos(slots.get(rnd_slot));
			LISTVF_CARROTS.push(f);	
			if (isentity) {
				LISTVF_ENTITIES.push(f);
				LISTPOS_ENTITIES.push(f.getPos());
			}		
		}	
	}
	//spawn carrots
	num=TILES_POS.num();
	for (i=0; i<num; i++) {
		ttrap=toTileTrap(i);
		tpos = TILES_POS.get(i);
		getSlots(toTileType(i),int(toTileAngle(i)),tpos,slots);
		for (j=0; j<slots.num(); j++) {
			if ( used_slot.findIndex((i*1000)+j)>=used_slot.num() ) {
				slot_pos=slots.get(j).xz();
				slot_pos=float2( int(slot_pos.x()), int(slot_pos.y() );
				vfile f=vfmakelink(fcarrot,"/sector/carrots/");
				f.setPos(slots.get(j));
				if ((ttrap==CONST_TILETRAP_POND) || (ttrap==CONST_TILETRAP_QUICKSAND) || (ttrap==CONST_TILETRAP_PIER) || (ttrap==CONST_TILETRAP_CRACK) || (ttrap==CONST_TILETRAP_SNOWSPOT) || (ttrap==CONST_TILETRAP_FAUCET)) {
					f.setPos( f.getPos() + float3(0, (5.0-(f.getPos().xz()-tpos.xz()).length())*0.75, 0) );
				}
				else if (ttrap==CONST_TILETRAP_HILL) {
					f.setPos( f.getPos() + float3(0, (5.0-(f.getPos().xz()-tpos.xz()).length())*0.25, 0) );
				}
				else if (ttrap==CONST_TILETRAP_BRIDGE) {
					f.setPos( f.getPos() + float3(0, (5.0-(f.getPos().xz()-tpos.xz()).length())*0.5, 0) );
				}
				TOTAL_CARROTS++;
				LISTVF_CARROTS.push(f);
			}
		}
	}	
}
void setupSpawners() {
	CONST_CLUNNY_SPAWN.clear();
	CONST_CLUNNY_SPAWN.push(float3(GRID_SIZE - 1,0,0.85));
	CONST_CLUNNY_SPAWN.push(float3(GRID_SIZE - 1,GRID_SIZE - 1,1));
	CONST_CLUNNY_SPAWN.push(float3(0,0,1.25));
	CONST_CLUNNY_SPAWN.push(float3((GRID_SIZE/2)-1,0,1.5));
	CONST_CLUNNY_SPAWN.push(float3(GRID_SIZE - 1,(GRID_SIZE/2) - 1,1.75));
	CONST_CLUNNY_SPAWN.push(float3(0,(GRID_SIZE/2) - 1,1.6));
	CONST_CLUNNY_SPAWN.push(float3((GRID_SIZE/2)-1,GRID_SIZE - 1,1.8));

	CONST_HEDGEHOG_SPAWN.clear();
	CONST_HEDGEHOG_SPAWN.push(float3(GRID_SIZE/2,GRID_SIZE/2,1));
	CONST_HEDGEHOG_SPAWN.push(float3(GRID_SIZE/2,0,1.1));
	CONST_HEDGEHOG_SPAWN.push(float3(GRID_SIZE-1,GRID_SIZE/2,1.2));
	CONST_HEDGEHOG_SPAWN.push(float3(GRID_SIZE/2,GRID_SIZE-1,1.3));
	CONST_HEDGEHOG_SPAWN.push(float3(0,GRID_SIZE/2,1.4));  
	
	CONST_PENGUIN_SPAWN.clear();
	CONST_PENGUIN_SPAWN.push(float3(GRID_SIZE/2,GRID_SIZE/2,1));
	CONST_PENGUIN_SPAWN.push(float3(GRID_SIZE/2,0,1.05);
	CONST_PENGUIN_SPAWN.push(float3(GRID_SIZE-1,GRID_SIZE/2,1.1));
	CONST_PENGUIN_SPAWN.push(float3(GRID_SIZE/2,GRID_SIZE-1,1.15));
	CONST_PENGUIN_SPAWN.push(float3(0,GRID_SIZE/2,1.2));  
}
void cbLevelMounted() {
	if (![CURRENTTHEME+".levels"->isLoaded() as int]) {
		addListener(ON_TIMEOUT_MSEC,"200","cbLevelMounted");
		return;
	}
	GRID_SIZE=[CURRENTTHEME+".levels"->getGridSize(LEVEL) as int];
	GRID_DIFFICULTY=[CURRENTTHEME+".levels"->getDifficulty(LEVEL) as int];
	REQUIRED_TIME=[CURRENTTHEME+".levels"->getRequiredTime(LEVEL) as int];
	//create labyrinth
	createLabyrinth();	
	//spawn carrots and collectibles
	spawnBalls();
	
	//spawn rock 
	spawnEntity("/sector/rock","scripts/rock.hs","",PROXSHAPE_SPHERE3D,0.0,0.0,0.0);
	
	//spawn hero
	vfile hero=vfopen(spawnEntity("/sector/hero","scripts/bunny.hs","",PROXSHAPE_SPHERE2D,0.0,0.0,0.0),"r");
	if (LISTVF_DEADEND.num()) {
		hero.setPos(float3(LISTVF_DEADEND.get(0).getPos().x(),2.33,LISTVF_DEADEND.get(0).getPos().z()));
	}
	else {
		hero.setPos(tileToPos(0,GRID_SIZE-1)+float3(0,2.33,0));
	}
	LISTVF_ENTITIES.push(hero);
	LISTPOS_ENTITIES.push(hero.getPos());

	//spawn enemies
	setupSpawners();
	lists vars=lists();
	vars.push("theme="+CURRENTTHEME);
	vars.push("speed_mult=1.0");

	int i,index;
	int maxnum=CONST_CLUNNY_SPAWN.num();
	int clunnies=min(maxnum,[CURRENTTHEME+".levels"->getClunnyNum(LEVEL) as int]);
	for (i=0;i<clunnies;i++) {
		vars.set(1,"speed_mult="+string(CONST_CLUNNY_SPAWN.get(i).z());
		vfile enemy=vfopen(spawnEntity("/sector/enemies/enemy"+string(i+1),"scripts/enemy.hs","enemy"+string(i+1),PROXSHAPE_SPHERE2D,0.0,0.0,0.0,vars),"r");
		enemy.setPos(tileToPos(int(CONST_CLUNNY_SPAWN.get(maxnum - i -1).x()),int(CONST_CLUNNY_SPAWN.get(maxnum - i - 1).y()))+float3(0,2.33,0)); 
		index=i;
		while ( (enemy.getPos()-hero.getPos()).xz().length()<=20.0 ) {
			if (index==0) enemy.setPos(tileToPos(int(CONST_CLUNNY_SPAWN.get(0).x()),int(CONST_CLUNNY_SPAWN.get(0).y()))+float3(0,2.33,0)); 
			else if ( (index+1)==maxnum ) enemy.setPos(tileToPos(int(CONST_CLUNNY_SPAWN.get(maxnum  -1).x()),int(CONST_CLUNNY_SPAWN.get(maxnum - 1).y()))+float3(0,2.33,0)); 
			else enemy.setPos(tileToPos(int(CONST_CLUNNY_SPAWN.get(maxnum - index -2).x()),int(CONST_CLUNNY_SPAWN.get(maxnum - index - 2).y()))+float3(0,2.33,0)); 
			index++;
			if (index>=maxnum) index=0;
		}
		LISTVF_ENTITIES.push(enemy);
		LISTPOS_ENTITIES.push(enemy.getPos());
	}

	maxnum=CONST_HEDGEHOG_SPAWN.num();
	int hedgehogs=min(maxnum,[CURRENTTHEME+".levels"->getHedgehogNum(LEVEL) as int]);
	for (i=0;i<hedgehogs;i++) {
		vars.set(1,"speed_mult="+string(CONST_HEDGEHOG_SPAWN.get(i).z());
		vfile enemy=vfopen(spawnEntity("/sector/enemies/hedgehog"+string(i+1),"scripts/hedgehog.hs","hedgehog"+string(i+1),PROXSHAPE_SPHERE2D,0.0,0.0,0.0,vars),"r");
		enemy.setPos(tileToPos(int(CONST_HEDGEHOG_SPAWN.get(maxnum - i -1).x()),int(CONST_HEDGEHOG_SPAWN.get(maxnum - i - 1).y()))+float3(0,2.33,0)); 
		index=i;
		if ( (enemy.getPos()-hero.getPos()).xz().length()<=20.0 ) {
			if (index==0) enemy.setPos(tileToPos(int(CONST_HEDGEHOG_SPAWN.get(0).x()),int(CONST_HEDGEHOG_SPAWN.get(0).y()))+float3(0,2.33,0)); 
			else if ( (index+1)==maxnum ) enemy.setPos(tileToPos(int(CONST_HEDGEHOG_SPAWN.get(maxnum  -1).x()),int(CONST_HEDGEHOG_SPAWN.get(maxnum - 1).y()))+float3(0,2.33,0)); 
			else enemy.setPos(tileToPos(int(CONST_HEDGEHOG_SPAWN.get(maxnum - index -2).x()),int(CONST_HEDGEHOG_SPAWN.get(maxnum - index - 2).y()))+float3(0,2.33,0)); 
			index++;
			if (index>=maxnum) index=0;
		}
		LISTVF_ENTITIES.push(enemy);
		LISTPOS_ENTITIES.push(enemy.getPos());
	}
	
	maxnum=CONST_PENGUIN_SPAWN.num();
	int penguins=min(maxnum,[CURRENTTHEME+".levels"->getPenguinNum(LEVEL) as int]);
	for (i=0;i<penguins;i++) {
		vars.set(1,"speed_mult="+string(CONST_PENGUIN_SPAWN.get(i).z());
		vfile enemy=vfopen(spawnEntity("/sector/enemies/penguin"+string(i+1),"scripts/penguin.hs","penguin"+string(i+1),PROXSHAPE_SPHERE2D,0.0,0.0,0.0,vars),"r");
		enemy.setPos(tileToPos(int(CONST_PENGUIN_SPAWN.get(maxnum - i -1).x()),int(CONST_PENGUIN_SPAWN.get(maxnum - i - 1).y()))+float3(0,2.33,0)); 
		index=i;
		if ( (enemy.getPos()-hero.getPos()).xz().length()<=20.0 ) {
			if (index==0) enemy.setPos(tileToPos(int(CONST_PENGUIN_SPAWN.get(0).x()),int(CONST_PENGUIN_SPAWN.get(0).y()))+float3(0,2.33,0)); 
			else if ( (index+1)==maxnum ) enemy.setPos(tileToPos(int(CONST_PENGUIN_SPAWN.get(maxnum  -1).x()),int(CONST_PENGUIN_SPAWN.get(maxnum - 1).y()))+float3(0,2.33,0)); 
			else enemy.setPos(tileToPos(int(CONST_PENGUIN_SPAWN.get(maxnum - index -2).x()),int(CONST_PENGUIN_SPAWN.get(maxnum - index - 2).y()))+float3(0,2.33,0)); 
			index++;
			if (index>=maxnum) index=0;
		}
		LISTVF_ENTITIES.push(enemy);
		LISTPOS_ENTITIES.push(enemy.getPos());
	}	
	
	//set light
	int mod_level=LEVEL%8;
	vfile flight=vfopen("/sector/light","w");	
	float4 lcolor=float4(1,1,1,1);
	lcolor=rgb2hsv(lcolor);
	float f=radians(11.25);
	lcolor.x( 180.0*cos( float(mod_level)*f) );
	lcolor.y( 0.5-0.5*cos( float(mod_level)*f) );
	lcolor=hsv2rgb(lcolor);
	flight.setChannel("color.r",lcolor.x());
	flight.setChannel("color.g",lcolor.y());
	flight.setChannel("color.b",lcolor.z());
	flight.close();
	addListener(ON_TIMEOUT_MSEC,"200","cbLevelWait");
}
void cbLevelWait() {
	int i;
	debugLog("Waiting for entities to load...");
	for (i=0;i<LISTVF_ENTITIES.num();i++) {
		if (![LISTVF_ENTITIES.get(i).getTag()->isLoaded() as int]) {
			debugLog("Waiting for: "+LISTVF_ENTITIES.get(i).getTag());
			addListener(ON_TIMEOUT_MSEC,"200","cbLevelWait");
			return;
		}
	}
	["statue"->reset()];
	debugLog("Entities loaded...");	
	addListener(ON_SCENELOADED,"cbComplete");
}
void cbComplete() {
	addListener(ON_TIMEOUT_MSEC,"1000","cbComplete2");
}
void cbComplete2() {
	debugLog("Entities are complete...");	
	sendEvent(REPLY_EVENT,REPLY_TAG);
}
void e_loadlevel(string _theme,int _level,string _replytag,string _replyevent) {
	rand(_level);
	REPLY_TAG=_replytag;
	REPLY_EVENT=_replyevent;

	//check for restart
	if ((_theme==CURRENTTHEME) && (_level==LEVEL)) {
		debugLog("Resetting level...");
		resetCounters();
		system("chrnd -r +v /sector/carrots");
		["rock"->reset()];
		["statue"->reset()];
		int i;
		for (i=0;i<LISTVF_ENTITIES.num();i++) {
			LISTVF_ENTITIES.get(i).setPos( LISTPOS_ENTITIES.get(i) );
			LISTVF_ENTITIES.get(i).setRot(float3(0,0,0));
			[LISTVF_ENTITIES.get(i).getTag() -> reset()];
		}		
		addListener(ON_TIMEOUT_MSEC,"200","cbLevelWait");
		return;
	}


	//clean up
	system("rm -r /sector/corridors/");
	system("rm -r /sector/carrots/");
	system("rm -r /sector/enemies/");
	system("rm -r /sector/hero");
	system("rm -r /sector/rock");
	system("rm -r /sector/skydome");
	system("mkdir /sector/corridors");
	system("mkdir /sector/carrots");
	system("mkdir /sector/enemies");
	system("mkdir /sector/skydome");

	LISTVF_ENTITIES=listvf();	
	LISTPOS_ENTITIES=listf3();
	LISTVF_DEADEND=listvf();
	LEVEL=_level;
	
	//check for level already loaded
	if (CURRENTTHEME==_theme) {
		cbLevelMounted();
	}
	else {
		//remove previous theme
		if (CURRENTTHEME.length()) {
			clearScene("/assets/"+CURRENTTHEME);
		}
		CURRENTTHEME=_theme;
		loadScene("levelsets/"+_theme+"/"+_theme+".hvfs","/assets/","cbLevelMounted");
	}	
}
//save state from app pause
public void e_AppPause() {
	debugLog("Saving game state");
	appPropertySet(APPNAME,"state","PLAY:"+CURRENTTHEME+":"+LEVEL);
	//counters
	appPropertySet(APPNAME,"CURRENT_SCORE",string(CURRENT_SCORE));
	appPropertySet(APPNAME,"CURRENT_TIME",string(CURRENT_TIME));
	appPropertySet(APPNAME,"BONUS_JUMP",string(BONUS_JUMP));
	appPropertySet(APPNAME,"BONUS_PUP",string(BONUS_PUP));
	appPropertySet(APPNAME,"BONUS_TIME",string(BONUS_TIME));
	appPropertySet(APPNAME,"PU1_STACK",string(PU1_STACK));
	appPropertySet(APPNAME,"PU2_STACK",string(PU2_STACK));
	appPropertySet(APPNAME,"PU3_STACK",string(PU3_STACK));
	appPropertySet(APPNAME,"COUNTER_LOSE",string(COUNTER_LOSE));
	appPropertySet(APPNAME,"TIMEOUT_PU1",string(TIMEOUT_PU1));
	appPropertySet(APPNAME,"TIMEOUT_PU2",string(TIMEOUT_PU2));
	appPropertySet(APPNAME,"TIMEOUT_PU3",string(TIMEOUT_PU3));
	
	appPropertySet(APPNAME,"PICK_SHOES",string(PICK_SHOES));
	appPropertySet(APPNAME,"PICK_POTION",string(PICK_POTION));
	appPropertySet(APPNAME,"PICK_ROCK",string(PICK_ROCK));
	appPropertySet(APPNAME,"PICK_CLOCK",string(PICK_CLOCK));
	appPropertySet(APPNAME,"PICK_CHEST",string(PICK_CHEST));
	appPropertySet(APPNAME,"USE_SHOES",string(USE_SHOES));
	appPropertySet(APPNAME,"USE_ROCK",string(USE_ROCK));
	appPropertySet(APPNAME,"USE_POTION",string(USE_POTION));

	appPropertySet(APPNAME,"EGG_CARROTS_INROW",string(EGG_CARROTS_INROW));
	appPropertySet(APPNAME,"EGG_JUMPS_INROW",string(EGG_JUMPS_INROW));
	appPropertySet(APPNAME,"EGG_SQUASH_INROW",string(EGG_SQUASH_INROW));

	//save entity state
	int i;
	for (i=0;i<LISTVF_ENTITIES.num();i++) {
		[LISTVF_ENTITIES.get(i).getTag() -> saveState()];
	}
	["statue"->saveState()];

	//store carrot state
	string expr;
	for (i=0;i<LISTVF_CARROTS.num();i++) {
		if (LISTVF_CARROTS.get(i).isVisible()) { expr+="1;"; } else { expr+="0;"; }
	}
	appPropertySet(APPNAME,"L_CARROTS",string(expr));
	appPropertyFlush();
	debugLog("Saving game state completed");
}
void e_resume() {
	debugLog("Resuming state");
	int i;
	lists lcarrot=lists();
	appPropertyGet(APPNAME,"L_CARROTS","").split(";",lcarrot);
	if (lcarrot.num()!=LISTVF_CARROTS.num()) { 
		errLog("Invalid resume data");
		return; 
	}
	for (i=0;i<LISTVF_CARROTS.num();i++) {
		if (int(lcarrot.get(i))==0) LISTVF_CARROTS.get(i).hide();
	}
	
	//resume state
	CURRENT_SCORE=int(appPropertyGet(APPNAME,"CURRENT_SCORE",string(CURRENT_SCORE)));
	CURRENT_TIME=int(appPropertyGet(APPNAME,"CURRENT_TIME",string(CURRENT_TIME)));
	BONUS_JUMP=int(appPropertyGet(APPNAME,"BONUS_JUMP",string(BONUS_JUMP)));
	BONUS_PUP=int(appPropertyGet(APPNAME,"BONUS_PUP",string(BONUS_PUP)));
	BONUS_TIME=int(appPropertyGet(APPNAME,"BONUS_TIME",string(BONUS_TIME)));
	PU1_STACK=int(appPropertyGet(APPNAME,"PU1_STACK",string(PU1_STACK)));
	PU2_STACK=int(appPropertyGet(APPNAME,"PU2_STACK",string(PU2_STACK)));
	PU3_STACK=int(appPropertyGet(APPNAME,"PU3_STACK",string(PU3_STACK)));
	COUNTER_LOSE=int(appPropertyGet(APPNAME,"COUNTER_LOSE",string(COUNTER_LOSE)));
	TIMEOUT_PU1=float(appPropertyGet(APPNAME,"TIMEOUT_PU1",string(TIMEOUT_PU1)));
	TIMEOUT_PU2=float(appPropertyGet(APPNAME,"TIMEOUT_PU2",string(TIMEOUT_PU2)));
	TIMEOUT_PU3=float(appPropertyGet(APPNAME,"TIMEOUT_PU3",string(TIMEOUT_PU3)));
	
	PICK_SHOES=int(appPropertyGet(APPNAME,"PICK_SHOES",string(PICK_SHOES)));
	PICK_POTION=int(appPropertyGet(APPNAME,"PICK_POTION",string(PICK_POTION)));
	PICK_ROCK=int(appPropertyGet(APPNAME,"PICK_ROCK",string(PICK_ROCK)));
	PICK_CLOCK=int(appPropertyGet(APPNAME,"PICK_CLOCK",string(PICK_CLOCK)));
	PICK_CHEST=int(appPropertyGet(APPNAME,"PICK_CHEST",string(PICK_CHEST)));
	USE_SHOES=int(appPropertyGet(APPNAME,"USE_SHOES",string(USE_SHOES)));
	USE_POTION=int(appPropertyGet(APPNAME,"USE_POTION",string(USE_POTION)));
	USE_ROCK=int(appPropertyGet(APPNAME,"USE_ROCK",string(USE_ROCK)));
	
	EGG_CARROTS_INROW=int(appPropertyGet(APPNAME,"EGG_CARROTS_INROW",string(EGG_CARROTS_INROW)));
	EGG_JUMPS_INROW=int(appPropertyGet(APPNAME,"EGG_JUMPS_INROW",string(EGG_JUMPS_INROW)));
	EGG_SQUASH_INROW=int(appPropertyGet(APPNAME,"EGG_SQUASH_INROW",string(EGG_SQUASH_INROW)));
	
	for (i=0;i<LISTVF_ENTITIES.num();i++) {
		[LISTVF_ENTITIES.get(i).getTag() -> loadState()];
	}
	["statue"->loadState()];
}
public void e_SaveLevelScore() {
	int FINAL_SCORE_STARS=0;
	if (CURRENT_SCORE>=(TOTAL_CARROTS*CONST_PERC_STAR3)) {
		FINAL_SCORE_STARS=3;
	}
	else if (CURRENT_SCORE>=(TOTAL_CARROTS*CONST_PERC_STAR2)) {
		FINAL_SCORE_STARS=2;
	}
	else if (CURRENT_SCORE>=(TOTAL_CARROTS*CONST_PERC_STAR1)) {
		FINAL_SCORE_STARS=1;
	}
	if (FINAL_SCORE_STARS>0) {	
		//store results
		int i;
		lists lvls=lists();
		appPropertyGet(APPNAME,"lvlscore_"+CURRENTTHEME,"").split(";",lvls);	
		for (i=lvls.num();i<LEVEL;i++) {
			lvls.push("0");
		}
		lvls.set(LEVEL-1,string(max(FINAL_SCORE_STARS,int(lvls.get(LEVEL-1)))));
		string ret;
		for (i=0;i<lvls.num();i++) {
			ret+=lvls.get(i)+";";
		}
		appPropertySet(APPNAME,"lvlscore_"+CURRENTTHEME,ret);
		appPropertyFlush();
	}
}
void e_enableentities() {
	debugLog("Enabling entities...");
	int i;
	for (i=0;i<LISTVF_ENTITIES.num();i++) {
		[LISTVF_ENTITIES.get(i).getTag()->regEvents()];
	}
	["statue"->regEvents()];
}


