 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/
 
#using stdlib game
#hive 1

float speed = 0.45;

vfile rock;
Resource res;
float3 GOTO_POS;
float elapsed=0.0;
float jump_y=2.0;
float rock_scale;
float on_target;

public void reset() {
	debugLog("Reset snowball");
	elapsed=0.0;
	jump_y=2.0;
	on_target=-1;
	this.hide();
	rock.show();
	rock.tempHide();
	rock.setPos( float3(0,0.6,0) );
	clearListeners(ON_TICK);
}
void init()  
{
	debugLog("Loading :"+getTag());
	this.setChannel("prox.radius",2.0);
	res=Resource("levelsets/traps/penguin.hvfs","cbResLoaded");	
}
void cbResLoaded() {
	rock=res.use("snowball","cbRockLoaded");
}
void cbRockLoaded() {
	addListener(ON_EVENT,"GOTO","e_goto");
	addListener(ON_ENTITYENTER,"e_enter");
	reset();
}
void e_goto(float3 _from,float3 _to) {
	this.setPos(_from);
	this.show();
	rock.tempShow();
	addListener(ON_TICK,"tick");
	GOTO_POS=_to;
	GOTO_POS.y( 2.33 );
	rock_scale=2;
	rock.setScale(float3(rock_scale,rock_scale,rock_scale));
	on_target=-1;
}
public void hide() {
	clearListeners(ON_TICK);
	this.hide();
	rock.temphide();
	elapsed=0;
	jump_y=2;
}
void tick() {
	if (!this.isVisible()) return;
	if (on_target>0) {
		on_target-=fElapsed();
		if (on_target<=0.0) {
			hide();
		}
		else {
			float s=rock_scale*(on_target/20.0);
			rock.setScale(float3(s,s,s));
			
			float3 r=rock.getRot();
			r.x( normalizeAngle(r.x()-fElapsed()*45.0) );
			rock.setRot(r);
		}
		return;
	}
	
	rock_scale=min(7.0,rock_scale+fElapsed()*0.5);
	rock.setScale(float3(rock_scale,rock_scale,rock_scale));	

	float3 rot=rock.getRot();
	rot.x( normalizeAngle(rot.x()-fElapsed()*45.0) );
	rock.setRot(rot);
	
	float3 oldp=this.getPos();
	oldp.y( 2.33 );
	if ( (oldp-GOTO_POS).xz().length() <= (fElapsed()*speed) ) {
		on_target=20;
		//hide();
	}
	else {
		elapsed+=fElapsed()*0.1;
		jump_y=MAX(0,jump_y-fElapsed()*0.05);
		this.setRot( oldp.lookat(GOTO_POS) );
		float3 norm=GOTO_POS-oldp;
		norm.normalize();
		this.setPos( oldp + (norm*(fElapsed()*speed)) +float3(0.0,abs(cos(elapsed))*jump_y,0.0) );
	}
} 
void e_enter(string _tag) {
	if (!this.isVisible()) { return; }
	if (on_target>0) { return; }
	if (_tag.startsWithNoCase("hero")) {
		on_target=20;
	}
	else if (_tag.startsWithNoCase("enemy")) {
		if (![_tag->isHit() as int]) {
			sendEvent("HIT",_tag);
			["hero"->playHitSound(this.getPos().xz())];
			on_target=20;
			//hide();
		}
	}	
}
public int isValid() {
	return int(this.isVisible() && on_target<0);
}

