 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib game
#hive 1

Resource res;
vfile tail,wings,fire;
float BASE_Y=2.33;

int CONST_WINGS=0;
int CONST_TAIL=1;
int CONST_FIRE=2;

int CURRENT_ITEM=0;

public void reset() {
	tail.setPos(float3(0,0,0));
	wings.setPos(float3(0,0,0));
	fire.setPos(float3(0,0,0));

	tail.show();
	wings.show();
	fire.show();

	tail.tempHide();
	wings.tempHide();
	fire.tempHide();
	
	this.hide();
	
	//reset listeners
	clearListeners(ON_TICK);
	clearListeners(ON_EVENT);
	clearListeners(ON_ENTITYENTER);
	clearListeners(ON_ENTITYLEAVE);
	clearListeners(ON_TIMEOUT_FRAMES);
}
public string getType() { return string(CURRENT_ITEM); }
void init() {
	//set entity tag
	setTag("statue");

	//load resource, this will mount the hvfs under "/.db/..."
	res=Resource("levelsets/generic/dragon_items.hvfs","resLoaded");
	
	this.hide();
}
void resLoaded() {
	tail=res.use("dragon_tail","");
	wings=res.use("dragon_wing","");
	fire=res.use("dragon_fire","");
	reset();
}
public void regEvents() {
}
void e_enter(string _tag) {
	if (this.isVisible() && (_tag=="hero")) {
		if (CURRENT_ITEM==CONST_WINGS) ["ui.play"->enableWings(0)];
		else if (CURRENT_ITEM==CONST_TAIL) ["ui.play"->enableTail(0)];
		else if (CURRENT_ITEM==CONST_FIRE) ["ui.play"->enableFire(0)];
		reset();
		addListener(ON_TIMEOUT_FRAMES,string((7+rand(14))*getFPS()),"respawn");
	}
}
void e_leave(string _tag) {
}
//start execution by ui.play
public void start() {
	addListener(ON_TIMEOUT_FRAMES,string(20*getFPS()),"respawn");
}

void respawn() {
	reset();
	//check for bunny
	listi l=listi();
	if (!["hero"->hasWings() as int]) l.push(CONST_WINGS);
	if (!["hero"->hasTail() as int]) l.push(CONST_TAIL);
	if (!["hero"->hasFire() as int]) l.push(CONST_FIRE);
	
	if (l.num()==0) return;
	l.shuffle();
	CURRENT_ITEM=l.get(0);
	
	//find available slot
	float3 pos=["ui.play"->getAvailableDragonSlot() as float3];
	if (pos.y()<0.0) {
		addListener(ON_TIMEOUT_FRAMES,string((5+rand(16))*getFPS()),"respawn");
		return;
	}
	
	if (CURRENT_ITEM==CONST_WINGS) wings.tempShow();
	else if (CURRENT_ITEM==CONST_TAIL) tail.tempShow();
	else if (CURRENT_ITEM==CONST_FIRE) fire.tempShow();
	
	this.setPos(pos+float3(0.0,10.0,0.0));
	this.setRot(hpr(float(rand(360)),0.0,0.0));
	this.show();	

	addListener(ON_TICK,"tick");
	addListener(ON_ENTITYENTER,"e_enter");
	addListener(ON_ENTITYLEAVE,"e_leave");
}
void tick() {
	this.setPos( this.getPos()+float3(0.0,-fElapsed()*0.2,0.0) );
	float3 p=this.getPos();	
	if (p.y()<=BASE_Y) {
		clearListeners(ON_TICK);
		p.y( BASE_Y );
		this.setPos(p);
	}
}

public void saveState() {
}
public void loadState() {
}
