 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib gui
#using chartboost

#hive 1

String APPNAME = "bunnymaze";
Layout HUD;
Widget loadring;
Widget ad;

void init() {
	setTag("ui.ad");
	warnLog(" *** UI.AD INIT");
	//add HUD container
	HUD=Layout();
	//HUD.hide();
	HUD.show();
	HUD.setBaseSize(800,480,"autofit");
	
	Widget bg=Widget(HUD,UI_ICON);
	bg.setSize("100%","100%");
	bg.setParam(PARAM_IMAGE,"LINEAR:textures/ui/bluebg.image");
	
	ad=Widget(HUD,UI_ICON);
	ad.setSize(128,64);
	ad.setPos(400,128);
	ad.hide();
	ad.setParam(PARAM_IMAGE,"LINEAR:textures/ui/ui_showingads.image");
	ad.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);

	loadring=Widget(HUD,UI_LOADRING);
	loadring.setPivot(PIVOTX_RIGHT,PIVOTY_BOTTOM);
	loadring.setSize(32,32);
	loadring.setPos(790,470);
	loadring.setParam(PARAM_ROTATION_SPEED,"-3");
	loadring.setParam(PARAM_FRAMERATE,"16");
	loadring.setParam(PARAM_LOADRING_SEGMENTS,"8");
	loadring.setParam(PARAM_LOADRING_SEGMENTS,"8");
	loadring.setParam(PARAM_IMAGE,"LINEAR:textures/ui/loadingprogressring.image");
	loadring.show();

	this.hide();
	
	addListener(ON_APPFOCUSLOST,"e_show");
	addListener(ON_APPFOCUS,"e_hide");
	addListener(ON_MOUSEDOWN,"e_hide");
}	
void e_show() {
	this.show();
	HUD.fadeIn(200,"");
}
void e_hide() {
	this.hide();
	ad.hide();
	HUD.hide();
}

public void hideAds(){
	ad.hide();
	if (["ui.home"->hasAds() as int]) {
		debugLog("Hide Ad");	
		chartboost_hide();	
		chartboost_cache();
	}
}

void polltoClose(){
	warnLog("Listening...");
	if (chartboost_isvisible())	{
		ad.fadeIn(100,"");		
		addListener(ON_TIMEOUT_MSEC,"1000","polltoClose");
		}
	else e_hide();
}

public void showAds(){
		if ( ["ui.home"->hasAds() as int] ) {
			chartboost_show();			
			addListener(ON_TIMEOUT_MSEC,"1000","polltoClose")
			return;
		}
	// int adprop=int(appPropertyGet(APPNAME,"adprob","15"));
	// adprop= 15;
	// stdLog("adprob: "+string(adprop));
	// if (chartboost_wasvisible(1)) {
		// stdLog(" *** AD DISPLAYED");
		// adprop-=5;
		// appPropertySet(APPNAME,"adprob",string(adprop));
		// appPropertyFlush();
	// }
	
	// int dice = clamp(adprop-5,2,10);
	// debugLog(" adprob:"+string(adprop)+ "  dice: "+string(dice));
	// dice = 30;
	// if ( ["ui.home"->hasAds() as int] && (rand(10)<dice) ) {
		// stdLog(" *** DISPLAYING AD");
		// HUD.show();
		// ad.show();
		// this.show();
		// chartboost_show();
	// }
}

public void cacheAds(){
	chartboost_cache();
}
