 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/
 
#using stdlib gui market gamepad analytics
#hive 1
String APPNAME = "bunnymaze";

Layout HUD,HUDBLACK;
Widget NOTEPAD,BBACK,BUNNY_MISSING;
//Widget STAR_MINPACK,STAR_MAXPACK;
Widget LABEL_MINPACK,LABEL_MAXPACK,BUTTON_MINPACK,BUTTON_MAXPACK,LABEL_MINPACK_COST,LABEL_MAXPACK_COST;
Widget ICON_MINPACK,ICON_MAXPACK,BUTTON_MINPACK_HIDDEN,BUTTON_MAXPACK_HIDDEN;
Widget LABEL_MISSINGSTARS;
Widget ICON_PURCHASE_PROGRESS;
Widget ICON_PURCHASE_OK;
Widget CURSOR,CURSOR_WIDGET;
Gamepad gpad;

string REPLYTAG,REPLYEVENT;
listi BILLING_SP;
lists BILLING_COST;
lists BILLING_ID;

string COLOR_ORANGE="180,90,20,255";
string COLOR_BROWN="130,80,40,255";

int PURCHASE_WAIT;

void init() {
	PURCHASE_WAIT=0;
	//initialize billing values
	BILLING_SP=listi();
	BILLING_COST=lists();
	BILLING_ID=lists();
	
	string appid = "com.eyelead."+APPNAME;
	//print("appname is "+APPNAME);
	
	BILLING_SP.push(30);  BILLING_COST.push("$0.99"); BILLING_ID.push(appid+".sp.a1");
	BILLING_SP.push(30);  BILLING_COST.push("$0.99"); BILLING_ID.push(appid+".sp.a2");	
	BILLING_SP.push(70);  BILLING_COST.push("$1.99"); BILLING_ID.push(appid+".sp.b1");
	BILLING_SP.push(70);  BILLING_COST.push("$1.99"); BILLING_ID.push(appid+".sp.b2");	
	BILLING_SP.push(150); BILLING_COST.push("$2.99"); BILLING_ID.push(appid+".sp.c1");//was 130
	BILLING_SP.push(150); BILLING_COST.push("$2.99"); BILLING_ID.push(appid+".sp.c2");	
	BILLING_SP.push(320); BILLING_COST.push("$3.99"); BILLING_ID.push(appid+".sp.d1");//was 260
	BILLING_SP.push(320); BILLING_COST.push("$3.99"); BILLING_ID.push(appid+".sp.d2");

	setTag("ui.billing");
	this.hide();
	
	//add HUD container
	HUD=Layout();
	HUD.setBaseSize(800,480,"autofit");
	
	HUDBLACK=Layout();
	HUDBLACK.setBaseSize(800,480,"autofit");
	HUDBLACK.enableGhost(1);

	Widget BG=Widget(HUD,UI_PANEL);
	BG.setParam(PARAM_COLOR,"0,0,0,220");
	
	BG=Widget(HUDBLACK,UI_PANEL);
	BG.setParam(PARAM_COLOR,"0,0,0,255");
	
	NOTEPAD=Widget(HUD,UI_ICON);
	NOTEPAD.setPivot(PIVOTX_CENTER,PIVOTY_TOP);	
	NOTEPAD.setSize(512,512);
	NOTEPAD.setPos(400,1000);
	NOTEPAD.setOpacity(0.0);
	NOTEPAD.setParam(PARAM_IMAGE,"LINEAR:textures/ui/notebook.image");
	
	BUNNY_MISSING=Widget(NOTEPAD,UI_ICON);
	BUNNY_MISSING.setParam(PARAM_IMAGE,"LINEAR:textures/ui/ui_billing_starsmissing.image");
	BUNNY_MISSING.setSize(512,256);
	BUNNY_MISSING.setPos(0,38);
	
	LABEL_MISSINGSTARS=Widget(BUNNY_MISSING,UI_TEXFONTLABEL);
	LABEL_MISSINGSTARS.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	LABEL_MISSINGSTARS.setSize(64,64);
	LABEL_MISSINGSTARS.setPos(330,129);
	LABEL_MISSINGSTARS.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font2.image");
	LABEL_MISSINGSTARS.setparam(PARAM_FONTSIZE,"41,41");
	LABEL_MISSINGSTARS.setparam(PARAM_FONTSPACING,"-0.35");
	LABEL_MISSINGSTARS.setparam(PARAM_TEXTALIGN,"center");
	LABEL_MISSINGSTARS.setparam(PARAM_COLOR,COLOR_ORANGE);
	
	ICON_MINPACK=Widget(NOTEPAD,UI_ICON);
	ICON_MINPACK.setPivot(PIVOTX_CENTER,PIVOTY_TOP);
	ICON_MINPACK.setParam(PARAM_IMAGE,"LINEAR:textures/ui/ui_billing_bag.image");
	ICON_MINPACK.setSize(128,128);
	ICON_MINPACK.setPos(155,260);

	ICON_MAXPACK=Widget(NOTEPAD,UI_ICON);
	ICON_MAXPACK.setPivot(PIVOTX_CENTER,PIVOTY_TOP);
	ICON_MAXPACK.setParam(PARAM_IMAGE,"LINEAR:textures/ui/ui_billing_bag.image");
	ICON_MAXPACK.setSize(128,128);
	ICON_MAXPACK.setPos(370,260); 	
	
	LABEL_MINPACK=Widget(ICON_MINPACK,UI_TEXFONTLABEL);
	LABEL_MINPACK.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	LABEL_MINPACK.setSize(64,64);
	LABEL_MINPACK.setPos(50,90);	
	LABEL_MINPACK.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font2.image");
	LABEL_MINPACK.setparam(PARAM_FONTSIZE,"32,32");
	LABEL_MINPACK.setparam(PARAM_FONTSPACING,"-0.42");
	LABEL_MINPACK.setparam(PARAM_TEXTALIGN,"center");
	LABEL_MINPACK.setparam(PARAM_COLOR,COLOR_BROWN);
	
	LABEL_MAXPACK=Widget(ICON_MAXPACK,UI_TEXFONTLABEL);
	LABEL_MAXPACK.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	LABEL_MAXPACK.setSize(64,64);
	LABEL_MAXPACK.setPos(50,90);
	LABEL_MAXPACK.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font2.image");
	LABEL_MAXPACK.setparam(PARAM_FONTSIZE,"32,32");
	LABEL_MAXPACK.setparam(PARAM_FONTSPACING,"-0.42");
	LABEL_MAXPACK.setparam(PARAM_TEXTALIGN,"center");
	LABEL_MAXPACK.setparam(PARAM_COLOR,COLOR_BROWN);
	
	BUTTON_MINPACK_HIDDEN=Widget(ICON_MINPACK,UI_PUSHBUTTON);
	BUTTON_MINPACK_HIDDEN.setSize(ICON_MINPACK.getW(),ICON_MINPACK.getH());
	
	BUTTON_MINPACK=Widget(ICON_MINPACK,UI_PUSHBUTTON);
	BUTTON_MINPACK.setPivot(PIVOTX_CENTER,PIVOTY_TOP);
	BUTTON_MINPACK.setSize(256,64);
	BUTTON_MINPACK.setPos(50,120);
	BUTTON_MINPACK.setParam(PARAM_THEME,"LINEAR:textures/ui/ui_buy_normal.image,textures/ui/ui_buy_normal.image,textures/ui/ui_buy_pressed.image");
	
	BUTTON_MAXPACK_HIDDEN=Widget(ICON_MAXPACK,UI_PUSHBUTTON);
	BUTTON_MAXPACK_HIDDEN.setSize(ICON_MAXPACK.getW(),ICON_MAXPACK.getH());
	
	BUTTON_MAXPACK=Widget(ICON_MAXPACK,UI_PUSHBUTTON);
	BUTTON_MAXPACK.setPivot(PIVOTX_CENTER,PIVOTY_TOP);
	BUTTON_MAXPACK.setSize(256,64);
	BUTTON_MAXPACK.setPos(50,120);
	BUTTON_MAXPACK.setParam(PARAM_THEME,"LINEAR:textures/ui/ui_buy_normal.image,textures/ui/ui_buy_normal.image,textures/ui/ui_buy_pressed.image");
	
	LABEL_MINPACK_COST=Widget(BUTTON_MINPACK,UI_TEXFONTLABEL);
	LABEL_MINPACK_COST.enableGhost(1);
	LABEL_MINPACK_COST.setSize(64,64);
	LABEL_MINPACK_COST.setPos(125,-4);
	LABEL_MINPACK_COST.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font.image");
	LABEL_MINPACK_COST.setparam(PARAM_FONTSIZE,"28,28");
	LABEL_MINPACK_COST.setparam(PARAM_FONTSPACING,"-0.4");
	LABEL_MINPACK_COST.setparam(PARAM_TEXTALIGN,"left");
	
	LABEL_MAXPACK_COST=Widget(BUTTON_MAXPACK,UI_TEXFONTLABEL);
	LABEL_MAXPACK_COST.enableGhost(1);
	LABEL_MAXPACK_COST.setSize(64,64);
	LABEL_MAXPACK_COST.setPos(125,-4);
	LABEL_MAXPACK_COST.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font.image");
	LABEL_MAXPACK_COST.setparam(PARAM_FONTSIZE,"28,28");
	LABEL_MAXPACK_COST.setparam(PARAM_FONTSPACING,"-0.4");
	LABEL_MAXPACK_COST.setparam(PARAM_TEXTALIGN,"left");
	
	ICON_PURCHASE_PROGRESS=Widget(NOTEPAD,UI_ICON);
	ICON_PURCHASE_PROGRESS.setSize(512,512);
	ICON_PURCHASE_PROGRESS.setParam(PARAM_IMAGE,"LINEAR:textures/ui/ui_billing_wait.image");
	ICON_PURCHASE_OK=Widget(NOTEPAD,UI_ICON);
	ICON_PURCHASE_OK.setSize(512,256);
	ICON_PURCHASE_OK.setPos(0,128);
	ICON_PURCHASE_OK.setParam(PARAM_IMAGE,"LINEAR:textures/ui/ui_billing_transactionok.image");
	ICON_PURCHASE_PROGRESS.hide();
	ICON_PURCHASE_OK.hide();
	
	BBACK=Widget(NOTEPAD,UI_PUSHBUTTON);
	BBACK.setPivot(PIVOTX_RIGHT,PIVOTY_TOP);
	BBACK.setSize(64,64);
	BBACK.setparam(PARAM_THEME,"LINEAR:textures/ui/menu_close_window.image,textures/ui/menu_close_window.image,textures/ui/menu_close_window_pressed.image");
	BBACK.setPos(490,50);	
	BBACK.setparam(PARAM_ONCLICK,"cbBack");	
	
	CURSOR=Widget(HUD,UI_ICON);
	CURSOR.setPivot(PIVOTX_LEFT,PIVOTY_TOP);
	CURSOR.setSize(64,64);
	CURSOR.setParam(PARAM_IMAGE,"LINEAR:textures/ui/hand-cursor.image");
	CURSOR.hide();
	CURSOR.enableGhost(1);
	
	gpad=Gamepad();
	
	//market_lgsmartworld_start("3242","ITM492023");
	market_onPurchaseEvent("cbPurchaseEvent");
}
public void open(int _required) {
	clearListeners(ON_MOUSEDOWN);
	BUNNY_MISSING.show();
	ICON_PURCHASE_PROGRESS.hide();
	ICON_PURCHASE_OK.hide();

	CURSOR.hide();
	CURSOR_WIDGET=BBACK;
	gpad.onButtonDown("");

	int i,num;
	int minval=BILLING_SP.get(0);
	int maxval=minval;
	string mincost=BILLING_COST.get(0);
	string maxcost=mincost;
	string minid=BILLING_ID.get(0);
	string maxid=minid;
	
	//find min cost
	num=BILLING_SP.num();
	for (i=0;i<num;i++) {
		if (BILLING_SP.get(i)>=_required) {
			if (!(market_ispurchased(BILLING_ID.get(i)))) {
				minval=BILLING_SP.get(i);
				mincost=BILLING_COST.get(i);
				minid=BILLING_ID.get(i);
				break;
			}
		}
	}
	
	//find max cost
	for (i=BILLING_SP.num()-1;i>=0;i--) {
		if (!(market_ispurchased(BILLING_ID.get(i)))) {
			if (BILLING_SP.get(i)>=maxval) {
				maxval=BILLING_SP.get(i);
				maxcost=BILLING_COST.get(i);
				maxid=BILLING_ID.get(i);
			}
		}
	}
	
	LABEL_MISSINGSTARS.setparam(PARAM_TEXT,string(_required)+"`");	
	
	if (market_hasbilling() || int(appPropertyGet(APPNAME,"billing_ui","0"))) {
		ICON_MINPACK.show();
		ICON_MAXPACK.show();
		analytics_trackview("/billing/supported");
	}
	else {
		ICON_MINPACK.hide();
		ICON_MAXPACK.hide();
		analytics_trackview("/billing/unsupported");
	}
	
	LABEL_MINPACK.setparam(PARAM_TEXT,string(minval));
	LABEL_MAXPACK.setparam(PARAM_TEXT,string(maxval));
	
	LABEL_MINPACK_COST.setparam(PARAM_TEXT,mincost);
	LABEL_MAXPACK_COST.setparam(PARAM_TEXT,maxcost);
	
	if (market_ispurchased(minid)) {
		ICON_MINPACK.hide();
	}
	else {
		BUTTON_MINPACK.setParam(PARAM_ONCLICK,"cbBuy("+minid+")");
		BUTTON_MINPACK_HIDDEN.setParam(PARAM_ONCLICK,"cbBuy("+minid+")");
	}
	
	if (market_ispurchased(maxid)) {
		ICON_MAXPACK.hide();
	}
	else {
		BUTTON_MAXPACK.setParam(PARAM_ONCLICK,"cbBuy("+maxid+")");
		BUTTON_MAXPACK_HIDDEN.setParam(PARAM_ONCLICK,"cbBuy("+maxid+")");
	}
	
	HUD.enableGhost(0);
	this.show();
	HUD.fadeIn(200,"");
	NOTEPAD.clearAnimate("");
	NOTEPAD.animate("Y","1000:0;-10:400;0:800","open_end");
	NOTEPAD.animate("A","L0:0;L1:600","");
	
	if (PURCHASE_WAIT) {
		ICON_MINPACK.hide();
		ICON_MAXPACK.hide();
		BUNNY_MISSING.hide();
		ICON_PURCHASE_PROGRESS.show();
		ICON_PURCHASE_PROGRESS.show();
	}
}
void open_end() {
	gpad.onButtonDown("cbGamepad");
}
public void open_thanks() {
	clearListeners(ON_MOUSEDOWN);
	CURSOR.hide();
	CURSOR_WIDGET=BBACK;
	gpad.onButtonDown("");
	ICON_MINPACK.hide();
	ICON_MAXPACK.hide();
	BUNNY_MISSING.hide();
	ICON_PURCHASE_PROGRESS.hide();
	ICON_PURCHASE_OK.show();

	HUD.enableGhost(0);
	this.show();
	HUD.fadeIn(200,"");
	NOTEPAD.clearAnimate("");
	NOTEPAD.animate("Y","1000:0;-10:400;0:800","open_thanks_end");
	NOTEPAD.animate("A","L0:0;L1:600","");
}
void open_thanks_end() {
	addListener(ON_MOUSEDOWN,"cbMouseThanks");
	gpad.onButtonDown("cbGamepadThanks");
}
public void restorePurchases() {
	market_restorePurchases();
}
void cbBack() {
	clearListeners(ON_MOUSEDOWN);
	gpad.onButtonDown("");
	HUD.enableGhost(1);
	HUD.fadeOut(700,"cbBackEnd");
	
	NOTEPAD.clearAnimate("");
	NOTEPAD.animate("Y","0:0;-10:300;1000:700","");
	NOTEPAD.animate("A","L1:0;L1:500;0:700","");
}
void cbBackEnd() {
	this.hide();
	["ui.home"->billingOff()];
}
public int isLoaded() { return 1; }
public int getPurchasedStars() {
	int i,num,ret=0;
	num=BILLING_SP.num();
	for (i=0;i<num;i++) {
		if (market_ispurchased(BILLING_ID.get(i))) ret+=BILLING_SP.get(i);
	}
	return ret;
}
public int getNoAds() {
	if (["ui.init"->isIos() as int] || ["ui.init"->isKindle() as int]) return 1;
	return market_ispurchased("com.eyelead.bunnymaze.noads");
}
public void buyNoAds() {
	if (market_hasbilling()) {
		analytics_trackview("/billing/purchase/com.eyelead.bunnymaze.noads");
		analytics_dispatch();
		market_makepurchase("com.eyelead.bunnymaze.noads");
	}
}
string PURCHASE_ID;
void cbBuy(string _val) {
	PURCHASE_ID=_val;
	delListener(ON_TIMEOUT_MSEC,"cbMakePurchase");
	addListener(ON_TIMEOUT_MSEC,"500","cbMakePurchase");
	//fCall("cbBuyFade("+_val+")");
	// if (["ui.init"->isIos() as int] || ["ui.init"->isKindle() as int]) {fCall("cbBuyFade("+_val+")"); }
	// else { HUDBLACK.fadeIn(500,"cbBuyFade("+_val+")"); fCall("cbBuyFade("+_val+")"); }
}

//void cbBuyFade(string _val) {}
void cbMakePurchase() {
	analytics_trackview("/billing/purchase/"+PURCHASE_ID);
	analytics_dispatch();
	market_makepurchase(PURCHASE_ID);
	if (["ui.init"->isIos() as int] || ["ui.init"->isKindle() as int]) { cbBack(); }
}
void cbGamepadThanks(int _controller,int _action) {
	if (gpad.isABXY(_action)) { cbBack(); }
}
void cbMouseThanks() { cbBack();}


void cbGamepad(int _controller,int _action) {
	if (_action==GAMEPAD_B) {
		cbBack();
		return;
	}
	if (gpad.isDPAD(_action) || gpad.isABXY(_action)) {
		if (CURSOR.isVisible()) {
			if (_action==GAMEPAD_UP) {
				if (CURSOR_WIDGET==BBACK) {	
					if (BUTTON_MAXPACK.isVisible()) CURSOR_WIDGET=BUTTON_MAXPACK; 
					else if (BUTTON_MINPACK.isVisible()) CURSOR_WIDGET=BUTTON_MINPACK; 
				}
				else if (CURSOR_WIDGET==BUTTON_MAXPACK) {	
					if (BUTTON_MINPACK.isVisible()) CURSOR_WIDGET=BUTTON_MINPACK; 
				}				
			}
			else if (_action==GAMEPAD_DOWN) {
				if (CURSOR_WIDGET==BUTTON_MINPACK) {	
					if (BUTTON_MAXPACK.isVisible()) CURSOR_WIDGET=BUTTON_MAXPACK; 
					else CURSOR_WIDGET=BBACK; 
				}
				else if (CURSOR_WIDGET==BUTTON_MAXPACK) {	
					CURSOR_WIDGET=BBACK; 
				}
			}
			else if (_action==GAMEPAD_A) {
				CURSOR_WIDGET.doAction();
			}			
		}
		else {
			CURSOR.show();
		}
		//position cursor
		CURSOR.setParent(CURSOR_WIDGET);
		CURSOR.setPos( (CURSOR_WIDGET.getW()*2)/3,CURSOR_WIDGET.getH()/2);			
	}
}
void cbPurchaseEvent(int _event) {
	if (_event==PURCHASE_STATECHANGED) {
		PURCHASE_WAIT=0;
		["ui.home"->refreshScore()];
	}
	else if (_event==PURCHASE_CANCELED) {
		PURCHASE_WAIT=0;
	}
	else if (_event==PURCHASE_REQUESTED) {
		PURCHASE_WAIT=1;
	}
	else if (_event==PURCHASE_RESTOREFINISHED) {
		["ui.home"->finishPurchaseRestore()];	
	}
}

