 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib gui gamepad sound
#hive 1

String APPNAME = "bunnymaze";

Layout HUD;
Widget BRIEF_LEVEL,BRIEF_CARROT,BRIEF_CARROT_X_ICON,BRIEF_TIME,BRIEF_EQUAL_CARROT,BRIEF_EQUAL_TIME,BRIEF_ICON_CARROT,BRIEF_ICON_TIME,TAPTOCONTINUE;
Widget BEST_PARENT,BRIEF_BEST, BRIEF_IMG_BEST;
string REPLY_TAG,REPLY_EVENT;

Gamepad gpad;
Sound snd;

int FONT_SIZE=60;


void showbest(){
	string CURRENT_THEME=["sc.loader"->getTheme() as string];
	string CURRENT_LEVEL=["sc.loader"->getLevel() as string];
	int carrots = ["ui.home"->getCarrots(CURRENT_THEME, CURRENT_LEVEL) as int];
	if (carrots >0){
		BRIEF_BEST.setParam(PARAM_TEXT,":"+string(carrots))
		BEST_PARENT.show();		
		int x = BEST_PARENT.getX();
		BEST_PARENT.clearAnimate("");
		BEST_PARENT.animate("X",string(x-50)+":100;"+string(x)+":400;","");
		BEST_PARENT.fadeIn(400,"");
	}

}
void setupFont(Widget _label,int _size,string _align,int _variant) {
	if (_variant) _label.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font2.image");
	else _label.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font.image");

	_label.setparam(PARAM_FONTSIZE,string(_size)+","+_size);
	_label.setparam(PARAM_FONTSPACING,"-0.45");
	_label.setparam(PARAM_TEXTALIGN,_align);
	_label.setSize(_size,_size);
	_label.enableGhost(1);
}

void init() {
	setTag("ui.brief");

	gpad=Gamepad();
	
	//add HUD container
	HUD=Layout();
	HUD.setBaseSize(800,480,"autofit");
	HUD.show();

	TAPTOCONTINUE=Widget(HUD,UI_ICON);
	TAPTOCONTINUE.setSize(64,64);
	TAPTOCONTINUE.setPivot(PIVOTX_RIGHT,PIVOTY_BOTTOM);
	TAPTOCONTINUE.setPos(790,470);
	TAPTOCONTINUE.setparam(PARAM_IMAGE,"LINEAR:textures/ui/ui_taptocontinue_normal.image");
	
	BEST_PARENT = WidgeT(HUD,UI_WIDGET);
	BEST_PARENT.setPos(495,440);

	string best_color="240,90,20,255";
	BRIEF_BEST=Widget(BEST_PARENT,UI_TEXFONTLABEL);
	setupFont(BRIEF_BEST,40,"left",1);
	BRIEF_BEST.setParam(PARAM_FONTSPACING,"-0.50")	
	BRIEF_BEST.setPos(0,0);
	BRIEF_BEST.setParam(PARAM_COLOR,best_color);
	BRIEF_BEST.setPivot(PIVOTX_LEFT,PIVOTY_BOTTOM);
	BRIEF_BEST.setParam(PARAM_TEXT,":00000");

	BRIEF_IMG_BEST 	= Widget(BEST_PARENT, UI_ICON);
	BRIEF_IMG_BEST.setparam(PARAM_IMAGE,"LINEAR:textures/ui/debrief_best.image");
	BRIEF_IMG_BEST.setPos(17,8);
	BRIEF_IMG_BEST.setSize(64,64);
	BRIEF_IMG_BEST.setPivot(PIVOTX_RIGHT,PIVOTY_BOTTOM);



	BRIEF_LEVEL=Widget(HUD,UI_TEXFONTLABEL);
	setupFont(BRIEF_LEVEL,50,"center",0);
	BRIEF_LEVEL.setPivot(PIVOTX_CENTER,PIVOTY_TOP);
	BRIEF_LEVEL.setPos(400,70);
	BRIEF_LEVEL.setparam(PARAM_FONTSPACING,"-0.55");

	BRIEF_ICON_CARROT=Widget(HUD,UI_ICON);
	BRIEF_ICON_CARROT.setParam(PARAM_IMAGE,"LINEAR:textures/ui/briefing_star.image");
	BRIEF_ICON_CARROT.setPivot(PIVOTX_RIGHT,PIVOTY_MIDDLE);	
	BRIEF_ICON_CARROT.setSize( 128, 128 );
	BRIEF_ICON_CARROT.setPos(380,190);

	BRIEF_EQUAL_CARROT=Widget(HUD,UI_TEXFONTLABEL);
	setupFont(BRIEF_EQUAL_CARROT,FONT_SIZE,"center",1);
	BRIEF_EQUAL_CARROT.setparam(PARAM_TEXT,"=");	
	BRIEF_EQUAL_CARROT.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);	
	BRIEF_EQUAL_CARROT.setSize(1,50);
	BRIEF_EQUAL_CARROT.setPos(408,190);
	
	BRIEF_CARROT=Widget(HUD,UI_TEXFONTLABEL);
	setupFont(BRIEF_CARROT,FONT_SIZE,"left",1);
	BRIEF_CARROT.setPivot(PIVOTX_LEFT,PIVOTY_MIDDLE);
	BRIEF_CARROT.setPos(420,190);
	BRIEF_CARROT.setParam(PARAM_TEXT,"0");

	BRIEF_CARROT_X_ICON=Widget(BRIEF_CARROT,UI_ICON);
	BRIEF_CARROT_X_ICON.setSize(64,64);
	BRIEF_CARROT_X_ICON.setParam(PARAM_IMAGE,"LINEAR:textures/ui/briefing_carrot.image");
	BRIEF_CARROT_X_ICON.setPos(65,-7);
	
	BRIEF_ICON_TIME=Widget(HUD,UI_ICON);
	BRIEF_ICON_TIME.setParam(PARAM_IMAGE,"LINEAR:textures/ui/briefing_clock.image");
	BRIEF_ICON_TIME.setPivot(PIVOTX_RIGHT,PIVOTY_MIDDLE);
	BRIEF_ICON_TIME.setSize( 128, 128 );
	BRIEF_ICON_TIME.setPos(380,315);

	BRIEF_EQUAL_TIME=Widget(HUD,UI_TEXFONTLABEL);
	setupFont(BRIEF_EQUAL_TIME,FONT_SIZE,"center",1);
	BRIEF_EQUAL_TIME.setparam(PARAM_TEXT,"=");
	BRIEF_EQUAL_TIME.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);	
	BRIEF_EQUAL_TIME.setSize(1,50);
	BRIEF_EQUAL_TIME.setPos(408,315);
	
	
	BRIEF_TIME=Widget(HUD,UI_TEXFONTLABEL);
	setupFont(BRIEF_TIME,FONT_SIZE,"left",1);
	BRIEF_TIME.setPivot(PIVOTX_LEFT,PIVOTY_MIDDLE);
	BRIEF_TIME.setPos(420,315);
	BRIEF_TIME.setParam(PARAM_TEXT,"0");
		
	//string font_color="70,38,0,255";
	string font_color="160,90,30,255";
		
	BRIEF_EQUAL_CARROT.setParam(PARAM_COLOR,font_color);
	BRIEF_CARROT.setParam(PARAM_COLOR,font_color);
	BRIEF_EQUAL_TIME.setParam(PARAM_COLOR,font_color);
	BRIEF_TIME.setParam(PARAM_COLOR,font_color);	
	
	vfile vfsnd;
	vfsnd=vfopen("/sector/ui.sound","r");
	snd=Sound(vfsnd);
	fCall("e_volume");
	
	addListener(ON_EVENT,"SHOW","e_show");
	addListener(ON_EVENT,"HIDE","e_hide");
	addListener(ON_EVENT,"VOLUME","e_volume");
}
void e_volume() {
	if (snd) snd.setVolume(float(appPropertyGet(APPNAME,"sfxvol","1.0")));
}
void e_hide() {	
	["ui.ad"->hideAds()];
	HUD.fadeOut(200,"cbHide");
}
void cbHide() {
	this.hide();
}
void e_show(int _level,int _carrots,int _time,string _replytag,string _replyevent,int _fromrestart) {
	this.show();
	HUD.hide();
	HUD.fadeIn(200,"");
	REPLY_TAG=_replytag;
	REPLY_EVENT=_replyevent;
	string theme=["sc.loader"->getTheme() as string];
	theme=["ui.home"->themeToName(theme) as string];
	BRIEF_LEVEL.setParam(PARAM_TEXT,"# "+theme +" - "+_level); // LEVEL
	BRIEF_TIME.setParam(PARAM_TEXT,string(_time)+ascii(34));
	BRIEF_CARROT.setParam(PARAM_TEXT,string(_carrots));
	//BRIEF_CARROT_X_ICON.setPos((string(_carrots)).length()*21 + 25,-7);
	BRIEF_CARROT_X_ICON.setPos((string(_carrots)).length()*FONT_SIZE*0.553,-3);


	BEST_PARENT.hide();
	BRIEF_CARROT.hide();
	BRIEF_TIME.hide();
	BRIEF_EQUAL_CARROT.hide();
	BRIEF_EQUAL_TIME.hide();
	BRIEF_ICON_CARROT.hide();
	BRIEF_ICON_TIME.hide();
	TAPTOCONTINUE.clearAnimate("");
	TAPTOCONTINUE.setOpacity(0.0);
	
	if (_fromrestart) fCall("cbSkipBrief");
	else addListener(ON_TIMEOUT_MSEC,"1000","cbBrief1");
}
void cbTapAnim() {
	if (!this.isVisible()) return;
	TAPTOCONTINUE.animate("A","L1:0;L1:300;L0.1:1300","cbTapAnim");
}
void cbSkipBrief() {
	delListener(ON_TIMEOUT_MSEC,"cbBrief1");
	delListener(ON_TIMEOUT_MSEC,"cbBrief2");
	delListener(ON_TIMEOUT_MSEC,"cbBrief3");
	delListener(ON_TIMEOUT_MSEC,"cbBrief4");
	delListener(ON_TIMEOUT_MSEC,"cbBrief5");
	delListener(ON_TIMEOUT_MSEC,"cbBrief6");
	delListener(ON_TIMEOUT_MSEC,"cbBrief7");	
	showbest();
	clearListeners(ON_MOUSEUP);
	gpad.onButtonDown("cbTapToStart");
	addListener(ON_MOUSEUP,"cbTapToStart");
	BRIEF_CARROT.show();
	BRIEF_TIME.show();
	BRIEF_EQUAL_CARROT.show();
	BRIEF_EQUAL_TIME.show();
	BRIEF_ICON_CARROT.show();
	BRIEF_ICON_TIME.show();
	addListener(ON_TIMEOUT_MSEC,"1000","cbTapAnim");	
}
void cbBrief1() {
	snd.fplay("sounds/win1.audio");
	BRIEF_ICON_CARROT.show();	
	addListener(ON_TIMEOUT_MSEC,"100","cbBrief2");
	addListener(ON_MOUSEUP,"cbSkipBrief");
	gpad.onButtonDown("cbSkipBrief");	
}
void cbBrief2() {
	snd.fplay("sounds/win1.audio");
	BRIEF_EQUAL_CARROT.show();
	addListener(ON_TIMEOUT_MSEC,"100","cbBrief3");
}
void cbBrief3() {
	snd.fplay("sounds/win1.audio");
	BRIEF_CARROT.show();
	addListener(ON_TIMEOUT_MSEC,"1000","cbBrief4");
}
void cbBrief4() {
	snd.fplay("sounds/win1.audio");
	BRIEF_ICON_TIME.show();
	addListener(ON_TIMEOUT_MSEC,"100","cbBrief5");
}
void cbBrief5() {
	snd.fplay("sounds/win1.audio");
	BRIEF_EQUAL_TIME.show();
	addListener(ON_TIMEOUT_MSEC,"100","cbBrief6");
}
void cbBrief6() {
	snd.fplay("sounds/win1.audio");
	BRIEF_TIME.show();
	addListener(ON_TIMEOUT_MSEC,"1000","cbBrief7");
}
void cbBrief7() {
	//find best score
	showbest();


	//tap to start
	clearListeners(ON_MOUSEUP);
	addListener(ON_MOUSEUP,"cbTapToStart");
	gpad.onButtonDown("cbTapToStart");	
	addListener(ON_TIMEOUT_MSEC,"1000","cbTapAnim");		
}
void cbTapToStart() {
	gpad.onButtonDown("");	
	clearListeners(ON_MOUSEUP);
	sendEvent(REPLY_EVENT,REPLY_TAG);
}
