 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib gui gamepad
#hive 1

Layout HUD,HUDBLACK;
Widget NOTEPAD,TAPTOCONTINUE,LABEL_VERSION;
Gamepad gpad;
int loaded;
string version="1.2.5";
string APPTITLE="Bunny Maze 3D";

void init() {
	setTag("ui.credits");
	this.hide();
	
	//add HUD container
	HUD=Layout();
	HUD.setBaseSize(800,480,"autofit");
	
	HUDBLACK=Layout();
	HUDBLACK.setBaseSize(800,480,"autofit");
	HUDBLACK.enableGhost(1);

	Widget BG=Widget(HUD,UI_PANEL);
	BG.setParam(PARAM_COLOR,"0,0,0,220");
	
	BG=Widget(HUDBLACK,UI_PANEL);
	BG.setParam(PARAM_COLOR,"0,0,0,255");
	
	NOTEPAD=Widget(HUD,UI_ICON);
	NOTEPAD.setPivot(PIVOTX_CENTER,PIVOTY_TOP);	
	NOTEPAD.setSize(512,512);
	NOTEPAD.setPos(400,1000);
	NOTEPAD.setOpacity(0.0);

	//NOTEPAD2=Widget(NOTEPAD,UI_ICON);
	//NOTEPAD2.setSize(512,512);
	//NOTEPAD2.setOpacity(0.0);
			
	TAPTOCONTINUE=Widget(HUD,UI_ICON);
	TAPTOCONTINUE.setPivot(PIVOTX_RIGHT,PIVOTY_BOTTOM);
	TAPTOCONTINUE.setSize(64,64);
	TAPTOCONTINUE.setPos(790,470);
	TAPTOCONTINUE.setOpacity(0.0);
	TAPTOCONTINUE.setparam(PARAM_IMAGE,"LINEAR:textures/ui/ui_taptocontinue_normal.image");	
	
	LABEL_VERSION=Widget(HUD,UI_TEXFONTLABEL);
	LABEL_VERSION.setPivot(PIVOTX_LEFT,PIVOTY_BOTTOM);	
	LABEL_VERSION.setSize(16,16);
	LABEL_VERSION.setPos(5,475);
	LABEL_VERSION.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font2.image");
	LABEL_VERSION.setparam(PARAM_FONTSIZE,"12,12");
	LABEL_VERSION.setparam(PARAM_FONTSPACING,"-0.465");
	LABEL_VERSION.setparam(PARAM_TEXTALIGN,"left");
	LABEL_VERSION.setparam(PARAM_TEXT,APPTITLE+" v"+version);
		
	gpad=Gamepad();
	
	loaded=0;
}
void cbTapAnim() {
	if (!this.isVisible()) return;
	TAPTOCONTINUE.animate("A","L0:0;L1:500","");
}
void cbLoaded() {
	HUD.enableGhost(0);
	this.show();
	HUD.fadeIn(200,"");
	NOTEPAD.clearAnimate("");
	//NOTEPAD2.clearAnimate("");
	NOTEPAD.setOpacity(0.0);
	//NOTEPAD2.setOpacity(0.0);
	NOTEPAD.animate("Y","1000:0;-10:400;0:800","open_end");
	NOTEPAD.animate("A","L0:0;L1:600","");
	
	TAPTOCONTINUE.clearAnimate("");
	TAPTOCONTINUE.setOpacity(0.0);
}
public void open() {
	gpad.onButtonDown("");
	clearListeners(ON_MOUSEUP);
	if (!loaded) {
		loaded=1;
		//NOTEPAD2.setParam(PARAM_IMAGE,"LINEAR:textures/ui/info2.image");		
		NOTEPAD.setParam(PARAM_IMAGE,"LINEAR:textures/ui/info.image");
		NOTEPAD.onLoad("cbLoaded");
	}
	else {
		cbLoaded();
	}
}
void open_end() {
	gpad.onButtonDown("cbGamepad2");
	addListener(ON_MOUSEUP,"cbBack");
	cbTapAnim();	
}
void cbBack() {
	clearListeners(ON_MOUSEUP);
	gpad.onButtonDown("");
	HUD.enableGhost(1);
	HUD.fadeOut(700,"cbBackEnd");
	
	NOTEPAD.clearAnimate("");
	NOTEPAD.animate("Y","0:0;-10:300;1000:700","");
	NOTEPAD.animate("A","L1:0;L1:500;0:700","");
}
void cbBackEnd() {
	this.hide();
	["ui.home"->billingOff()];
}
public int isLoaded() { return 1; }


void cbGamepad2(int _controller,int _action) {
	if (_action==GAMEPAD_B || _action==GAMEPAD_A) {
		cbBack();
		return;
	}
}

