 /****************************************************************************
 * This file is part of Bunny Maze Application                               *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/
#hive 1
#using stdlib gui gamepad sound network

String APPNAME = "bunnymaze";
Layout HUD;
Widget DEBRIEF_SCISSOR1,DEBRIEF_SCISSOR2,DEBRIEF_SCISSOR3,DEBRIEF_STARBG1,DEBRIEF_STARBG2,DEBRIEF_STARBG3,DEBRIEF_STARFG1,DEBRIEF_STARFG2,DEBRIEF_STARFG3,DEBRIEF_TEXT,DEBRIEF_TEXT_CARROT;
Widget DEBRIEF_STAR1_FLASH1,DEBRIEF_STAR1_FLASH2,DEBRIEF_STAR2_FLASH1,DEBRIEF_STAR2_FLASH2,DEBRIEF_STAR3_FLASH1,DEBRIEF_STAR3_FLASH2;
Widget DEBRIEF_MENU,DEBRIEF_NEXT,DEBRIEF_RETRY;
Widget DEBRIEF_IMG_BEST, DEBRIEF_IMG_CLUNNIES, DEBRIEF_IMG_PUS, DEBRIEF_IMG_CARROTS, DEBRIEF_IMG_TIME;
Widget DEBRIEF_BEST,LABEL_LEVEL;
Widget CURSOR,CURSOR_WIDGET;
Widget STARS_TOTAL;
Widget bfacebook, NOTEPAD;
Widget btwitter;
Widget prev_icon;
String CURRENT_THEME, CURRENT_LEVEL;
int TARGET_COUNT, PREV_TARGET_COUNT;

int CURRENT_SCORE_COUNT;
int SCORE_COUNT;
int TOTAL_COUNT;
int COLLECTED_CARROTS;
int BONUS_POWERUP,BONUS_JUMP,BONUS_TIME;
//int BONUSFACTOR_POWERUP = 3;
//int BONUSFACTOR_JUMP = 1;
//int BONUSFACTOR_TIME = 3

Sound snd;

float CONST_PERC_STAR1 = 0.5;
float CONST_PERC_STAR2 = 1.0;
float CONST_PERC_STAR3 = 1.5;

Gamepad gpad;

int PREV_STAR,PREV_TOTALSTARS,NEXT_TOTALSTARS;
int ICON_OFFSET = 30;


void setupFont(Widget _label,int _size,string _align,int _variant) {
	if (_variant) _label.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font2.image");
	else _label.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font.image");
	_label.setparam(PARAM_FONTSIZE,string(_size)+","+_size);
	_label.setparam(PARAM_FONTSPACING,"-0.45");
	_label.setparam(PARAM_TEXTALIGN,_align);
	_label.setSize(_size,_size);
	_label.enableGhost(1);
}

void setup_count_icon(Widget widget){
	widget.setSize(100,100);
	widget.setPos(355,200);
	widget.setPivot(PIVOTX_RIGHT,PIVOTY_TOP);
	widget.hide();
	widget.enableGhost(1);
	widget.show();
}

void hide_icons(){
	DEBRIEF_IMG_CLUNNIES.clearAnimate("");
	DEBRIEF_IMG_CLUNNIES.hide();

	DEBRIEF_IMG_PUS.clearAnimate("");
	DEBRIEF_IMG_PUS.hide();

	DEBRIEF_IMG_BEST.clearAnimate("");
	DEBRIEF_IMG_BEST.hide();

	DEBRIEF_IMG_CARROTS.clearAnimate("");
	DEBRIEF_IMG_CARROTS.hide();

	DEBRIEF_IMG_TIME.clearAnimate("");
	DEBRIEF_IMG_TIME.hide();
}
void toggle_icon(Widget icon){
	// warnLog(icon.getParam(PARAM_IMAGE));
	if (prev_icon == icon) return;
	hide_icons();
	int y = icon.getY();
	icon.clearAnimate("");
	icon.animate("Y",string(y+30)+":0;L"+string(y)+":200","");
	icon.fadeIn(200,"");
	prev_icon = icon;
}

void big_best(){
	snd.fplay("sounds/collect_stone.audio");
	DEBRIEF_IMG_BEST.setPos(350,180);
	DEBRIEF_IMG_BEST.setSize(128,128);
	DEBRIEF_IMG_BEST.clearAnimate("");
	DEBRIEF_IMG_BEST.animate("W","600:0;L126:220;L128:300","");
	DEBRIEF_IMG_BEST.animate("H","600:0;L126:220;L128:300","");
	DEBRIEF_IMG_BEST.fadeIn(300,"");
	//DEBRIEF_IMG_BEST.show();
}

void center_text(){
	DEBRIEF_TEXT.setPos(360,220);
}

void top_text(){
	DEBRIEF_TEXT.setPos(360,195);
}

void showBestScore( ){
	if (SCORE_COUNT < TOTAL_COUNT* CONST_PERC_STAR1 ) return;
	
	CURRENT_THEME=["sc.loader"->getTheme() as string];
	CURRENT_LEVEL=["sc.loader"->getLevel() as string];

	//stdLog("theme:" + CURRENT_THEME + " level: "+ CURRENT_LEVEL);
	int carrots = ["ui.home"->setMaxCarrots(SCORE_COUNT,CURRENT_THEME, CURRENT_LEVEL) as int];
	
	if ( SCORE_COUNT >=carrots){
		if (carrots < 1) {
			big_best();
			DEBRIEF_BEST.setParam(PARAM_TEXT,"(Best Score)"); 
			}
		else {
			big_best();
			DEBRIEF_BEST.setParam(PARAM_TEXT,"*Improved Score!*"); 
		} 
	} else  {

		DEBRIEF_BEST.setParam(PARAM_TEXT,"(best:"+string(carrots) +")" ); 
	}
	DEBRIEF_BEST.fadeIn(700,"");	
}


void init() {
	setTag("ui.debrief");

	gpad=Gamepad();
		
	//add HUD container
	HUD=Layout();
	HUD.setBaseSize(800,480,"autofit");
	HUD.show();
	
	LABEL_LEVEL=Widget(HUD,UI_TEXFONTLABEL);
	LABEL_LEVEL.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font.image");
	LABEL_LEVEL.setparam(PARAM_FONTSIZE,"30,30");
	LABEL_LEVEL.setparam(PARAM_FONTSPACING,"-0.60");
	LABEL_LEVEL.setparam(PARAM_TEXTALIGN,"left");
	LABEL_LEVEL.enableGhost(1);
	LABEL_LEVEL.setPivot(PIVOTX_LEFT,PIVOTY_BOTTOM);
	LABEL_LEVEL.setPos(10,470);
	LABEL_LEVEL.setSize(24,24);
	LABEL_LEVEL.setParam(PARAM_COLOR,"130,130,130,255");
	LABEL_LEVEL.hide();

	NOTEPAD=Widget(HUD,UI_WIDGET);
	NOTEPAD.setPivot(PIVOTX_CENTER,PIVOTY_TOP);	
	NOTEPAD.setSize(512,512);
	NOTEPAD.setPos(400,0);
	
	int BOFFY = 70;
	int BOFFX = 568;
	bfacebook=Widget(NOTEPAD,UI_PUSHBUTTON);
	bfacebook.setSize(80,80);
	bfacebook.setparam(PARAM_THEME,"LINEAR:textures/ui/ui_fbside_normal.image,textures/ui/ui_fbside_normal.image,textures/ui/ui_fbside_pressed.image");
	bfacebook.setparam(PARAM_ONCLICK,"cbFacebook");
	bfacebook.setPivot(PIVOTX_RIGHT,PIVOTY_TOP);
	bfacebook.setPos(BOFFX,BOFFY);
	bfacebook.hide();
	
	//btwitter=Widget(NOTEPAD,UI_PUSHBUTTON);
	//btwitter.setSize(80,80);
	//btwitter.setparam(PARAM_THEME,"LINEAR:textures/ui/ui_twside_normal.image,textures/ui/ui_twside_normal.image,textures/ui/ui_twside_pressed.image");
	//btwitter.setparam(PARAM_ONCLICK,"cbTwitter");
	//btwitter.setPivot(PIVOTX_RIGHT,PIVOTY_TOP);
	//btwitter.setPos(BOFFX,BOFFY*2.3);
	//btwitter.hide();
	
		
	DEBRIEF_STARBG1=Widget(HUD,UI_ICON);
	DEBRIEF_STARBG2=Widget(HUD,UI_ICON);
	DEBRIEF_STARBG3=Widget(HUD,UI_ICON);
	DEBRIEF_SCISSOR1=Widget(DEBRIEF_STARBG1,UI_SCISSOR);
	DEBRIEF_SCISSOR2=Widget(DEBRIEF_STARBG2,UI_SCISSOR);
	DEBRIEF_SCISSOR3=Widget(DEBRIEF_STARBG3,UI_SCISSOR);
	DEBRIEF_STARFG1=Widget(DEBRIEF_SCISSOR1,UI_ICON);
	DEBRIEF_STARFG1=Widget(DEBRIEF_SCISSOR1,UI_ICON);
	DEBRIEF_STARFG2=Widget(DEBRIEF_SCISSOR2,UI_ICON);
	DEBRIEF_STARFG3=Widget(DEBRIEF_SCISSOR3,UI_ICON);
	DEBRIEF_TEXT=Widget(HUD,UI_TEXFONTLABEL);
	DEBRIEF_BEST=Widget(HUD,UI_TEXFONTLABEL);
	DEBRIEF_TEXT_CARROT=Widget(DEBRIEF_TEXT,UI_ICON);	
	
	DEBRIEF_STARBG1.setSize(128,128);
	DEBRIEF_STARBG2.setSize(128,128);
	DEBRIEF_STARBG3.setSize(128,128);
	DEBRIEF_STARBG1.enableGhost(1);
	DEBRIEF_STARBG2.enableGhost(1);
	DEBRIEF_STARBG3.enableGhost(1);
	DEBRIEF_STARBG1.setparam(PARAM_IMAGE,"LINEAR:textures/ui/debriefing_star_bg.image");
	DEBRIEF_STARBG2.setparam(PARAM_IMAGE,"LINEAR:textures/ui/debriefing_star_bg.image");
	DEBRIEF_STARBG3.setparam(PARAM_IMAGE,"LINEAR:textures/ui/debriefing_star_bg.image");
	DEBRIEF_STARBG1.setPivot(PIVOTX_RIGHT,PIVOTY_TOP);
	DEBRIEF_STARBG2.setPivot(PIVOTX_CENTER,PIVOTY_TOP);
	DEBRIEF_STARBG3.setPivot(PIVOTX_LEFT,PIVOTY_TOP);
	DEBRIEF_STARBG1.setPos(340,55);
	DEBRIEF_STARBG2.setPos(400,55);
	DEBRIEF_STARBG3.setPos(470,55);
	
	DEBRIEF_SCISSOR1.setSize(128,128);
	DEBRIEF_SCISSOR2.setSize(128,128);
	DEBRIEF_SCISSOR3.setSize(128,128);
	
	DEBRIEF_STARFG1.setparam(PARAM_IMAGE,"LINEAR:textures/ui/debriefing_star_fg.image");	
	DEBRIEF_STARFG2.setparam(PARAM_IMAGE,"LINEAR:textures/ui/debriefing_star_fg.image");	
	DEBRIEF_STARFG3.setparam(PARAM_IMAGE,"LINEAR:textures/ui/debriefing_star_fg.image");	
	DEBRIEF_STARFG1.setSize(DEBRIEF_STARBG1.getW(),DEBRIEF_STARBG1.getH());
	DEBRIEF_STARFG2.setSize(DEBRIEF_STARBG1.getW(),DEBRIEF_STARBG1.getH());
	DEBRIEF_STARFG3.setSize(DEBRIEF_STARBG1.getW(),DEBRIEF_STARBG1.getH());
			
	string debrief_color="160,90,30,255";
	setupFont(DEBRIEF_TEXT,63,"center",1);
	DEBRIEF_TEXT.setParam(PARAM_FONTSPACING,"-0.43")
	DEBRIEF_TEXT.setPivot(PIVOTX_CENTER,PIVOTY_TOP);
	//DEBRIEF_TEXT.setPos(370,195);
	DEBRIEF_TEXT.setParam(PARAM_COLOR,debrief_color);
	center_text();

	string best_color="240,90,20,255";
	setupFont(DEBRIEF_BEST,28,"left",1);
	DEBRIEF_BEST.setParam(PARAM_FONTSPACING,"-0.44")
	DEBRIEF_BEST.setPivot(PIVOTX_CENTER,PIVOTY_TOP);
	DEBRIEF_BEST.setPos(315,268);
	DEBRIEF_BEST.setParam(PARAM_COLOR,best_color);
	
	DEBRIEF_TEXT_CARROT.setParam(PARAM_IMAGE,"LINEAR:textures/ui/briefing_carrot.image");
	DEBRIEF_TEXT_CARROT.setSize(64,64);
	DEBRIEF_TEXT_CARROT.setPos(28,2);	
	
	DEBRIEF_STAR1_FLASH1=Widget(DEBRIEF_STARBG1,UI_ICON);
	DEBRIEF_STAR1_FLASH1.setSize("100%","100%");
	DEBRIEF_STAR1_FLASH1.setparam(PARAM_IMAGE,"LINEAR:textures/ui/star_flash1.image");
	DEBRIEF_STAR1_FLASH1.setOpacity(0.0);
	DEBRIEF_STAR1_FLASH1.enableGhost(1);

	DEBRIEF_STAR1_FLASH2=Widget(DEBRIEF_STARBG1,UI_ICON);
	DEBRIEF_STAR1_FLASH2.setSize("100%","100%");
	DEBRIEF_STAR1_FLASH2.setparam(PARAM_IMAGE,"LINEAR:textures/ui/star_flash2.image");
	DEBRIEF_STAR1_FLASH2.setOpacity(0.0);
	DEBRIEF_STAR1_FLASH2.enableGhost(1);

	DEBRIEF_STAR2_FLASH1=Widget(DEBRIEF_STARBG2,UI_ICON);
	DEBRIEF_STAR2_FLASH1.setSize("100%","100%");
	DEBRIEF_STAR2_FLASH1.setparam(PARAM_IMAGE,"LINEAR:textures/ui/star_flash1.image");
	DEBRIEF_STAR2_FLASH1.setOpacity(0.0);
	DEBRIEF_STAR2_FLASH1.enableGhost(1);

	DEBRIEF_STAR2_FLASH2=Widget(DEBRIEF_STARBG2,UI_ICON);
	DEBRIEF_STAR2_FLASH2.setSize("100%","100%");
	DEBRIEF_STAR2_FLASH2.setparam(PARAM_IMAGE,"LINEAR:textures/ui/star_flash2.image");
	DEBRIEF_STAR2_FLASH2.setOpacity(0.0);
	DEBRIEF_STAR2_FLASH2.enableGhost(1);

	DEBRIEF_STAR3_FLASH1=Widget(DEBRIEF_STARBG3,UI_ICON);
	DEBRIEF_STAR3_FLASH1.setSize("100%","100%");
	DEBRIEF_STAR3_FLASH1.setparam(PARAM_IMAGE,"LINEAR:textures/ui/star_flash1.image");
	DEBRIEF_STAR3_FLASH1.setOpacity(0.0);
	DEBRIEF_STAR3_FLASH1.enableGhost(1);

	DEBRIEF_STAR3_FLASH2=Widget(DEBRIEF_STARBG3,UI_ICON);
	DEBRIEF_STAR3_FLASH2.setSize("100%","100%");
	DEBRIEF_STAR3_FLASH2.setparam(PARAM_IMAGE,"LINEAR:textures/ui/star_flash2.image");
	DEBRIEF_STAR3_FLASH2.setOpacity(0.0);
	DEBRIEF_STAR3_FLASH2.enableGhost(1);
	
	STARS_TOTAL=Widget(HUD,UI_TEXFONTLABEL);
	STARS_TOTAL.setPivot(PIVOTX_RIGHT,PIVOTY_BOTTOM);
	STARS_TOTAL.setSize(32,32);
	STARS_TOTAL.setPos(795,470);
	STARS_TOTAL.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font.image");
	STARS_TOTAL.setparam(PARAM_FONTSIZE,"32,32");
	STARS_TOTAL.setparam(PARAM_FONTSPACING,"-0.4");
	STARS_TOTAL.setparam(PARAM_TEXTALIGN,"right");
	STARS_TOTAL.setparam(PARAM_TEXT,"");
	STARS_TOTAL.enableGhost(1);		
	
	DEBRIEF_RETRY=Widget(HUD,UI_PUSHBUTTON);
	DEBRIEF_RETRY.setSize(128,128);
	DEBRIEF_RETRY.setparam(PARAM_THEME,"LINEAR:textures/ui/tryagain_normal.image,textures/ui/tryagain_normal.image,textures/ui/tryagain_pressed.image");
	DEBRIEF_RETRY.setparam(PARAM_ONCLICK,"cbTryAgain");
	
	DEBRIEF_MENU=Widget(HUD,UI_PUSHBUTTON);
	DEBRIEF_MENU.setSize(128,128);
	DEBRIEF_MENU.setparam(PARAM_THEME,"LINEAR:textures/ui/menu_normal.image,textures/ui/menu_normal.image,textures/ui/menu_pressed.image");
	DEBRIEF_MENU.setparam(PARAM_ONCLICK,"cbBack");

	DEBRIEF_NEXT=Widget(HUD,UI_PUSHBUTTON);
	DEBRIEF_NEXT.setSize(128,128);
	DEBRIEF_NEXT.setparam(PARAM_THEME,"LINEAR:textures/ui/okay_normal.image,textures/ui/okay_normal.image,textures/ui/okay_pressed.image");
	DEBRIEF_NEXT.setparam(PARAM_ONCLICK,"cbNext");	
	
	DEBRIEF_MENU.setPivot(PIVOTX_RIGHT,PIVOTY_TOP);
	DEBRIEF_NEXT.setPivot(PIVOTX_LEFT,PIVOTY_TOP);
	DEBRIEF_RETRY.setPivot(PIVOTX_CENTER,PIVOTY_TOP);
	DEBRIEF_NEXT.setPos(400+80,306);		
	DEBRIEF_MENU.setPos(400-80,306);
	DEBRIEF_RETRY.setPos(400,306);		
	
	DEBRIEF_IMG_CLUNNIES	= Widget(HUD, UI_ICON);
	DEBRIEF_IMG_PUS		 	= Widget(HUD, UI_ICON);
	DEBRIEF_IMG_CARROTS		= Widget(HUD, UI_ICON);
	DEBRIEF_IMG_TIME		= Widget(HUD, UI_ICON);
	DEBRIEF_IMG_BEST 		= Widget(HUD, UI_ICON);

	setup_count_icon(DEBRIEF_IMG_TIME);
	setup_count_icon(DEBRIEF_IMG_CARROTS);
	setup_count_icon(DEBRIEF_IMG_PUS);
	setup_count_icon(DEBRIEF_IMG_CLUNNIES);
	setup_count_icon(DEBRIEF_IMG_BEST);

	showBestScore();

	DEBRIEF_IMG_BEST.setparam(PARAM_IMAGE,"LINEAR:textures/ui/debrief_best.image");
	DEBRIEF_IMG_CLUNNIES.setparam(PARAM_IMAGE,"LINEAR:textures/ui/debrief_bonus_clunnies.image");
	DEBRIEF_IMG_PUS.setparam(PARAM_IMAGE,"LINEAR:textures/ui/debrief_bonus_pus.image");
	DEBRIEF_IMG_CARROTS.setparam(PARAM_IMAGE,"LINEAR:textures/ui/debrief_bonus_carrots.image");
	DEBRIEF_IMG_TIME.setparam(PARAM_IMAGE,"LINEAR:textures/ui/debrief_bonus_time.image");



	
	
	
	CURSOR=Widget(HUD,UI_ICON);
	CURSOR.setPivot(PIVOTX_LEFT,PIVOTY_TOP);
	CURSOR.setSize(64,64);
	CURSOR.setParam(PARAM_IMAGE,"LINEAR:textures/ui/hand-cursor.image");
	CURSOR.hide();
	CURSOR.enableGhost(1);
	
	vfile vfsnd;
	vfsnd=vfopen("/sector/ui.sound","r");
	snd=Sound(vfsnd);
	fCall("e_volume");
	
	addListener(ON_EVENT,"SHOW","e_show");
	addListener(ON_EVENT,"HIDE","e_hide");
	addListener(ON_EVENT,"VOLUME","e_volume");
}
void e_volume() {
	if (snd) snd.setVolume(float(appPropertyGet(APPNAME,"sfxvol","1.0")));
}
void cbBack() {
	clearListeners(ON_TIMEOUT_MSEC);
	snd.fplay("sounds/button.audio"); 	
	gpad.onButtonDown("");
	sendEvent("UI_DEBRIEF_MENU","sc.control");
}
void cbTryAgain() {
	clearListeners(ON_TIMEOUT_MSEC);
	snd.fplay("sounds/button.audio"); 	
	gpad.onButtonDown("");
	sendEvent("UI_DEBRIEF_TRYAGAIN","sc.control");
}
void cbNext() {
	//print("UI HAS ADS: "+string( ["ui.home"->hasAds() as int]) );
	["ui.ad"->showAds()];

	clearListeners(ON_TIMEOUT_MSEC);
	snd.fplay("sounds/button.audio"); 	
	gpad.onButtonDown("");
	sendEvent("UI_DEBRIEF_NEXT","sc.control");
}

void e_hide() {
	gpad.onButtonDown("");
	HUD.fadeOut(200,"cbHide");
}
void cbHide() {
	this.hide();
}



void e_show(int _totalcarrots,int _score,int _powerup,int _jump,int _time,int _prevstars,int _newstars) {
	["ui.ad"->cacheAds()];
	center_text();
	TARGET_COUNT = 0;
	PREV_TARGET_COUNT = 0;
	DEBRIEF_BEST.setParam(PARAM_TEXT,""); 
	DEBRIEF_BEST.hide();
	this.show();
	bfacebook.hide();
	//btwitter.hide();
	PREV_TOTALSTARS=_prevstars;
	NEXT_TOTALSTARS=_newstars;
	PREV_STAR=0;
	CURSOR_WIDGET=CURSOR;
	CURSOR.hide();
	HUD.hide();
	HUD.fadeIn(200,"");
	COLLECTED_CARROTS=_score-_powerup-_jump-_time;
	BONUS_JUMP=_jump;
	BONUS_POWERUP=_powerup;
	BONUS_TIME=_time;
	TOTAL_COUNT=_totalcarrots;
	SCORE_COUNT=_score;
	CURRENT_SCORE_COUNT=0;
	DEBRIEF_NEXT.hide();
	DEBRIEF_MENU.hide();
	DEBRIEF_RETRY.hide();
	DEBRIEF_SCISSOR1.setOpacity(1.0);
	DEBRIEF_SCISSOR2.setOpacity(1.0);
	DEBRIEF_SCISSOR3.setOpacity(1.0);
	DEBRIEF_SCISSOR1.show();
	DEBRIEF_SCISSOR2.show();
	DEBRIEF_SCISSOR3.show();
	TARGET_COUNT = 0;
	STARS_TOTAL.hide();
	STARS_TOTAL.setparam(PARAM_TEXT,"`"+string(_prevstars));
	clearListeners(ON_TIMEOUT_MSEC);
	addListener(ON_TIMEOUT_MSEC,"33","cbDebriefCountdown");
	addListener(ON_MOUSEUP,"cbSkipDebrief");
	gpad.onButtonDown("cbSkipDebrief");
}
void debriefUpdateStars() {
	float revealperc1=0.0,revealperc2=0.0,revealperc3=0.0;
	if (CURRENT_SCORE_COUNT>(TOTAL_COUNT*CONST_PERC_STAR2)) {
		revealperc1=1.0;
		revealperc2=1.0;
		revealperc3=float(CURRENT_SCORE_COUNT-(TOTAL_COUNT*CONST_PERC_STAR2))/float(TOTAL_COUNT*(CONST_PERC_STAR3-CONST_PERC_STAR2));
	}
	else if (CURRENT_SCORE_COUNT>(TOTAL_COUNT*CONST_PERC_STAR1)) {
		revealperc1=1.0;
		revealperc2=float(CURRENT_SCORE_COUNT-(TOTAL_COUNT*CONST_PERC_STAR1))/float(TOTAL_COUNT*(CONST_PERC_STAR2-CONST_PERC_STAR1));
	}
	else {
		revealperc1=float(CURRENT_SCORE_COUNT)/float(TOTAL_COUNT*CONST_PERC_STAR1);
	}
	revealperc1=clamp(revealperc1,0.0,1.0);
	revealperc2=clamp(revealperc2,0.0,1.0);
	revealperc3=clamp(revealperc3,0.0,1.0);

	int total=int( revealperc1+revealperc2+revealperc3 );
	if (total>PREV_STAR) {
		PREV_STAR=total;
		snd.fplay("sounds/win2.audio");
	}
	
	string themenum; 
	themenum = ["sc.loader"->getTheme() as string]; //does not seem to work
	themenum = ["ui.home"->themeToName(themenum) as string];
	CURRENT_LEVEL=["sc.loader"->getLevel() as string];
	LABEL_LEVEL.setParam(PARAM_TEXT,"# "+themenum +" - "+CURRENT_LEVEL); // LEVEL
	LABEL_LEVEL.show();

	
	DEBRIEF_SCISSOR1.setSize(128,24+77*revealperc1);
	DEBRIEF_SCISSOR1.setPos(0,128-DEBRIEF_SCISSOR1.getH());
	DEBRIEF_STARFG1.setPos(0,-DEBRIEF_SCISSOR1.getY());		
	
	DEBRIEF_SCISSOR2.setSize(128,24+77*revealperc2);
	DEBRIEF_SCISSOR2.setPos(0,128-DEBRIEF_SCISSOR2.getH());
	DEBRIEF_STARFG2.setPos(0,-DEBRIEF_SCISSOR2.getY());		

	DEBRIEF_SCISSOR3.setSize(128,24+77*revealperc3);
	DEBRIEF_SCISSOR3.setPos(0,128-DEBRIEF_SCISSOR3.getH());
	DEBRIEF_STARFG3.setPos(0,-DEBRIEF_SCISSOR3.getY());
}
void cbSkipDebrief() {
	CURRENT_SCORE_COUNT=SCORE_COUNT;
	debriefUpdateStars();	
}
void increase_score(int target){
	if ( target == 0) target = COLLECTED_CARROTS;

	if ( (target-CURRENT_SCORE_COUNT)>100 ) {
		CURRENT_SCORE_COUNT+=25;
	}
	else if ( (target-CURRENT_SCORE_COUNT)>40 ) {
		CURRENT_SCORE_COUNT+=5;
	}
	else if ( (target-CURRENT_SCORE_COUNT)>20 ) {
		CURRENT_SCORE_COUNT+=2;
	}
	else {
		CURRENT_SCORE_COUNT++;
	}
}
void print_count(string count_str){
	DEBRIEF_TEXT.setParam(PARAM_TEXT,count_str);
	DEBRIEF_TEXT_CARROT.setPos((length(count_str)*12)+44,DEBRIEF_TEXT_CARROT.getY());	
}
void cbDebriefCountdown() {
	if (CURRENT_SCORE_COUNT>=SCORE_COUNT) {
		delListener(ON_MOUSEUP,"cbSkipDebrief");
		gpad.onButtonDown("");
		string count_str=string(SCORE_COUNT);
		center_text();
		DEBRIEF_TEXT.hide();		
		DEBRIEF_TEXT.setParam(PARAM_TEXT,count_str);
		DEBRIEF_TEXT.fadeIn(300,"");
		DEBRIEF_TEXT_CARROT.setPos((length(count_str)*ICON_OFFSET) + 4,DEBRIEF_TEXT_CARROT.getY());	
		int fx=0;
		if (SCORE_COUNT>=(TOTAL_COUNT*CONST_PERC_STAR3)) {
			DEBRIEF_STAR1_FLASH1.animate("A","S0:0;S1:500;S0:1000","");
			DEBRIEF_STAR1_FLASH2.animate("A","S0:250;S1:750;S0:1250","");
			DEBRIEF_STAR2_FLASH1.animate("A","S0:0;S1:500;S0:1000","");
			DEBRIEF_STAR2_FLASH2.animate("A","S0:250;S1:750;S0:1250","");
			DEBRIEF_STAR3_FLASH1.animate("A","S0:0;S1:500;S0:1000","");
			DEBRIEF_STAR3_FLASH2.animate("A","S0:250;S1:750;S0:1250","");
			fx=1;
		}
		else if (SCORE_COUNT>=(TOTAL_COUNT*CONST_PERC_STAR2)) {
			fx=1;
			DEBRIEF_STAR1_FLASH1.animate("A","S0:0;S1:500;S0:1000","");
			DEBRIEF_STAR1_FLASH2.animate("A","S0:250;S1:750;S0:1250","");
			DEBRIEF_STAR2_FLASH1.animate("A","S0:0;S1:500;S0:1000","");
			DEBRIEF_STAR2_FLASH2.animate("A","S0:250;S1:750;S0:1250","");
			DEBRIEF_SCISSOR3.fadeOut(1000,"");
		}
		else if (SCORE_COUNT>=(TOTAL_COUNT*CONST_PERC_STAR1)) {
			fx=1;
			DEBRIEF_STAR1_FLASH1.animate("A","S0:0;S1:500;S0:1000","");
			DEBRIEF_STAR1_FLASH2.animate("A","S0:250;S1:750;S0:1250","");
			DEBRIEF_SCISSOR2.fadeOut(1000,"");
			DEBRIEF_SCISSOR3.fadeOut(1000,"");
		}
		else {
			DEBRIEF_SCISSOR1.fadeOut(1000,"");
			DEBRIEF_SCISSOR2.fadeOut(1000,"");
			DEBRIEF_SCISSOR3.fadeOut(1000,"");
		}
		if (fx) { //if win
			snd.fplay("sounds/win2.audio");
			DEBRIEF_MENU.setPivot(PIVOTX_RIGHT,PIVOTY_TOP);
			DEBRIEF_NEXT.setPivot(PIVOTX_LEFT,PIVOTY_TOP);
			DEBRIEF_RETRY.setPivot(PIVOTX_CENTER,PIVOTY_TOP);
			DEBRIEF_NEXT.setPos(400+80,306);		
			DEBRIEF_MENU.setPos(400-80,306);
			DEBRIEF_RETRY.setPos(400,306);		
			DEBRIEF_NEXT.fadeIn(200,"");
			DEBRIEF_MENU.fadeIn(200,"");
			DEBRIEF_RETRY.fadeIn(200,"");
			CURSOR_WIDGET=DEBRIEF_NEXT;
			if (APPNAME != "bunnymazehd"){
				int adprop=int(appPropertyGet(APPNAME,"adprob","15"));
				adprop=min(adprop+5,20);
				appPropertySet(APPNAME,"adprob",string(adprop));
				appPropertyFlush();
			}			
		}
		else {
			DEBRIEF_MENU.setPivot(PIVOTX_RIGHT,PIVOTY_TOP);
			DEBRIEF_RETRY.setPivot(PIVOTX_LEFT,PIVOTY_TOP);
			DEBRIEF_MENU.setPos(400-11,306);
			DEBRIEF_RETRY.setPos(400+11,306);		
			DEBRIEF_MENU.fadeIn(200,"");
			DEBRIEF_RETRY.fadeIn(200,"");
			CURSOR_WIDGET=DEBRIEF_RETRY;
			int adprop=int(appPropertyGet(APPNAME,"adprob","15"));
			adprop=min(adprop+2,20);
			appPropertySet(APPNAME,"adprob",string(adprop));
			appPropertyFlush();
		}
		hide_icons();
		top_text();
		gpad.onButtonDown("cbGPADMenu");
		bfacebook.fadeIn(200,"");
		//btwitter.fadeIn(200,"");
		STARS_TOTAL.fadeIn(900,"cbTotalStarsCount");
		showBestScore();
		return;
	}
	
	snd.fplay("sounds/win1.audio"); 	
	debriefUpdateStars();
	
	int delay=36;
	increase_score(TARGET_COUNT);
	
	if (CURRENT_SCORE_COUNT<=COLLECTED_CARROTS) {
		TARGET_COUNT = COLLECTED_CARROTS;
		//warnLog("CARROTS: "+string(COLLECTED_CARROTS));
		string count_str=string(CURRENT_SCORE_COUNT);
		toggle_icon(DEBRIEF_IMG_CARROTS);
		print_count(count_str);
	}
	else if ( (BONUS_POWERUP>0) && (CURRENT_SCORE_COUNT<=(COLLECTED_CARROTS+BONUS_POWERUP))) {
		//warnLog("PUS: "+string(BONUS_POWERUP)+" -- "+ string(TARGET_COUNT-COLLECTED_CARROTS);
		TARGET_COUNT = COLLECTED_CARROTS+BONUS_POWERUP;
		toggle_icon(DEBRIEF_IMG_PUS);
		string count_str=""+string(CURRENT_SCORE_COUNT-COLLECTED_CARROTS);
		print_count(count_str);
	}
	else if ( (BONUS_JUMP>0) && (CURRENT_SCORE_COUNT<=(COLLECTED_CARROTS+BONUS_POWERUP+BONUS_JUMP)) ) {
		//warnLog("JUMP: "+string(BONUS_JUMP));
		TARGET_COUNT = COLLECTED_CARROTS+BONUS_POWERUP+BONUS_JUMP;
		toggle_icon(DEBRIEF_IMG_CLUNNIES);
		string count_str=""+string(CURRENT_SCORE_COUNT-COLLECTED_CARROTS-BONUS_POWERUP);		
		print_count(count_str);
	}
	else if ( (BONUS_TIME>0) && (CURRENT_SCORE_COUNT<=(COLLECTED_CARROTS+BONUS_POWERUP+BONUS_JUMP+BONUS_TIME))) {
		//warnLog("TIME: "+string(BONUS_TIME));
		TARGET_COUNT = COLLECTED_CARROTS+BONUS_POWERUP+BONUS_JUMP+BONUS_TIME;
		toggle_icon(DEBRIEF_IMG_TIME);
		string count_str=""+string(CURRENT_SCORE_COUNT-COLLECTED_CARROTS-BONUS_POWERUP-BONUS_JUMP);
		print_count(count_str);
	}

	
	if (CURRENT_SCORE_COUNT == TARGET_COUNT){
				delay=1000; //// FIX THIS
			}

	
	PREV_TARGET_COUNT = TARGET_COUNT;
	addListener(ON_TIMEOUT_MSEC,string(delay),"cbDebriefCountdown");
}


void cbTotalStarsCount() {
	if (PREV_TOTALSTARS<NEXT_TOTALSTARS) {
		snd.fplay("sounds/carrot6.audio");
		PREV_TOTALSTARS++;
		STARS_TOTAL.setparam(PARAM_TEXT,"`"+string(PREV_TOTALSTARS));
		addListener(ON_TIMEOUT_MSEC,"500","cbTotalStarsCount");
	} 
}
void cbGPADMenu(int _controller,int _action) {
	if (_action==GAMEPAD_B) { 
		DEBRIEF_MENU.doAction();
		return; 
	}
	if (_action==GAMEPAD_MENU || _action==GAMEPAD_BACK) { return; }
	if (gpad.isDPAD(_action) || gpad.isABXY(_action)) {
		if (CURSOR.isVisible()) {
			if (_action==GAMEPAD_RIGHT) {
				if (CURSOR_WIDGET==DEBRIEF_MENU) {
					CURSOR_WIDGET=DEBRIEF_RETRY;
				}
				else if (CURSOR_WIDGET==DEBRIEF_RETRY) {
					if (DEBRIEF_NEXT.isVisible()) CURSOR_WIDGET=DEBRIEF_NEXT;
				}
			}
			else if (_action==GAMEPAD_LEFT) {
				if (CURSOR_WIDGET==DEBRIEF_NEXT) {
					CURSOR_WIDGET=DEBRIEF_RETRY;
				}
				else if (CURSOR_WIDGET==DEBRIEF_RETRY) {
					CURSOR_WIDGET=DEBRIEF_MENU;
				}				
			}
			else if (_action==GAMEPAD_A && int(CURSOR_WIDGET)) {
				CURSOR_WIDGET.doAction();
			}		
		}
		else {
			CURSOR.show();
		}

		CURSOR.setParent(CURSOR_WIDGET);
		CURSOR.setPos( (CURSOR_WIDGET.getW()*2)/3,CURSOR_WIDGET.getH()/2);
	}
}

void cbFacebook() {
	openURL("http://www.facebook.com/bunnymaze3d");
}
void cbTwitter() {
	openURL("http://www.twitter.com/bunnymaze3d");
}
