 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#hive 1
#using stdlib gui analytics gamepad sound network

String APPNAME = "bunnymaze";

Layout HUDBG,HUDFG;
Widget Backdrop_FG,Backdrop_BG;

Widget PARENT_HOME,PARENT_LEVELS,homelogo,homelogo2,homestreaks,bhome_play,bhome_quit,bhome_credits,bhome_options,blevel_home,blevel_options,blevel_stars,blevel_total,blevel_buy,blevel_buy_over,blevel_noads;
Widget newLvlButton,newLvlNum,wfx,wfx2,wfx3,wfxcont;
Widget CONTROLLER_LT,CONTROLLER_RT;
Widget bhome_facebook,bhome_restore;
Widget blevel_facebook;
//Widget bhome_twitter;
int B_PAUSE=0,B_BILLING=0;
int CURRENT_PAGE=0,TOTAL_STARS=0,AVAILABLE_STARS=0;
int numsets=0;
string CURRENT_LEVELSET;
lists LEVELSET_NAME,LEVELSET_TITLE,LEVELSET_PREV_UNLOCKED;
listi LEVELSET_GRID_X,LEVELSET_GRID_Y,LEVELSET_SP;
list LEVELSET_PAGES,LEVELSET_PAGES_LOCK;
list LEVELSET_BUTTON,LEVELSET_NUMBERS;
list L_SCROLL_DOTS;
Widget ActiveDot; 
Widget CURSOR,CURSOR_WIDGET;
Gamepad gpad;
Sound snd;
int FLAG_THANKS;
int NOADS = 0;

int GRID_BUTTON_SIZE = 87;
int GRID_BUTTON_SPACING_X=100;
int GRID_BUTTON_SPACING_Y=103;
int GRID_OFFY = 32;
float GRID_STAR_SCALE = 0.4;
int GRID_STAR_STRIDE = 24;
int GRID_STAR_OFFSET = 2;

int BUTTON_SIZE = 77;
int BUTTON_SPACING = 88;

int BUTTON_OFFSET_X = 92;
int BUTTON_OFFSET_Y = 20;

void start_social() {/*social_start("test");*/}

//Widget DEBUGGER;

int bUnlockLevels=0,bUnlockLevelSets=0,bLoaded;
int show_controller=0;

void cacheTexture(string _texture) {
	//cache some textures
	Widget wc=Widget(HUDBG,UI_ICON);
	wc.hide();
	wc.setParam(PARAM_IMAGE,"LINEAR:textures/ui/"+_texture);
}
void cacheBackdrop(string _texture) {
	//cache some textures
	Widget wc=Widget(HUDBG,UI_ICON);
	wc.hide();
	wc.setParam(PARAM_IMAGE,"LINEAR:levelsets/"+_texture+"/textures/levelset_bg_"+_texture+".image");
}

public string themeToName(string _theme) {
	return LEVELSET_TITLE.get(LEVELSET_NAME.findIndex(_theme));
}

public int showController() {
	if (!show_controller) {
		CONTROLLER_LT.setParam(PARAM_IMAGE,"LINEAR:textures/ui/controller_triggerl.image");	
		CONTROLLER_RT.setParam(PARAM_IMAGE,"LINEAR:textures/ui/controller_triggerr.image");
		show_controller=1;
	}
	int index=LEVELSET_NAME.findIndex(CURRENT_LEVELSET);
	if (index==0) {
		CONTROLLER_RT.show();
		CONTROLLER_LT.hide();
	}
	else if ((index+1)<LEVELSET_NAME.num()) {
		CONTROLLER_LT.show();
		CONTROLLER_RT.show();
	}
	else {
		CONTROLLER_RT.hide();
		CONTROLLER_LT.show();
	} 
	return 1;
}

void init() {
	start_social();
	FLAG_THANKS=0;
	show_controller=0;
	bLoaded=0;
	int dotoffy = -38;
	if (debug()) {
		bUnlockLevels=int(appPropertyGet(APPNAME,"unlocklevels","0"));
		bUnlockLevelSets=int(appPropertyGet(APPNAME,"unlocksets","0"));
	}
	else {
		bUnlockLevels=1;
		bUnlockLevelSets=1;
	}
	
	setTag("ui.home");
	enableTick(0);

	gpad=Gamepad();
	
	//allocate lists
	LEVELSET_NAME=lists();
	LEVELSET_TITLE=lists();
	LEVELSET_PREV_UNLOCKED=lists();
	LEVELSET_GRID_X=listi();
	LEVELSET_GRID_Y=listi();
	LEVELSET_SP=listi();
	LEVELSET_PAGES=list();
	LEVELSET_PAGES_LOCK=list();
	LEVELSET_BUTTON=list();
	LEVELSET_NUMBERS=list();
	L_SCROLL_DOTS=list();
	
	B_BILLING=0;
	
	//BACKGROUND
	HUDBG=Layout();
	HUDBG.setBaseSize(800,480,"anamorphicfit");
	HUDBG.show();
	
	//cache textures
	cacheTexture("level_active_normal.image");
	cacheTexture("level_active_pressed.image");
	cacheTexture("level_disabled_normal.image");
	cacheTexture("level_disabled_pressed.image");
	cacheTexture("level_effect.image");
	cacheTexture("level_finished_normal.image");
	cacheTexture("level_finished_pressed.image");
	cacheTexture("level_star.image");
	
	Backdrop_BG=Widget(HUDBG,UI_ICON);
	Backdrop_BG.setParam(PARAM_IMAGE,"LINEAR:textures/ui/homebg.image");
	Backdrop_BG.setSize("100%","100%");
	
	Backdrop_FG=Widget(HUDBG,UI_ICON);
	Backdrop_FG.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	Backdrop_FG.setSize(800,480);
	Backdrop_FG.setPos(400,240);
	Backdrop_FG.setOpacity(0.0); 
		
	HUDFG=Layout();
	HUDFG.setBaseSize(800,480,"autofit");
	HUDFG.show();
	
	//HOME
	PARENT_HOME=Widget(HUDFG,UI_WIDGET);
	PARENT_HOME.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	PARENT_HOME.setPos(400,240);
	PARENT_HOME.setSize(800,480);
	
	homestreaks=Widget(PARENT_HOME,UI_LOADRING);
	homestreaks.setParam(PARAM_IMAGE,"LINEAR:textures/ui/homestreaks.image");
	homestreaks.setParam(PARAM_ROTATION_SPEED,"2");	
	homestreaks.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);	
	homestreaks.setSize(512,512);
	homestreaks.setPos(400,190);
	homestreaks.setOpacity(0.0);
	homestreaks.enableGhost(1);

	homelogo=Widget(PARENT_HOME,UI_ICON);
	homelogo.setParam(PARAM_IMAGE,"LINEAR:textures/ui/homelogo.image");
	homelogo.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);	
	homelogo.setSize(256,256);
	homelogo.setPos(400,0);
	homelogo.setOpacity(0.0);
	homelogo.enableGhost(1);

	homelogo2=Widget(PARENT_HOME,UI_ICON);
	homelogo2.setParam(PARAM_IMAGE,"LINEAR:textures/ui/logo-"+APPNAME+".image");
	homelogo2.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);	
	homelogo2.setSize(460,230);
	homelogo2.setPos(400,0);
	homelogo2.setOpacity(0.0);
	homelogo2.enableGhost(1);

	bhome_play=Widget(PARENT_HOME,UI_PUSHBUTTON);
	bhome_play.setSize(4*BUTTON_SIZE,BUTTON_SIZE);
	bhome_play.setparam(PARAM_THEME,"LINEAR:textures/ui/play_normal.image,textures/ui/play_normal.image,textures/ui/play_pressed.image");
	bhome_play.setparam(PARAM_ONCLICK,"cbPlayButton");
	bhome_play.setPivot(PIVOTX_RIGHT,PIVOTY_BOTTOM);
	bhome_play.setPos(800-BUTTON_OFFSET_Y,480-BUTTON_OFFSET_Y); //ADJUSTING FOR THE PICTURE GAP
	
	bhome_credits=Widget(PARENT_HOME,UI_PUSHBUTTON);
	bhome_credits.setSize(BUTTON_SIZE,BUTTON_SIZE);
	bhome_credits.setparam(PARAM_THEME,"LINEAR:textures/ui/smallcredits_normal.image,textures/ui/smallcredits_normal.image,textures/ui/smallcredits_pressed.image");
	bhome_credits.setparam(PARAM_ONCLICK,"cbCredits");
	bhome_credits.setPivot(PIVOTX_CENTER,PIVOTY_BOTTOM);
	bhome_credits.setPos(BUTTON_OFFSET_X+BUTTON_SPACING,480-BUTTON_OFFSET_Y);
	
	bhome_facebook=Widget(PARENT_HOME,UI_PUSHBUTTON);
	bhome_facebook.setSize(BUTTON_SIZE,BUTTON_SIZE);
	bhome_facebook.setparam(PARAM_THEME,"LINEAR:textures/ui/ui_fb_normal.image,textures/ui/ui_fb_normal.image,textures/ui/ui_fb_pressed.image");
	bhome_facebook.setparam(PARAM_ONCLICK,"cbFacebook");
	bhome_facebook.setPivot(PIVOTX_CENTER,PIVOTY_BOTTOM);
	bhome_facebook.setPos(BUTTON_OFFSET_X+BUTTON_SPACING*2,480-BUTTON_OFFSET_Y);
	
	int upper_offset=800-100-70;
	if (["ui.init"->isIos() as int]) {
		upper_offset-=70;
	}
	
	if (["ui.init"->isIos() as int]) {
		bhome_restore=Widget(PARENT_HOME,UI_PUSHBUTTON);
		bhome_restore.setSize(BUTTON_SIZE,BUTTON_SIZE);
		bhome_restore.setparam(PARAM_THEME,"LINEAR:textures/ui/ui_restorepurchases_normal.image,textures/ui/ui_restorepurchases_normal.image,textures/ui/ui_restorepurchases_pressed.image");
		bhome_restore.setparam(PARAM_ONCLICK,"cbRestorePurchases");
		bhome_restore.setPivot(PIVOTX_RIGHT,PIVOTY_TOP);
		bhome_restore.setPos(upper_offset,24);upper_offset+=70;
	}

	if (["ui.init"->isIos() as int]) {
		bhome_credits.setPos(bhome_credits.getX()-70,bhome_credits.getY());
		bhome_options.setPos(bhome_options.getX()-70,bhome_options.getY());
	}
	else {
		bhome_quit=Widget(PARENT_HOME,UI_PUSHBUTTON);
		bhome_quit.setSize(BUTTON_SIZE,BUTTON_SIZE);
		bhome_quit.setparam(PARAM_THEME,"LINEAR:textures/ui/ui_androidhome_normal.image,textures/ui/ui_androidhome_normal.image,textures/ui/ui_androidhome_pressed.image");
		bhome_quit.setparam(PARAM_ONCLICK,"cbAndroidHome");
		bhome_quit.setPivot(PIVOTX_CENTER,PIVOTY_BOTTOM);	
		bhome_quit.setPos(BUTTON_OFFSET_X,480-BUTTON_OFFSET_Y);
	}
	
	// LEVELS
	PARENT_LEVELS=Widget(HUDFG,UI_WIDGET);
	PARENT_LEVELS.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	PARENT_LEVELS.setPos(1200,240);
	PARENT_LEVELS.setSize(800,480);
	PARENT_LEVELS.setOpacity(0.0);

	CONTROLLER_LT=Widget(PARENT_LEVELS,UI_ICON);
	CONTROLLER_LT.enableGhost(1);
	CONTROLLER_LT.setPivot(PIVOTX_LEFT,PIVOTY_TOP);	
	CONTROLLER_LT.setSize(64,32);
	CONTROLLER_LT.setPos(64+2,0);
	CONTROLLER_LT.hide();

	CONTROLLER_RT=Widget(PARENT_LEVELS,UI_ICON);
	CONTROLLER_RT.enableGhost(1);
	CONTROLLER_RT.setPivot(PIVOTX_RIGHT,PIVOTY_TOP);	
	CONTROLLER_RT.setSize(64,32);
	CONTROLLER_RT.setPos(800-64-7,0);
	CONTROLLER_RT.hide();
	
	wfxcont=Widget(PARENT_LEVELS,UI_WIDGET);
	wfxcont.setPivot(PIVOTX_CENTER,PIVOTY_TOP);
	wfxcont.enableGhost(1);
	
	//load level sets
	fCall("loadLevelSets");	
	
	//add scroll dot background
	int scroll_w=LEVELSET_NAME.num()*20;
	Widget dotbg=Widget(PARENT_LEVELS,UI_ICON);
	dotbg.setOpacity(0.8);
	dotbg.setParam(PARAM_IMAGE,"LINEAR:textures/ui/ui-scrolldots-bg2.image");
	dotbg.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	dotbg.setSize(128*1.5,16*1.5);
	dotbg.setPos(400-9,480-85+dotoffy);
	
	
	//add scroll dots	
	int i,num;
	num=LEVELSET_NAME.num();
	for (i=0;i<num;i++) {
		Widget w=Widget(PARENT_LEVELS,UI_ICON);
		w.setParam(PARAM_IMAGE,"LINEAR:textures/ui/ui-scrolldots-normal.image");
		w.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
		w.setSize(16,16);
		w.setPos(((20*i) - (scroll_w/2)) + 400,480-85+dotoffy);
		L_SCROLL_DOTS.push(w);
	}
	ActiveDot=Widget(PARENT_LEVELS,UI_ICON);
	ActiveDot.setParam(PARAM_IMAGE,"LINEAR:textures/ui/ui-scrolldots-active.image");
	ActiveDot.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	ActiveDot.setSize(16,16);
	ActiveDot.setPos(-(scroll_w/2) + 400,480-85+dotoffy);

	blevel_home=Widget(PARENT_LEVELS,UI_PUSHBUTTON);
	blevel_home.setSize(BUTTON_SIZE,BUTTON_SIZE);
	blevel_home.setparam(PARAM_THEME,"LINEAR:textures/ui/smallhome_normal.image,textures/ui/smallhome_normal.image,textures/ui/smallhome_pressed.image");
	blevel_home.setparam(PARAM_ONCLICK,"cbHome");
	blevel_home.setPivot(PIVOTX_CENTER,PIVOTY_BOTTOM);
	blevel_home.setPos(BUTTON_OFFSET_X,480-BUTTON_OFFSET_Y);

	//add bottom bar (after sets so that they are on top)
	blevel_options=Widget(PARENT_LEVELS,UI_PUSHBUTTON);
	blevel_options.setSize(BUTTON_SIZE,BUTTON_SIZE);
	blevel_options.setparam(PARAM_THEME,"LINEAR:textures/ui/smalloptions_normal.image,textures/ui/smalloptions_normal.image,textures/ui/smalloptions_pressed.image");
	blevel_options.setparam(PARAM_ONCLICK,"cbPause");
	blevel_options.setPivot(PIVOTX_CENTER,PIVOTY_BOTTOM);
	blevel_options.setPos(BUTTON_OFFSET_X+BUTTON_SPACING,480-BUTTON_OFFSET_Y);
	
	blevel_facebook=Widget(PARENT_LEVELS,UI_PUSHBUTTON);
	blevel_facebook.setSize(BUTTON_SIZE,BUTTON_SIZE);
	blevel_facebook.setparam(PARAM_THEME,"LINEAR:textures/ui/ui_fb_normal.image,textures/ui/ui_fb_normal.image,textures/ui/ui_fb_pressed.image");
	blevel_facebook.setparam(PARAM_ONCLICK,"cbFacebook");
	blevel_facebook.setPivot(PIVOTX_CENTER,PIVOTY_BOTTOM);
	blevel_facebook.setPos(BUTTON_OFFSET_X+BUTTON_SPACING*2,480-BUTTON_OFFSET_Y));
	
	blevel_buy=Widget(PARENT_LEVELS,UI_PUSHBUTTON);
	blevel_buy.setPivot(PIVOTX_CENTER,PIVOTY_BOTTOM);
	blevel_buy.setSize(BUTTON_SIZE*4,BUTTON_SIZE);
	blevel_buy.setPos(800-BUTTON_OFFSET_X-BUTTON_SIZE*1.5,480-BUTTON_OFFSET_Y);
	blevel_buy.setparam(PARAM_THEME,"LINEAR:textures/ui/ui_billing_normal.image,textures/ui/ui_billing_normal.image,textures/ui/ui_billing_pressed.image");
	blevel_buy.hide();
	blevel_buy.disable();
	blevel_buy.setparam(PARAM_ONCLICK,"cbBuy");
	
	blevel_stars=Widget(PARENT_LEVELS,UI_ICON);
	blevel_stars.setParam(PARAM_IMAGE,"LINEAR:textures/ui/ui_browser_star.image");	
	blevel_stars.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	blevel_stars.setSize(BUTTON_SIZE*0.7,BUTTON_SIZE*0.7);
	blevel_stars.setPos(800-BUTTON_OFFSET_X,480-BUTTON_OFFSET_Y-BUTTON_SIZE);
	blevel_stars.enableGhost(1);
	
	blevel_total=Widget(PARENT_LEVELS,UI_TEXFONTLABEL);
	blevel_total.setPivot(PIVOTX_RIGHT,PIVOTY_MIDDLE);
	blevel_total.setSize(BUTTON_SIZE,BUTTON_SIZE);
	blevel_total.setPos(800-BUTTON_OFFSET_X*0.8,480-BUTTON_OFFSET_Y-BUTTON_SIZE*0.52);
	blevel_total.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font.image");
	blevel_total.setparam(PARAM_FONTSIZE,"29,29");
	blevel_total.setparam(PARAM_FONTSPACING,"-0.4");
	blevel_total.setparam(PARAM_TEXTALIGN,"right");
	blevel_total.setparam(PARAM_TEXT,"");
	blevel_total.enableGhost(1); 
	
	blevel_buy_over=Widget(PARENT_LEVELS,UI_WIDGET);
	blevel_buy_over.setPivot(PIVOTX_RIGHT,PIVOTY_BOTTOM);
	blevel_buy_over.setSize(blevel_buy.getW(),blevel_buy.getH());
	blevel_buy_over.setPos(blevel_buy.getX(),blevel_buy.getY());
	blevel_buy_over.enableGhost(1);
	
	blevel_noads=Widget(PARENT_LEVELS,UI_PUSHBUTTON);
	blevel_noads.setparam(PARAM_THEME,"LINEAR:textures/ui/ui_removeads_normal.image,textures/ui/ui_removeads_normal.image,textures/ui/ui_removeads_pressed.image");
	blevel_noads.setPivot(PIVOTX_CENTER,PIVOTY_BOTTOM);
	blevel_noads.setSize(BUTTON_SIZE*2,BUTTON_SIZE);
	blevel_noads.setPos(390,480-BUTTON_OFFSET_Y);
	blevel_noads.setparam(PARAM_ONCLICK,"cbBuyNoAds");
	
	CURSOR=Widget(PARENT_HOME,UI_ICON);
	CURSOR.setPivot(PIVOTX_LEFT,PIVOTY_TOP);
	CURSOR.setSize(64,64);
	CURSOR.setParam(PARAM_IMAGE,"LINEAR:textures/ui/hand-cursor.image");
	CURSOR.hide();
	CURSOR.enableGhost(1);
	
	vfile vfsnd;
	vfsnd=vfopen("/sector/ui.sound","r");
	snd=Sound(vfsnd);
	fCall("e_volume");
	
	//resume from options
	addListener(ON_EVENT,"RESUME","e_resume");
	addListener(ON_EVENT,"RESETLEVELS","e_resetlevels");
	addListener(ON_EVENT,"HOME","e_home");
	addListener(ON_EVENT,"LEVELS","e_levels");
	addListener(ON_EVENT,"HIDE","e_hide");
	addListener(ON_EVENT,"NEXTLEVEL","e_nextlevel");
	addListener(ON_EVENT,"VOLUME","e_volume");
	addListener(ON_QUIT,"cbQuit");
	
	addListener(ON_TIMEOUT_MSEC,"100","checkBilling");
	addListener(ON_APPFOCUS,"checkBilling");

	//DEBUG
	//DEBUGGER=Widget(HUDFG,UI_TEXFONTLABEL);
	//DEBUGGER.setPivot(PIVOTX_LEFT,PIVOTY_MIDDLE);
	//DEBUGGER.setSize(64,64);
	//DEBUGGER.setPos(0,20);
	//DEBUGGER.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font.image");
	//DEBUGGER.setparam(PARAM_FONTSIZE,"20,20");
	//DEBUGGER.setparam(PARAM_FONTSPACING,"-0.4");
	//DEBUGGER.setparam(PARAM_TEXTALIGN,"left");
	//DEBUGGER.setparam(PARAM_COLOR,"255,0,0");
	//DEBUGGER.enableGhost(1);
	//addListener(ON_UPDATE,"cbDebugger");	
}
//void cbDebugger() {
	//DEBUGGER.setParam(PARAM_TEXT,gpad.getdebugstring());
//}

public void finishPurchaseRestore() {
	if (["ui.init"->isIos() as int]) {
		bhome_restore.setOpacity(1.0);
		bhome_restore.enable();
	}
}

void e_volume() {
	if (snd) snd.setVolume(float(appPropertyGet(APPNAME,"sfxvol","1.0")));
}

public void checkBilling() {
	if (["ui.billing"->isLoaded() as int]) {
		bLoaded=1;
		fCall("refreshScore");
	} else {
		debugLog("Waiting for ui.billing");
		addListener(ON_TIMEOUT_MSEC,"100","checkBilling");
	}
}
public int isLoaded() { return bLoaded; }

void cbAndroidHome() {
	["ui.options"->cbYesQuitGame()];
}

/////////// LEVEL SETS /////////////
public int getTotalStars() {
	int i,j,num,lvlnums;
	TOTAL_STARS=["ui.billing"->getPurchasedStars() as int]);
	int prev_purchased=int(appPropertyGet(APPNAME,"purchased_stars",string(TOTAL_STARS)));
	appPropertySet(APPNAME,"purchased_stars",string(TOTAL_STARS));
	if (TOTAL_STARS>prev_purchased) {
		FLAG_THANKS=1;
		//int adprop=int(appPropertyGet(APPNAME,"adprob","15"));
		//if ( (TOTAL_STARS-prev_purchased)>30 ) { adprop-=20; }
		//else { adprop-=10; }
		//appPropertySet(APPNAME,"adprob",string(adprop));
		appPropertyFlush();		
	}
	num=LEVELSET_NAME.num();
	for (i=0;i<num;i++) {
		lists lvls=lists();
		appPropertyGet(APPNAME,"lvlscore_"+LEVELSET_NAME.get(i),"").split(";",lvls);
		if (lvls.num()) {
			String s=lvls.get(lvls.num()-1);
			if (!s.length())  lvls.delIndex(lvls.num()-1);
		}
		lvlnums=lvls.num();
		for (j=0;j<lvlnums;j++) TOTAL_STARS+=int(lvls.get(j));
	}
		if (["ui.billing"->getNoAds() as int]) { NOADS = 1; blevel_noads.hide(); }
		else { NOADS = 0; blevel_noads.show(); }
	return TOTAL_STARS;
}

//<ads>
public int hasAds() {
	//return blevel_noads.isVisible();
	return (NOADS == 0);
}
void cbBuyNoAdsResume() {
	blevel_noads.enable();
	blevel_noads.setOpacity(1.0);
}
void cbBuyNoAds() {
	blevel_noads.disable();
	blevel_noads.setOpacity(0.5);
	addListener(ON_TIMEOUT_MSEC,"20000","cbBuyNoAdsResume");
	if (APPNAME != "bunnymazehd"){
		["ui.billing"->buyNoAds()];
	}
}
//</ads>

void updateTotalStars() {
	string text=string(TOTAL_STARS)+"/"+string(AVAILABLE_STARS);
	blevel_total.setParam(PARAM_TEXT,text);
	blevel_stars.setPos(blevel_total.getX() - int(text.length()*20.5),blevel_total.getY()-2);
}

public int getCarrots(string _theme, int _level){	
	string carrotstring = appPropertyGet(APPNAME,"lvlcarrots_"+_theme,"");
	lists themecarrots = lists();
	int i,num;
	int level  = _level-1;
	carrotstring.split(";",themecarrots);
	num = themecarrots.num();
	if (num <= level){
		for(i=num;i<_level;i++){
			carrotstring+="0;";		
		}
		appPropertySet(APPNAME,"lvlcarrots_"+_theme,carrotstring);
		return 0;
	} else return int(themecarrots.get(level));
}

public void setCarrots(int carrots, string _theme, int _level){
	string carrotstring = appPropertyGet(APPNAME,"lvlcarrots_"+_theme,"");
	lists themecarrots = lists();
	int i,num;
	int level  = _level-1;
	carrotstring.split(";",themecarrots);
	num = themecarrots.num();
	if (num <= level){
		for(i=num;i<_level;i++){
			themecarrots.addIndex(i,"0;");
		}
	}
	themecarrots.set(level,string(carrots)+";");
	string newcarrotstring = "";
	int cnum=themecarrots.num();
	for(i=0;i<cnum;i++){
		newcarrotstring += themecarrots.get(i);
	}
	appPropertySet(APPNAME,"lvlcarrots_"+_theme,newcarrotstring);
}

public int setMaxCarrots(int carrots, string _theme, int _level){	
	string carrotstring = appPropertyGet(APPNAME,"lvlcarrots_"+_theme,"");
	lists themecarrots = lists();
	int i,num;
	int level  = _level-1;
	carrotstring.split(";",themecarrots);
	num = themecarrots.num();
	if (num <= level){
		for(i=num;i<=level;i++){
			themecarrots.addIndex(i,"0;");
		}
	}
	int maxcarrots = int(themecarrots.get(level));
	if (carrots > maxcarrots) {
		themecarrots.set(level,string(carrots));		
		string newcarrotstring = "";
		int cnum=themecarrots.num();
		for(i=0;i<cnum;i++){
			newcarrotstring += themecarrots.get(i)+";";
		}
		//errLog("Property to save: ["+newcarrotstring+"]");
		appPropertySet(APPNAME,"lvlcarrots_"+_theme,newcarrotstring);
	} 
	return maxcarrots;

}



void loadLevelScore(string _theme) {
	CURSOR.setParent(PARENT_HOME);
	int index=LEVELSET_NAME.findIndex(_theme);
	
	lists lvls,prev_lvls;
	lvls=lists();
	prev_lvls=lists();
	
	string new_unlocked=appPropertyGet(APPNAME,"lvlscore_"+_theme,"");
	new_unlocked.split(";",lvls);	
	LEVELSET_PREV_UNLOCKED.get(index).split(";",prev_lvls);	
	LEVELSET_PREV_UNLOCKED.set(index,new_unlocked);
	
	if (lvls.num()) {
		String s=lvls.get(lvls.num()-1);
		if (!s.length()) {
			lvls.delIndex(lvls.num()-1);
		}
	}
	if (prev_lvls.num()) {
		String s=prev_lvls.get(prev_lvls.num()-1);
		if (!s.length()) {
			prev_lvls.delIndex(prev_lvls.num()-1);
		}
	}
	
	if (_theme=="MORELEVELS") {
		Widget lock=LEVELSET_PAGES_LOCK.get(index);
		lock.show();
		return;
	}	
		
	Widget w,w2;
	int i,j,k;
	int grid_x=LEVELSET_GRID_X.get(index);
	int grid_y=LEVELSET_GRID_Y.get(index);
	int required_sp=LEVELSET_SP.get(index);
	list l_levels=LEVELSET_BUTTON.get(index);
	list l_levelnums=LEVELSET_NUMBERS.get(index);
	if (TOTAL_STARS<required_sp && (!bUnlockLevelSets)) {
		Widget lock=LEVELSET_PAGES_LOCK.get(index);
		lock.show();
		for (j=0;j<grid_y;j++) {	
			for (i=0;i<grid_x;i++) {
				int lvlindex=j*grid_x+i;
				w=l_levels.get(lvlindex);
				w2=l_levelnums.get(lvlindex);
				w.hide();
				w2.hide();
				w2.disable();
			}
		}
	}
	else {	
		AVAILABLE_STARS+=(grid_x*grid_y*3);
		Widget lock=LEVELSET_PAGES_LOCK.get(index);
		lock.hide();
		for (j=0;j<grid_y;j++) {	
			for (i=0;i<grid_x;i++) {
				int lvlindex=j*grid_x+i;
				int lvlstars=0;
				w=l_levels.get(lvlindex);
				w2=l_levelnums.get(lvlindex);
				w.show();
				w2.show();
				w2.enable();
				w.delChildren();
				w.enable();

				//finished
				if ((lvlindex<lvls.num()) || bUnlockLevels) {		
					w2.setOpacity(1.0);
					w2.enable();
					w.setparam(PARAM_THEME,"LINEAR:textures/ui/level_finished_normal.image,textures/ui/level_finished_normal.image,textures/ui/level_finished_pressed.image");
					int maxstars,prev_maxstars;
					if (lvlindex<lvls.num()) { 
						maxstars=int(lvls.get(lvlindex)); 
						prev_maxstars=int(prev_lvls.get(lvlindex));
					}
					else {
						prev_maxstars=0;
						maxstars=prev_maxstars;
					}
					
					for (k=0;k<maxstars;k++) {
						Widget wstar;
						wstar=Widget(w,UI_ICON);
						wstar.setParam(PARAM_IMAGE,"LINEAR:textures/ui/level_star.image");
						wstar.setSize(w.getW()*GRID_STAR_SCALE,w.getH()*GRID_STAR_SCALE);						
						wstar.setPos(GRID_STAR_OFFSET+k*GRID_STAR_STRIDE,w.getH()-24);
						if (k>prev_maxstars) {
							wstar.setOpacity(0.0);
							wstar.fadeIn(500,"");
						}
					}
				}
				//next level
				else if (lvlindex==lvls.num()) {
					if (lvlindex>prev_lvls.num()) {
						newLvlNum=w2;
						newLvlButton=w;
						newLvlButton.disable();			
						
						wfxcont.setPos(w.getX(),w.getY());
						
						wfx3=Widget(wfxcont,UI_LOADRING);
						wfx3.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
						wfx3.setParam(PARAM_IMAGE,"LINEAR:textures/ui/homestreaks.image");
						wfx3.setParam(PARAM_ROTATION_SPEED,"-3");
						wfx3.setSize(0,0); 
						wfx3.setPos(wfxcont.getW()/2,wfxcont.getH()/2);
						wfx3.animate("W","L0:0;L"+string(400)+":1000;L"+string(400)+":2000;L0:3000","");
						wfx3.animate("H","L0:0;L"+string(400)+":1000;L"+string(400)+":2000;L0:3000","");
						wfx3.animate("A","L0:0;L1:500;L1:2000;L0:3000","");
						
						wfx2=Widget(w,UI_ICON);
						wfx2.setParam(PARAM_IMAGE,"LINEAR:textures/ui/level_disabled_normal.image");
						wfx2.setSize("100%","100%");

						wfx=Widget(w,UI_ADDITIVE);
						wfx.setSize("100%","100%");
					
						Widget ic=Widget(wfx,UI_ICON);
						ic.setParam(PARAM_IMAGE,"LINEAR:textures/ui/level_effect.image");
						ic.setSize("100%","100%");

						wfx.setOpacity(0.0);
						w2.setOpacity(0.0);
						w2.enable();
						wfx.onLoad("cbNewLevelLoad");
					}
					else {
						w2.setOpacity(1.0);
						w2.enable();
						w.setparam(PARAM_THEME,"LINEAR:textures/ui/level_active_normal.image,textures/ui/level_active_normal.image,textures/ui/level_active_pressed.image");
					}
				}
				else {
					w2.setOpacity(0.0);
					w2.disable();
					w.disable();
					w.setparam(PARAM_THEME,"LINEAR:textures/ui/level_disabled_normal.image,textures/ui/level_disabled_normal.image,textures/ui/level_disabled_pressed.image");
				}			
			}
		}
	}
}
void cbNewLevelLoad() {
	wfx2.onLoad("cbNewLevelLoad2");
}
void cbNewLevelLoad2() {
	newLvlButton.setparam(PARAM_THEME,"LINEAR:textures/ui/level_active_normal.image,textures/ui/level_active_normal.image,textures/ui/level_active_pressed.image");
	newLvlButton.onLoad("cbNewLevelLoad3");
}
void cbNewLevelLoad3() {
	snd.play("sounds/win2.audio");
	wfx.setOpacity(0.0);
	wfx.fadeIn(500,"cbNewLevelFadeIn");
}
void cbNewLevelFadeIn() {
	wfx.fadeOut(500,"");
	wfx2.fadeOut(500,"");
	
	newLvlNum.setOpacity(0.0);
	newLvlNum.fadeIn(500,"");
	
	newLvlButton.setOpacity(0.0);
	newLvlButton.fadeIn(500,"");
	newLvlButton.enable();
}
int quantizeRequiredSP(int _t) {
	int m=_t/10;
	int r=_t-(m*10);
	int ret=m*10;
	if (r>=5) ret+=5;
	return ret;
}


// add the levelset and return the total number of Start Points contained
// within this levelset
int addSet(string name, int GRID_X, int GRID_Y, int SP, string bgtex){
	int CONST_SP_MAX_PER_LEVEL=3;
	
	LEVELSET_NAME.push(name);
	LEVELSET_GRID_X.push(GRID_X);
	LEVELSET_GRID_Y.push(GRID_Y);	
	LEVELSET_SP.push(SP);
	
	numsets++;
	if (bgtex.length==0) {
		cacheBackdrop(name);
		LEVELSET_TITLE.push(string(numsets));
	}
	else {
		cacheTexture(bgtex);
		LEVELSET_TITLE.push("Stay Tuned!");
	}
				
	return GRID_X*GRID_Y*CONST_SP_MAX_PER_LEVEL;
}

void loadLevelSets() {
	int SP_PER_LEVEL=3;
	float SP_SET_MUL=8.5; // (21-1)/3
	float SP_BONUS_FACTOR=0.08;
	int CUMULATIVE_SP=0;
	int LSP=0;

	//forest
	//print("");
	//print("LSP: "+string(LSP) + "  CUMULATIVE_SP: "+string(CUMULATIVE_SP));
	CUMULATIVE_SP+=addSet("forest",7,3,0,"");
	
	//docks
	LSP=CUMULATIVE_SP-int(SP_PER_LEVEL*SP_SET_MUL)-int(LSP*SP_BONUS_FACTOR)-8;
	//print("LSP: "+string(LSP) + "  CUMULATIVE_SP: "+string(CUMULATIVE_SP));
	CUMULATIVE_SP+=addSet("docks",7,3,LSP,"");
	
	//desert
	LSP=CUMULATIVE_SP-int(SP_PER_LEVEL*SP_SET_MUL)-int(LSP*SP_BONUS_FACTOR)-3;
	//print("LSP: "+string(LSP) + "  CUMULATIVE_SP: "+string(CUMULATIVE_SP));
	CUMULATIVE_SP+=addSet("desert",7,3,LSP,"");

	//snow
	LSP=CUMULATIVE_SP-int(SP_PER_LEVEL*SP_SET_MUL)-int(LSP*SP_BONUS_FACTOR);
	//print("LSP: "+string(LSP) + "  CUMULATIVE_SP: "+string(CUMULATIVE_SP));
	CUMULATIVE_SP+=addSet("snow",7,3,LSP,"");

	//city
	LSP=CUMULATIVE_SP-int(SP_PER_LEVEL*SP_SET_MUL)-int(LSP*SP_BONUS_FACTOR);
	//print("LSP: "+string(LSP) + "  CUMULATIVE_SP: "+string(CUMULATIVE_SP));
	CUMULATIVE_SP+=addSet("city",7,3,LSP,"");

	//jungle
	LSP=CUMULATIVE_SP-int(SP_PER_LEVEL*SP_SET_MUL)-int(LSP*SP_BONUS_FACTOR)-6;
	//print("LSP: "+string(LSP) + "  CUMULATIVE_SP: "+string(CUMULATIVE_SP));
	CUMULATIVE_SP+=addSet("jungle",7,3,LSP,"");
	
	//toyland
	//LSP=CUMULATIVE_SP-(SP_PER_LEVEL*SP_SET_MUL);
	//CUMULATIVE_SP+=addSet("toyland",7,3,LSP,"");
	
	//more to come
	addSet("MORELEVELS",0,0,LSP,"ui_morelevels_bg.image"); //That's a custom set
	//LEVELSET_TITLE.push("Stay tuned!");
	
	CURRENT_LEVELSET=LEVELSET_NAME.get(0);

	//load widgets
	int i,num;
	num=LEVELSET_NAME.num();
	for (i=0;i<num;i++) {
		LEVELSET_PREV_UNLOCKED.push(appPropertyGet(APPNAME,"lvlscore_"+LEVELSET_NAME.get(i),""));
	
		Widget parent=Widget(PARENT_LEVELS,UI_WIDGET);
		if (i>0) parent.setOpacity(0.5);
		LEVELSET_PAGES.push(parent);		
		parent.setPivot(PIVOTX_CENTER,PIVOTY_TOP);
		parent.setSize(800,480);
		parent.setPos(400+800*i,0);
		//add buttons
		list l_buttons=list();
		list l_numbers=list();
		LEVELSET_BUTTON.push(l_buttons);
		LEVELSET_NUMBERS.push(l_numbers);
		
		int spacing_x=GRID_BUTTON_SPACING_X;
		int spacing_y=GRID_BUTTON_SPACING_Y;
		//int size=76;
		int size=GRID_BUTTON_SIZE;
		int x,y;
		int grid_x=LEVELSET_GRID_X.get(i);
		int grid_y=LEVELSET_GRID_Y.get(i);
		int offx=(size+800-grid_x*spacing_x)/2;
		int offy=GRID_OFFY; //General Y offset of UI locks buttons. Set to 100 for lenovoTV
		int fontoffy=-3;
		int marginx=4;
		wfxcont.setSize(size,size);
		for (y=0;y<grid_y;y++) {	
			for (x=0;x<grid_x;x++) {
				Widget w=Widget(parent,UI_PUSHBUTTON);
				w.setparam(PARAM_THEME,"LINEAR:textures/ui/level_active_normal.image,textures/ui/level_active_normal.image,textures/ui/level_active_pressed.image");				
				w.setPivot(PIVOTX_CENTER,PIVOTY_TOP);
				w.setSize(size,size);			
				w.setPos(marginx+offx+(x*spacing_x),offy+(y*spacing_y));
				w.setData(string(1+y*grid_x+x));
				l_buttons.push(w);
			}
		}
		marginx=2;
		for (y=0;y<grid_y;y++) {	
			for (x=0;x<grid_x;x++) {
				Widget w2=Widget(parent,UI_TEXFONTLABEL);
				w2.setPivot(PIVOTX_CENTER,PIVOTY_TOP);
				w2.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font.image");
				w2.setparam(PARAM_FONTSIZE,"30,30");
				w2.setparam(PARAM_FONTSPACING,"-0.4");
				w2.setSize(size,size);			
				w2.setPos(marginx+offx+3+(x*spacing_x),offy+(y*spacing_y)+fontoffy);
				w2.setData(string(1+y*grid_x+x));
				w2.setParam(PARAM_TEXT,w2.getData());
				w2.setParam(PARAM_TEXTALIGN,"center");
				w2.enableGhost(1);
				l_numbers.push(w2);
			}
		}	
		if (LEVELSET_NAME.get(i)=="MORELEVELS") {
			Widget lock=Widget(parent,UI_ICON);
			lock.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
			lock.setSize(370,370);
			lock.setPos(400,140+offy);
			lock.setParam(PARAM_IMAGE,"LINEAR:textures/ui/ui_morelevelstocome.image");
			lock.hide();
			LEVELSET_PAGES_LOCK.push(lock);
		}
		else {
			Widget lock=Widget(parent,UI_PUSHBUTTON);
			lock.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
			lock.setSize(300,300);
			lock.setPos(400,155+offy);//was 140
			lock.setParam(PARAM_THEME,"LINEAR:textures/ui/ui_levelset_lock.image,textures/ui/ui_levelset_lock.image,textures/ui/ui_levelset_lock.image");
			lock.hide();
			LEVELSET_PAGES_LOCK.push(lock);
	
			Widget w3=Widget(lock,UI_ICON);
			w3.setPivot(PIVOTX_RIGHT,PIVOTY_MIDDLE);
			w3.setSize(40,40);
			w3.setPos(144,150);
			w3.setParam(PARAM_IMAGE,"LINEAR:textures/ui/ui_browser_star.image");
			w3.enableGhost(1);
			
			w3=Widget(lock,UI_TEXFONTLABEL);
			w3.setPivot(PIVOTX_LEFT,PIVOTY_MIDDLE);
			w3.setSize(40,40);
			w3.setPos(130,150);
			w3.enableGhost(1);				
			w3.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font.image");
			w3.setparam(PARAM_FONTSIZE,"32,32");
			w3.setparam(PARAM_FONTSPACING,"-0.4");
			w3.setparam(PARAM_TEXTALIGN,"left");
			w3.setparam(PARAM_TEXT,string(LEVELSET_SP.get(i)));
		}
	}	
}

/////////// BACK PRESSED ///////////

void cbQuit() {}

///////// BACKGROUND LOADING //////////

string last_imagename;
int bg_loaded=1;
string bg_toload;
void doBackground(string _page) {
	string imgname;
	if (_page=="home") {
		imgname="LINEAR:textures/ui/homebg.image";
	} 
	else if (_page=="MORELEVELS") { 
		imgname="LINEAR:textures/ui/ui_morelevels_bg.image";
	}
	else {
		imgname="LINEAR:levelsets/"+_page+"/textures/levelset_bg_"+_page+".image";
	}
	if (last_imagename==imgname) {
		return;
	}
	
	analytics_trackview("/hd/lobby/"+_page);	
	
	bg_loaded=0;
	Backdrop_FG.setOpacity(0.0);
	Backdrop_FG.clearanimate("");	
	last_imagename=imgname;
	Backdrop_FG.setParam(PARAM_IMAGE,last_imagename); 
	Backdrop_FG.onLoad("cbFGLoaded");
}
void cbFGLoaded() {
	Backdrop_FG.animate("A","0:0;1:500","");
	Backdrop_FG.animate("W","1200:0;800:500","");
	Backdrop_FG.animate("H","720:0;480:500","cbAnimFinished");
}
void cbAnimFinished() {
	Backdrop_BG.setParam(PARAM_IMAGE,last_imagename); 
	Backdrop_BG.onLoad("cbBGLoaded");
}
void cbBGLoaded() {
	Backdrop_FG.setOpacity(0.0);
	bg_loaded=1;
}
void loadBackground() {
	delListener(ON_TIMEOUT_MSEC,"loadBackground");	
	if (!bg_loaded) {
		addListener(ON_TIMEOUT_MSEC,"100","loadBackground");
	}
	else {
		doBackground(bg_toload);
	}
}

////////// HOME ANIMATION ///////////

void loadHomeAnim() {
	homelogo.animate("Y","-256:0;-256:500;220:1100;220:1500","");
	homelogo2.animate("Y","-300:0;-300:500;260:1100;220:1500","");
	homestreaks.animate("A","L0:0;L0:1500;L1:1700","");
	homelogo.animate("A","0:0;0:500;1:700","");
	homelogo2.animate("A","0:0;0:500;1:700","");
}
void cbPause() {
	snd.fplay("sounds/button.audio");
	B_PAUSE=1;
	HUDFG.fadeOut(200,"");
	sendEvent("OPTIONS","ui.options");
	gpad.onButtonDown("");
}
void e_resume() {
	HUDFG.fadeIn(200,"cbResumeEnd");
	B_PAUSE=0;
}
void cbResumeEnd() {
	gpad.onButtonDown("cbGamepad");
}

////////// PLAY //////////
void cbHome() {
	snd.fplay("sounds/button.audio");
	CURSOR.hide();
	CURSOR_WIDGET=bhome_play;
	gpad.onButtonDown("cbGamepad");
	clearListeners(ON_MOUSEDOWN);
	clearListeners(ON_MOUSEUP);
	clearListeners(ON_MOUSEMOTION);

	appPropertySet(APPNAME,"state","");
	appPropertyFlush();
	PARENT_HOME.animate("A",string(PARENT_HOME.getOpacity())+":0;1:500","");
	PARENT_HOME.animate("X",string(PARENT_HOME.getX())+":0;400:500","");
	PARENT_LEVELS.animate("X",string(PARENT_LEVELS.getX())+":0;1200:500","");
	PARENT_LEVELS.animate("A",string(PARENT_LEVELS.getOpacity())+":0;0:500","cbHomeFinished");
	CURRENT_PAGE=0;
	PARENT_HOME.show();
	bg_toload="home";
	loadBackground();
	loadHomeAnim();
}
void cbHomeFinished() {
	PARENT_LEVELS.hide();
}
void cbPlay() {
	gpad.onButtonDown("cbGamepad");
	addListener(ON_MOUSEDOWN,"cbMouseDown");
	addListener(ON_MOUSEUP,"cbMouseUp");
	addListener(ON_MOUSEMOTION,"cbMouseMotion");

	appPropertySet(APPNAME,"state","LEVELSELECT:"+CURRENT_LEVELSET);
	appPropertyFlush();
	PARENT_HOME.animate("A",string(PARENT_HOME.getOpacity())+":0;0:500","");
	PARENT_HOME.animate("X",string(PARENT_HOME.getX())+":0;-400:500","");
	PARENT_LEVELS.animate("X",string(PARENT_LEVELS.getX())+":0;400:500","");
	PARENT_LEVELS.animate("A",string(PARENT_LEVELS.getOpacity())+":0;1:500","cbPlayFinished");
	CURRENT_PAGE=1;
	PARENT_LEVELS.show();
	bg_toload=CURRENT_LEVELSET;
	loadBackground();
	
	CURSOR.hide();
	list buttons=LEVELSET_NUMBERS.get(LEVELSET_NAME.findIndex(CURRENT_LEVELSET));
	CURSOR_WIDGET=buttons.get(0);
}
void cbPlayButton() {
	snd.fplay("sounds/button.audio");
	cbPlay();
}
void cbPlayFinished() {
	PARENT_HOME.hide();
}
void cbSelectLevel(string _theme,int _level) {
	snd.fplay("sounds/button.audio");
	gpad.onButtonDown("");
	clearListeners(ON_MOUSEDOWN);
	clearListeners(ON_MOUSEUP);
	clearListeners(ON_MOUSEMOTION);

	Event e=Event("PLAY","sc.control");
	e.addArg(_theme);
	e.addArg(_level);
	sendEvent(e);
}
void cbResumeGPAD() {
	gpad.onButtonDown("cbGamepad");
}
void gotoLevelSet(int index) {
	if (index<0 || index>=LEVELSET_NAME.num()) { return; }	
	string cb;
	CURRENT_LEVELSET=LEVELSET_NAME.get(index);	
	bg_toload=CURRENT_LEVELSET;
	appPropertySet(APPNAME,"state","LEVELSELECT:"+CURRENT_LEVELSET);
	appPropertyFlush();
	Widget w=L_SCROLL_DOTS.get(index);
	ActiveDot.setPos(w.getX(),w.getY());
	
	gpad.onButtonDown("");
	
	int i,num;
	num=LEVELSET_NAME.num();
	for (i=0;i<num;i++) {
		w=LEVELSET_PAGES.get(i);
		w.animate("X",string(w.getX())+":0;"+string(400+(i-index)*800)+":300","loadBackground");
		if (i==index) {
			w.animate("A",string(w.getOpacity())+":0;1:300","cbResumeGPAD");
		}
		else {
			w.animate("A",string(w.getOpacity())+":0;0.5:300","");
		} 
	}
	
	Widget lock=LEVELSET_PAGES_LOCK.get(index);	
	if (lock.isVisible() && (CURRENT_LEVELSET!="MORELEVELS")) {
		blevel_buy.fadeIn(300,"");
		blevel_buy.enable();
	}
	else {
		blevel_buy.fadeOut(300,"");
		blevel_buy.disable();
	}

	list buttons=LEVELSET_NUMBERS.get(index);
	CURSOR.hide();
	if (buttons.num()) {
		w=buttons.get(0);								
		if (w.isEnabled()) CURSOR_WIDGET=w;
		else CURSOR_WIDGET=blevel_home;
	}
	else CURSOR_WIDGET=blevel_home;
	
	if (show_controller) showController();
}

//////////// SWIPE ////////////
int mouse_down=0,mouse_moved=0;
float2 mouse_pos;
void cbMouseDown(int button,float3 mod,float2 pos) {
	mouse_pos=pos;
	mouse_down=1;
	mouse_moved=0;
	if ((!this.isVisible()) || B_PAUSE || (CURRENT_PAGE==0) || B_BILLING) {
		mouse_down=0;
	}
	else {
		int i;
		for (i=0;i<LEVELSET_PAGES.num();i++) {
			Widget(LEVELSET_PAGES.get(i)).clearanimate("");
		}
	}
}
void cbMouseUp(int _button, float3 _mod,float2 pos) {
	if (!mouse_down) return;
	mouse_down=0;
	int i,index=LEVELSET_NAME.findIndex(CURRENT_LEVELSET);
	Widget p=LEVELSET_PAGES.get(index);
	string cb;
	//next
	if (p.getX()<380 && (index+1)<LEVELSET_NAME.num()) {
		index++;
	}
	//previous
	else if (p.getX()>420 && (index-1)>=0) {
		index--;
	}
	//select button 
	else if (!mouse_moved) {
		if (CURRENT_LEVELSET!="MORELEVELS") {
			Widget lock=LEVELSET_PAGES_LOCK.get(index);
			if (lock.isVisible()) {
				if (lock.isMouseOnTop(pos)) {
					fCall("cbBuy");
				}
			}
			else {	
				list l_buttons=LEVELSET_BUTTON.get(index);
				for (i=0;i<l_buttons.num();i++) {
					Widget b=l_buttons.get(i);
					if (b.isMouseOnTop(pos)) {
						if (b.isEnabled()) {
							gotoLevelSet(index);
							cbSelectLevel(LEVELSET_NAME.get(index),int(b.getData()));
							return;
						}
						break;
					}
				}
			}
		}
	}
	
	gotoLevelSet(index);
}
void cbMouseMotion(float2 offset,float2 pos) {
	if (mouse_down) {
		if ((mouse_pos-pos).length()>20) { mouse_moved=1; }
		int i,num,index=LEVELSET_NAME.findIndex(CURRENT_LEVELSET);
		num=LEVELSET_PAGES.num();
		for (i=0;i<num;i++) {
			Widget n=LEVELSET_PAGES.get(i);
			n.setPos(400+((i-index)*800)+pos.x()-mouse_pos.x(),n.getY());
		}
	}
}
public void refreshScore() {
	AVAILABLE_STARS=0;
	getTotalStars();
	int i,num;
	num=LEVELSET_NAME.num();
	for (i=0;i<num;i++) {
		loadLevelScore(LEVELSET_NAME.get(i));
	}
	updateTotalStars();
	if (FLAG_THANKS) addListener(ON_TIMEOUT_MSEC,"2000","cbThanks");
}
void cbThanks() {
	if (FLAG_THANKS) {
		if (this.isVisible() && (B_BILLING==0)) {
			FLAG_THANKS=0;
			CURSOR.hide();
			B_BILLING=1;	
			["ui.billing"->open_thanks()];			
		}
		else {
			addListener(ON_TIMEOUT_MSEC,"2000","cbThanks");
		}
	}
}
void e_resetlevels() {
	int i,num;
	num=LEVELSET_NAME.num();
	for (i=0;i<num;i++) {
		appPropertySet(APPNAME,"lvlscore_"+LEVELSET_NAME.get(i),"");
		LEVELSET_PREV_UNLOCKED.set(i,"");
	}
	appPropertyFlush();
	refreshScore();
}
void e_home() {
	CURSOR.hide();
	CURSOR_WIDGET=bhome_play;
	this.show();
	gpad.onButtonDown("");	
	bg_toload="home";
	fCall("loadBackground");
	fCall("loadHomeAnim");
	addListener(ON_TIMEOUT_MSEC,"200","cbResumeEnd");
}
void e_hide() {
	this.hide();
	gpad.onButtonDown("");
	clearListeners(ON_MOUSEDOWN);
	clearListeners(ON_MOUSEUP);
	clearListeners(ON_MOUSEMOTION);
}
void e_levels() {
	this.show();
	gpad.onButtonDown("");
	addListener(ON_MOUSEDOWN,"cbMouseDown");
	addListener(ON_MOUSEUP,"cbMouseUp");
	addListener(ON_MOUSEMOTION,"cbMouseMotion");
	
	refreshScore();
	
	//check for current page
	if (CURRENT_PAGE==0) {
		fCall("cbPlay");
	}	
	int index=LEVELSET_NAME.findIndex(CURRENT_LEVELSET);	
	Widget w=L_SCROLL_DOTS.get(index);
	ActiveDot.setPos(w.getX(),w.getY());	
	int i,num;
	num=LEVELSET_NAME.num();
	for (i=0;i<num;i++) {
		w=LEVELSET_PAGES.get(i);
		w.setPos(400+(i-index)*800,w.getY());
		if (i==index) {
			w.setOpacity(1.0);
		}
		else {
			w.setOpacity(0.5);
		}
	}	
	Widget lock=LEVELSET_PAGES_LOCK.get(index);
	if (lock.isVisible()) {
		blevel_buy.show();
		blevel_buy.enable();
		blevel_buy.setOpacity(1.0);
	}
	else {
		blevel_buy.disable();
		blevel_buy.hide();
		blevel_buy.setOpacity(0.0);
	}
	list buttons=LEVELSET_NUMBERS.get(index);
	CURSOR_WIDGET=buttons.get(0);
	CURSOR.setParent(CURSOR_WIDGET);
	CURSOR.hide();	
	
	addListener(ON_TIMEOUT_MSEC,"200","cbResumeEnd");
}
void e_nextlevel(int _level) {
	int index=LEVELSET_NAME.findIndex(CURRENT_LEVELSET);	
	int total=LEVELSET_GRID_X.get(index)*LEVELSET_GRID_Y.get(index);
	if (_level>total) {
		gotoLevelSet(index+1);
		sendEvent("QUITLEVEL","sc.control");
	}
	else {
		Event e=Event("PLAY","sc.control");
		e.addArg(LEVELSET_NAME.get(index));
		e.addArg(_level);
		sendEvent(e);
	}
}
public void e_setCurrentTheme(string _theme) {
	if (LEVELSET_NAME.findIndex(_theme)<LEVELSET_NAME.num()) {
		CURRENT_LEVELSET=_theme;
	}
}
public int validate(string _theme,int _level) {
	int index=LEVELSET_NAME.findIndex(_theme);
	if (index>=LEVELSET_NAME.num()) { return 0; }
	if (_level<=0 || _level>( LEVELSET_GRID_X.get(index) *  LEVELSET_GRID_Y.get(index) )) { return 0; }
	return 1;	
}
void cbGamepad(int _controller,int _action) {
	if (B_BILLING || B_PAUSE || (!this.isVisible()) || _action==GAMEPAD_BACK) { return; } 
	if (_action==GAMEPAD_START || _action==GAMEPAD_MENU) {
		cbPause();
	}
	else if (_action==GAMEPAD_B && CURRENT_PAGE>0) 	cbHome();
	else if (_action==GAMEPAD_LBUTTON || _action==GAMEPAD_LTRIGGER) {
		if (CURRENT_PAGE>0) {
			int index=LEVELSET_NAME.findIndex(CURRENT_LEVELSET);
			gotoLevelSet(index-1);
		}
	}
	else if (_action==GAMEPAD_RBUTTON || _action==GAMEPAD_RTRIGGER) {
		if (CURRENT_PAGE>0) {
			int index=LEVELSET_NAME.findIndex(CURRENT_LEVELSET);
			gotoLevelSet(index+1);
		}
	}
	else {
		if (CURSOR.isVisible()) {
			if (gpad.isDPAD(_action)) {
				if (_action==GAMEPAD_LEFT) {
					if (CURSOR_WIDGET==bhome_play) 			 CURSOR_WIDGET=bhome_facebook;
					else if (CURSOR_WIDGET==bhome_facebook)  CURSOR_WIDGET=bhome_credits;
					else if (CURSOR_WIDGET==bhome_credits) 	 CURSOR_WIDGET=bhome_quit;	
					else if (CURSOR_WIDGET==blevel_buy_over) {
						if (blevel_noads.isVisible()) CURSOR_WIDGET=blevel_noads; 
						else CURSOR_WIDGET=blevel_facebook;
						}
					else if (CURSOR_WIDGET==blevel_noads) CURSOR_WIDGET=blevel_facebook;
					else if (CURSOR_WIDGET==blevel_facebook) CURSOR_WIDGET=blevel_options;
					else if (CURSOR_WIDGET==blevel_options)  CURSOR_WIDGET=blevel_home;
					else if (CURRENT_PAGE>0) {
						list buttons=LEVELSET_NUMBERS.get(LEVELSET_NAME.findIndex(CURRENT_LEVELSET));
						int index=buttons.findIndex(CURSOR_WIDGET);
						if ((index<buttons.num()) && (index>0)) {
							Widget w=buttons.get(index-1);
							if (w.isEnabled())	CURSOR_WIDGET=w;
						}
					}
				}
				else if (_action==GAMEPAD_RIGHT) {
					if (CURSOR_WIDGET==bhome_quit)			CURSOR_WIDGET=bhome_credits;
					else if (CURSOR_WIDGET==bhome_credits)  CURSOR_WIDGET=bhome_facebook;
					else if (CURSOR_WIDGET==bhome_facebook)  CURSOR_WIDGET=bhome_play;
					else if (CURSOR_WIDGET==blevel_home) 	CURSOR_WIDGET=blevel_options;
					else if (CURSOR_WIDGET==blevel_options) CURSOR_WIDGET=blevel_facebook;
					else if (CURSOR_WIDGET==blevel_facebook) {
						if (blevel_noads.isVisible()) CURSOR_WIDGET=blevel_noads; 
						else if (blevel_buy.isVisible())	CURSOR_WIDGET=blevel_buy_over;
					}
					else if (CURSOR_WIDGET==blevel_noads) {
						if (blevel_buy.isVisible())	CURSOR_WIDGET=blevel_buy_over;
					}					
					else if (CURRENT_PAGE>0) {
						list buttons=LEVELSET_NUMBERS.get(LEVELSET_NAME.findIndex(CURRENT_LEVELSET));
						int index=buttons.findIndex(CURSOR_WIDGET);
						if ((index+1)<buttons.num()) {
							Widget w=buttons.get(index+1);
							if (w.isEnabled())	CURSOR_WIDGET=w;
						}
					}
				}
				else if (_action==GAMEPAD_UP) {
					if (CURRENT_PAGE>0) {
						list buttons=LEVELSET_NUMBERS.get(LEVELSET_NAME.findIndex(CURRENT_LEVELSET));
						int index=buttons.findIndex(CURSOR_WIDGET);
						if (index<buttons.num()) {
							int row=LEVELSET_GRID_X.get(LEVELSET_NAME.findIndex(CURRENT_LEVELSET));
							if ( (index-row)>=0 ) {
								Widget w=buttons.get(index-row);
								if (w.isEnabled())	CURSOR_WIDGET=w;
							}
						}
						else {
							//find the first active widget
							int i;
							for (i=buttons.num()-1;i>=0;i--) {
								Widget w=buttons.get(i);
								if (w.isEnabled()) {
									CURSOR_WIDGET=w;
									break;
								}
							}
						}
					}
				}
				else if (_action==GAMEPAD_DOWN) {
					if (CURRENT_PAGE>0) {
						list buttons=LEVELSET_NUMBERS.get(LEVELSET_NAME.findIndex(CURRENT_LEVELSET));
						int index=buttons.findIndex(CURSOR_WIDGET);
						if (index<buttons.num()) {
							int row=LEVELSET_GRID_X.get(LEVELSET_NAME.findIndex(CURRENT_LEVELSET));
							if ( (index+row)<buttons.num() ) {
								Widget w=buttons.get(index+row);
								if (w.isEnabled())	CURSOR_WIDGET=w;
								else CURSOR_WIDGET=blevel_home;
							}
							else CURSOR_WIDGET=blevel_home;
						}
					}
				}
			}
			else if (_action==GAMEPAD_A) {
				if (CURRENT_PAGE>0) {
					list buttons=LEVELSET_NUMBERS.get(LEVELSET_NAME.findIndex(CURRENT_LEVELSET));
					int index=buttons.findIndex(CURSOR_WIDGET);
					if (index<buttons.num()) {
						Widget b=buttons.get(index);
						if (b.isEnabled()) {
							cbSelectLevel(CURRENT_LEVELSET,int(b.getData()));
						}
						return;
					}
				}
				if (CURSOR_WIDGET==blevel_buy_over) {
					blevel_buy.doAction();
				}
				else {
					CURSOR_WIDGET.doAction();
				}
			}
		}
		else CURSOR.show();
		//position cursor
		CURSOR.setParent(CURSOR_WIDGET);
		CURSOR.setPos( (CURSOR_WIDGET.getW()*2)/3,CURSOR_WIDGET.getH()/2);
	}
}
void cbBuy() {
	snd.fplay("sounds/button.audio");
	CURSOR.hide();
	B_BILLING=1;
	int r=LEVELSET_SP.get( LEVELSET_NAME.findIndex(CURRENT_LEVELSET) ) - TOTAL_STARS;
	["ui.billing"->open(r)];
}
void cbCredits() {
	snd.fplay("sounds/button.audio");
	CURSOR.hide();
	B_BILLING=1;
	["ui.credits"->open()];
}
void cbFacebook() {
	openURL("http://www.facebook.com/bunnymaze3d");
}
void cbTwitter() {
	openURL("http://www.twitter.com/bunnymaze3d");
}
void cbRestorePurchases() {
	["ui.billing"->restorePurchases()];
	if (["ui.init"->isIos() as int]) {
		bhome_restore.setOpacity(0.5);
		bhome_restore.disable();
	}
}
public void billingOff() { B_BILLING=0; }

