 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib gui 

#hive 1

Layout HUD;
Widget loadring,w_bunnylogo;
String reply_tag,reply_event;
int loadperc;

string APPNAME="bunnymaze";

void init() {
	setTag("ui.loading");
	//add HUD container
	HUD=Layout();
	HUD.show();
	HUD.setBaseSize(800,480,"autofit");
	
	Widget bg=Widget(HUD,UI_ICON);
	bg.setSize("100%","100%");
	bg.setParam(PARAM_IMAGE,"LINEAR:textures/ui/bluebg.image");

	w_bunnylogo=Widget(HUD,UI_ICON);
	w_bunnylogo.setParam(PARAM_IMAGE,"LINEAR:textures/ui/logo-"+APPNAME+".image");
	w_bunnylogo.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);	
	w_bunnylogo.setSize(460,230);
	w_bunnylogo.setPos(400,240);
	w_bunnylogo.hide();	
	
	loadring=Widget(HUD,UI_LOADRING);
	loadring.setPivot(PIVOTX_RIGHT,PIVOTY_BOTTOM);
	loadring.setSize(32,32);
	loadring.setPos(790,470);
	loadring.setParam(PARAM_ROTATION_SPEED,"-3");
	loadring.setParam(PARAM_FRAMERATE,"16");
	loadring.setParam(PARAM_LOADRING_SEGMENTS,"8");
	loadring.setParam(PARAM_LOADRING_SEGMENTS,"8");
	loadring.setParam(PARAM_IMAGE,"LINEAR:textures/ui/loadingprogressring.image");
	loadring.hide();
	
	addListener(ON_EVENT,"SHOW","e_show");
	addListener(ON_EVENT,"HIDE","e_hide");
}
/// ANIMATION
void startLoadAnim() {
	this.show();
	HUD.hide();
	HUD.fadeIn(400,"");
	loadring.fadeTo(500,0.75,"cbCallback");
	w_bunnylogo.hide();
	w_bunnylogo.fadeIn(260,"");
	//w_bunnylogo.setPos(400,240);
	w_bunnylogo.animate("Y","0:0;240:500","");
	loadperc=0;
	loadring.setParam(PARAM_PERCENTAGE,"0");
	addListener(ON_TIMEOUT_MSEC,"100","cbRing");
} 
void stopLoadAnim() {
	HUD.fadeOut(500,"cbEnd");
	loadring.fadeTo(500,0.75,"cbDelRing");
	w_bunnylogo.fadeOut(260,"");
	w_bunnylogo.animate("Y","240:0;600:700","cbCallback");	
}
void cbDelRing() {
	delListener(ON_TIMEOUT_MSEC,"cbRing");
}
void cbRing() {
	if (pollForComplete()>loadperc) loadperc+=12.5;
	loadring.setParam(PARAM_PERCENTAGE,string(loadperc));
	addListener(ON_TIMEOUT_MSEC,"100","cbRing");
}
void cbEnd() {
	this.hide();
}  
void cbCallback() {
	sendEvent(reply_event,reply_tag);
}
void e_show(string _tag,string _event) {
	delListener(ON_TIMEOUT_MSEC,"stopLoadAnim");
	reply_tag=_tag;
	reply_event=_event;
	startLoadAnim();
}
void e_hide(string _tag,string _event) {
	delListener(ON_TIMEOUT_MSEC,"stopLoadAnim");
	reply_tag=_tag;
	reply_event=_event;
	stopLoadAnim();
}
