 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib gui
#hive 1

Layout HUD,HUDNOTEPAD;
Widget NOTEPAD,CIRCLE,LEFTPAD,RIGHTPAD,TOPPAD,BOTTOMPAD,NOTEPAD_FG;

string REPLYTAG,REPLYEVENT;
string BGCOLOR="0,0,0,255";

void init() {
	setTag("ui.notepad");
	
	//add HUD container
	HUD=Layout();
	HUD.setBaseSize(800,480,"nofit");
	HUD.enableGhost(1);
	HUD.show();
	
	HUDNOTEPAD=Layout();
	HUDNOTEPAD.setBaseSize(800,480,"autofit");
	HUDNOTEPAD.enableGhost(1);
	HUDNOTEPAD.show();

	CIRCLE=Widget(HUD,UI_ICON);
	CIRCLE.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	CIRCLE.setSize(0,0);
	CIRCLE.setParam(PARAM_IMAGE,"LINEAR:textures/ui/ui_circle_mask.image");
	
	LEFTPAD=Widget(HUD,UI_PANEL);
	LEFTPAD.setPivot(PIVOTX_LEFT,PIVOTY_TOP);
	LEFTPAD.setParam(PARAM_COLOR,BGCOLOR);
	
	RIGHTPAD=Widget(HUD,UI_PANEL);
	RIGHTPAD.setPos(800,0);
	RIGHTPAD.setPivot(PIVOTX_RIGHT,PIVOTY_TOP);
	RIGHTPAD.setParam(PARAM_COLOR,BGCOLOR);
	
	TOPPAD=Widget(HUD,UI_PANEL);
	TOPPAD.setPivot(PIVOTX_LEFT,PIVOTY_TOP);
	TOPPAD.setParam(PARAM_COLOR,BGCOLOR);
	
	BOTTOMPAD=Widget(HUD,UI_PANEL);	
	BOTTOMPAD.setPivot(PIVOTX_LEFT,PIVOTY_BOTTOM);
	BOTTOMPAD.setParam(PARAM_COLOR,BGCOLOR);
	
	NOTEPAD=Widget(HUDNOTEPAD,UI_ICON);
	NOTEPAD.setPivot(PIVOTX_CENTER,PIVOTY_TOP);	
	NOTEPAD.setSize(512,512);
	NOTEPAD.setPos(400,1000);
	NOTEPAD.setOpacity(0.0);
	NOTEPAD.setParam(PARAM_IMAGE,"LINEAR:textures/ui/notebook.image");

	NOTEPAD_FG=Widget(NOTEPAD,UI_ICON);
	NOTEPAD_FG.setSize("100%","100%");
	NOTEPAD_FG.enableGhost(1);
	
	addListener(ON_POSTUPDATE,"update");	
}
void update() {
	if (!this.isVisible()) return;

	int hudw=HUD.getW();
	int hudh=HUD.getH();  
	CIRCLE.setPos( hudw/2,hudh/2 );
	int w=CIRCLE.getW()/2; 
	w-=2;

	RIGHTPAD.setSize((hudw/2)-w,hudh);
	RIGHTPAD.setPos(hudw,0);
	
	LEFTPAD.setSize((hudw/2)-w,hudh);
  
	TOPPAD.setSize(hudw,(hudh/2)-w);	
	BOTTOMPAD.setSize(hudw,(hudh/2)-w);	
	BOTTOMPAD.setPos(0,hudh);
} 
public void hide(string _replytag,string _replyevent) {
	REPLYTAG=_replytag;
	REPLYEVENT=_replyevent;
	this.show();
	CIRCLE.clearAnimate("");
	CIRCLE.setSize(0,0);
	NOTEPAD.animate("Y","0:0;-10:300;1000:700","hide_end");
	NOTEPAD.animate("A","L1:0;L1:500;0:700","");
}
void hide_end() {
	sendEvent(REPLYEVENT,REPLYTAG);
	addListener(ON_TIMEOUT_MSEC,"500","cbHide");
}
void cbHide() {
	this.hide();
}

// DEBRIEF

void loadTheme(string _callback) {
	string theme=["sc.loader"->getTheme() as string];
	NOTEPAD_FG.setParam(PARAM_IMAGE,"LINEAR:levelsets/"+theme+"/textures/"+theme+".notebook.image");
	NOTEPAD_FG.onLoad(_callback);
	NOTEPAD.setOpacity(0.0);
}

public void debrief(string _replytag,string _replyevent) {
	REPLYTAG=_replytag;
	REPLYEVENT=_replyevent;
	this.show();
	
	int w=max(sysGetWidth(),sysGetHeight())*1.5;
	CIRCLE.clearAnimate("");
	CIRCLE.animate("W",string(w)+":0;0:1000","");
	CIRCLE.animate("H",string(w)+":0;0:1000","");
	CIRCLE.setSize(w,w);
	
	loadTheme("cbStartDebrief");
}
void cbStartDebrief() {	
	NOTEPAD.clearAnimate("");
	NOTEPAD.animate("Y","1000:200;-10:900;0:1100","debrief_end");
	NOTEPAD.animate("A","L0:200;L1:800","");
}
void debrief_end() {
	sendEvent(REPLYEVENT,REPLYTAG);
}

// RESTART LEVEL EVENT

public void forcebrief() {
	this.show();
	CIRCLE.clearAnimate("");
	CIRCLE.setSize(0,0);
	loadTheme("cbStartForceDebrief");
}
void cbStartForceDebrief() {
	NOTEPAD.clearAnimate("");
	NOTEPAD.setPos(NOTEPAD.getX(),0);
	NOTEPAD.setOpacity(1.0);
}

// BREIF

public void brief(string _replytag,string _replyevent) {
	REPLYTAG=_replytag;
	REPLYEVENT=_replyevent;
	this.show();
	
	CIRCLE.clearAnimate("");
	CIRCLE.setSize(0,0);
	
	loadTheme("cbStartBrief");
}
void cbStartBrief() {
	NOTEPAD.clearAnimate("");
	NOTEPAD.animate("Y","1000:0;-10:700;0:1000","brief_end");
	NOTEPAD.animate("A","L0:0;L1:700","");
}
void brief_end() {
	sendEvent(REPLYEVENT,REPLYTAG);
}


// PLAY EVENT

public void play(string _replytag,string _replyevent) {
	REPLYTAG=_replytag;
	REPLYEVENT=_replyevent;

	this.show();
	
	NOTEPAD.clearAnimate("");
	NOTEPAD.animate("Y","0:0;-10:300;1000:700","");
	NOTEPAD.animate("A","L1:0;L1:500;0:700","");
	
	int w=max(sysGetWidth(),sysGetHeight())*1.5;
	CIRCLE.clearAnimate("");
	CIRCLE.animate("W","0:350;"+string(w)+":900","play_end");
	CIRCLE.animate("H","0:350;"+string(w)+":900","");
}
void play_end() {
	this.hide();
	sendEvent(REPLYEVENT,REPLYTAG);
}
