 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#hive 1
#using stdlib gui analytics gamepad sound network

Layout HUD;

String APPNAME = "bunnymaze";
Widget BG,BBACK,BCONTINUE,BRESET,BQUITGAME,BRESTART,BQUITLEVEL,BYES,BNO,LPAUSED,LOPTIONS;
Widget BSNDUP,BSNDDOWN,BSNDBAR;
Widget BMUSICUP,BMUSICDOWN,BMUSICBAR;
Widget PANELOPTIONS,PANELPAUSE,PANELCONFIRM,PANELSOUND;
Widget CURSOR,CURSOR_WIDGET,LABEL_LEVEL;
Widget MUSIC_OFF,SND_OFF;
Widget CONFIRM_RESET,CONFIRM_QUITGAME,CONFIRM_QUITLEVEL,CONFIRM_RESTART,CONFIRM_QUESTION;
Widget bfacebook;
Widget btwitter;
Widget bshare;
Gamepad gpad;
Sound sfx;
//int CONST_LONGBUTTON=66;

int PREVIOUS_SFX_VOL,PREVIOUS_MUSIC_VOL;
int is_options,is_hide_restart,is_ios;

int BUTTON_SIZE = 66;
int BUTTON_OFFSET = 5;
int INDICATOR_OFFSET = 18;

void init(String _args)
{
	is_hide_restart=0;
	is_ios=["ui.init"->isIos() as int];

	setTag("ui.options");	
	//this.hide();
	
	sfx=Sound("sounds/button.audio","");
	
	gpad=Gamepad();
	
	HUD=Layout();
	HUD.setBaseSize(800,480,"autofit");

	int offx=50;//45
	
	Widget dimmer=Widget(HUD,UI_ICON);
	dimmer.setSize("100%","100%");
	dimmer.setParam(PARAM_IMAGE,"LINEAR:textures/ui/dimmer.image");
	
	LABEL_LEVEL=Widget(HUD,UI_TEXFONTLABEL);
	LABEL_LEVEL.setParam(PARAM_FONTIMAGE,"LINEAR:textures/ui/font.image");
	LABEL_LEVEL.setparam(PARAM_FONTSIZE,"24,24");
	LABEL_LEVEL.setparam(PARAM_FONTSPACING,"-0.6");
	LABEL_LEVEL.setparam(PARAM_TEXTALIGN,"left");
	LABEL_LEVEL.enableGhost(1);
	LABEL_LEVEL.setPivot(PIVOTX_LEFT,PIVOTY_BOTTOM);
	LABEL_LEVEL.setPos(10,470);
	LABEL_LEVEL.setSize(24,24);
	LABEL_LEVEL.hide();
	
	BG=Widget(HUD,UI_ICON);
	BG.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);	
	BG.setSize(512,512);
	BG.setPos(400,240);
	BG.setParam(PARAM_IMAGE,"LINEAR:textures/ui/options_bg.image");
	
	LPAUSED=Widget(BG,UI_ICON);
	LPAUSED.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	LPAUSED.setSize(64,64); 
	LPAUSED.setPos(256,66);
	LPAUSED.setParam(PARAM_IMAGE,"LINEAR:textures/ui/menutitle-pause.image");
	LPAUSED.enableGhost(1);
	
	LOPTIONS=Widget(BG,UI_ICON);
	LOPTIONS.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	LOPTIONS.setSize(64,64); 
	LOPTIONS.setPos(256,66);
	LOPTIONS.setParam(PARAM_IMAGE,"LINEAR:textures/ui/menutitle-options.image");
	LOPTIONS.enableGhost(1);

	PANELOPTIONS=Widget(BG,UI_WIDGET);
	PANELOPTIONS.setSize(256,512);
	
	PANELPAUSE=Widget(BG,UI_WIDGET);
	PANELPAUSE.setSize(256,512);

	PANELCONFIRM=Widget(BG,UI_WIDGET);
	PANELCONFIRM.setSize(256,512);
	PANELCONFIRM.setPos(200,0);
	
	PANELSOUND=Widget(BG,UI_WIDGET);
	PANELSOUND.setSize(256,512);
	PANELSOUND.setPos(236,0);
	
	int SND_ROW_OFFSET=-80;
	
	int BOFFY = 70;
	int BOFFX = 555;
	bfacebook=Widget(BG,UI_PUSHBUTTON);
	bfacebook.setSize(80,80);
	bfacebook.setparam(PARAM_THEME,"LINEAR:textures/ui/ui_fbside_normal.image,textures/ui/ui_fbside_normal.image,textures/ui/ui_fbside_pressed.image");
	bfacebook.setparam(PARAM_ONCLICK,"cbFacebook");
	bfacebook.setPivot(PIVOTX_RIGHT,PIVOTY_TOP);
	bfacebook.setPos(BOFFX,BOFFY);
	
	Widget SND_ICON=Widget(PANELSOUND,UI_ICON);
	SND_ICON.enableGhost(1);
	SND_ICON.setSize(BUTTON_SIZE,BUTTON_SIZE);
	SND_ICON.setPos(SND_ROW_OFFSET,150);
	SND_ICON.setParam(PARAM_IMAGE,"LINEAR:textures/ui/menu_soundfx.image");
	
	SND_OFF=Widget(SND_ICON,UI_ICON);
	SND_OFF.enableGhost(1);
	SND_OFF.setSize(BUTTON_SIZE,BUTTON_SIZE);
	SND_OFF.setParam(PARAM_IMAGE,"LINEAR:textures/ui/ui_soundoff.image");
	SND_OFF.hide();
	
	BSNDDOWN=Widget(PANELSOUND,UI_PUSHBUTTON);
	BSNDDOWN.setSize(BUTTON_SIZE,BUTTON_SIZE);
	BSNDDOWN.setparam(PARAM_THEME,"LINEAR:textures/ui/menu_minus_normal.image,textures/ui/menu_minus_normal.image,textures/ui/menu_minus_pressed.image");
	BSNDDOWN.setPos(SND_ICON.getX()+SND_ICON.getW()-BUTTON_OFFSET,SND_ICON.getY());
	BSNDDOWN.setParam(PARAM_ONCLICK,"cbSoundDown");	
	
	Widget tmp=Widget(PANELSOUND,UI_ICON);
	tmp.enableGhost(1);
	tmp.setSize(BUTTON_SIZE*2,BUTTON_SIZE);
	tmp.setPos(BSNDDOWN.getX()+BSNDDOWN.getW()-INDICATOR_OFFSET,BSNDDOWN.getY());
	tmp.setParam(PARAM_IMAGE,"LINEAR:textures/ui/menu_volume_bg.image");	
	
	BSNDUP=Widget(PANELSOUND,UI_PUSHBUTTON);
	BSNDUP.setSize(BUTTON_SIZE,BUTTON_SIZE);
	BSNDUP.setparam(PARAM_THEME,"LINEAR:textures/ui/menu_plus_normal.image,textures/ui/menu_plus_normal.image,textures/ui/menu_plus_pressed.image");
	BSNDUP.setPos(tmp.getX()+tmp.getW()-BUTTON_OFFSET,tmp.getY());
	BSNDUP.setParam(PARAM_ONCLICK,"cbSoundUp");
		
	BSNDBAR=Widget(tmp,UI_SCISSOR);
	BSNDBAR.setSize(BUTTON_SIZE*2,BUTTON_SIZE);
	BSNDBAR.enableGhost(1);
	tmp=Widget(BSNDBAR,UI_ICON);
	tmp.enableGhost(1);
	tmp.setSize(BUTTON_SIZE*2,BUTTON_SIZE);
	tmp.setParam(PARAM_IMAGE,"LINEAR:textures/ui/menu_volume_fg.image");
	
	//MUSIC
	Widget MUSIC_ICON=Widget(PANELSOUND,UI_ICON);
	MUSIC_ICON.enableGhost(1);
	MUSIC_ICON.setSize(BUTTON_SIZE,BUTTON_SIZE);
	MUSIC_ICON.setPos(SND_ROW_OFFSET,SND_ICON.getY()+90);
	MUSIC_ICON.setParam(PARAM_IMAGE,"LINEAR:textures/ui/menu_music.image");
	
	MUSIC_OFF=Widget(MUSIC_ICON,UI_ICON);
	MUSIC_OFF.enableGhost(1);
	MUSIC_OFF.setSize(BUTTON_SIZE,BUTTON_SIZE);
	MUSIC_OFF.setParam(PARAM_IMAGE,"LINEAR:textures/ui/ui_soundoff.image");
	MUSIC_OFF.hide();

	BMUSICDOWN=Widget(PANELSOUND,UI_PUSHBUTTON);
	BMUSICDOWN.setSize(BUTTON_SIZE,BUTTON_SIZE);
	BMUSICDOWN.setparam(PARAM_THEME,"LINEAR:textures/ui/menu_minus_normal.image,textures/ui/menu_minus_normal.image,textures/ui/menu_minus_pressed.image");
	BMUSICDOWN.setPos(MUSIC_ICON.getX()+MUSIC_ICON.getW()-BUTTON_OFFSET,MUSIC_ICON.getY());
	BMUSICDOWN.setParam(PARAM_ONCLICK,"cbMusicDown");
	
	tmp=Widget(PANELSOUND,UI_ICON);
	tmp.enableGhost(1);
	tmp.setSize(BUTTON_SIZE*2,BUTTON_SIZE);
	tmp.setPos(BMUSICDOWN.getX()+BMUSICDOWN.getW()-INDICATOR_OFFSET,BMUSICDOWN.getY());
	tmp.setParam(PARAM_IMAGE,"LINEAR:textures/ui/menu_volume_bg.image");	
	
	BMUSICUP=Widget(PANELSOUND,UI_PUSHBUTTON);
	BMUSICUP.setSize(BUTTON_SIZE,BUTTON_SIZE);
	BMUSICUP.setparam(PARAM_THEME,"LINEAR:textures/ui/menu_plus_normal.image,textures/ui/menu_plus_normal.image,textures/ui/menu_plus_pressed.image");
	BMUSICUP.setPos(tmp.getX()+tmp.getW()-BUTTON_OFFSET,tmp.getY());
	BMUSICUP.setParam(PARAM_ONCLICK,"cbMusicUp");
		
	BMUSICBAR=Widget(tmp,UI_SCISSOR);
	BMUSICBAR.setSize(BUTTON_SIZE*2,BUTTON_SIZE);
	BMUSICBAR.enableGhost(1);
	tmp=Widget(BMUSICBAR,UI_ICON);
	tmp.enableGhost(1);
	tmp.setSize(BUTTON_SIZE*2,BUTTON_SIZE);
	tmp.setParam(PARAM_IMAGE,"LINEAR:textures/ui/menu_volume_fg.image");
		
	//mute sounds
	tmp=Widget(PANELSOUND,UI_PUSHBUTTON);
	tmp.setSize(BUTTON_SIZE,BUTTON_SIZE);
	tmp.setPos(SND_ICON.getX(),SND_ICON.getY());
	tmp.setParam(PARAM_ONCLICK,"cbSoundOff");

	tmp=Widget(PANELSOUND,UI_PUSHBUTTON);
	tmp.setSize(BUTTON_SIZE,BUTTON_SIZE);
	tmp.setPos(MUSIC_ICON.getX(),MUSIC_ICON.getY());
	tmp.setParam(PARAM_ONCLICK,"cbMusicOff");
		
	BBACK=Widget(BG,UI_PUSHBUTTON);
	BBACK.setPivot(PIVOTX_LEFT,PIVOTY_BOTTOM);
	BBACK.setSize(BUTTON_SIZE*2,BUTTON_SIZE);
	BBACK.setparam(PARAM_THEME,"LINEAR:textures/ui/menu_yes_normal.image,textures/ui/menu_yes_normal.image,textures/ui/menu_yes_pressed.image");
	BBACK.setPos(256,435);
	
	BCONTINUE=Widget(BG,UI_PUSHBUTTON);
	BCONTINUE.setPivot(PIVOTX_LEFT,PIVOTY_BOTTOM);
	BCONTINUE.setSize(BBACK.getW(),BBACK.getH());
	BCONTINUE.setparam(PARAM_THEME,"LINEAR:textures/ui/menu_yes_normal.image,textures/ui/menu_yes_normal.image,textures/ui/menu_yes_pressed.image");
	BCONTINUE.setPos(BBACK.getX(),BBACK.getY());

	BRESET=Widget(PANELOPTIONS,UI_PUSHBUTTON);
	BRESET.setSize(100,100);
	BRESET.setparam(PARAM_THEME,"LINEAR:textures/ui/menu_resetlevels_normal.image,textures/ui/menu_resetlevels_normal.image,textures/ui/menu_resetlevels_pressed.image");
	BRESET.setPos(offx,120);
	BRESET.setParam(PARAM_ONCLICK,"cbReset");
	
	BQUITGAME=Widget(PANELOPTIONS,UI_PUSHBUTTON);
	BQUITGAME.setSize(100,100);
	BQUITGAME.setparam(PARAM_THEME,"LINEAR:textures/ui/menu_quitgame_normal.image,textures/ui/menu_quitgame_normal.image,textures/ui/menu_quitgame_pressed.image");
	BQUITGAME.setPos(BRESET.getX(),BRESET.getY()+110);
	BQUITGAME.setParam(PARAM_ONCLICK,"cbQuitGame");
	if (is_ios) BQUITGAME.hide();

	BRESTART=Widget(PANELPAUSE,UI_PUSHBUTTON);
	BRESTART.setSize(BRESET.getW(),BRESET.getH());
	BRESTART.setparam(PARAM_THEME,"LINEAR:textures/ui/tryagain_normal.image,textures/ui/tryagain_normal.image,textures/ui/tryagain_pressed.image");
	BRESTART.setPos(BRESET.getX(),BRESET.getY());
	BRESTART.setParam(PARAM_ONCLICK,"cbRestart");
	
	BQUITLEVEL=Widget(PANELPAUSE,UI_PUSHBUTTON);
	BQUITLEVEL.setSize(BQUITGAME.getW(),BQUITGAME.getH());
	BQUITLEVEL.setparam(PARAM_THEME,"LINEAR:textures/ui/menu_quitlevel_normal.image,textures/ui/menu_quitlevel_normal.image,textures/ui/menu_quitlevel_pressed.image");
	BQUITLEVEL.setPos(BQUITGAME.getX(),BQUITGAME.getY());
	BQUITLEVEL.setParam(PARAM_ONCLICK,"cbQuitLevel");
	
	CONFIRM_RESET=Widget(PANELCONFIRM,UI_ICON);
	CONFIRM_QUITGAME=Widget(PANELCONFIRM,UI_ICON);
	CONFIRM_QUITLEVEL=Widget(PANELCONFIRM,UI_ICON);
	CONFIRM_RESTART=Widget(PANELCONFIRM,UI_ICON);
	CONFIRM_QUESTION=Widget(PANELCONFIRM,UI_ICON);
	
	CONFIRM_RESET.hide();
	CONFIRM_QUITGAME.hide();
	CONFIRM_QUITLEVEL.hide();
	CONFIRM_RESTART.hide();
	CONFIRM_QUESTION.hide();

	CONFIRM_RESET.setSize(280,280);
	CONFIRM_QUITGAME.setSize(280,280);
	CONFIRM_QUITLEVEL.setSize(320,320);
	CONFIRM_RESTART.setSize(320,320);

	CONFIRM_RESET.setPos(-17,120);
	CONFIRM_QUITGAME.setPos(-17,120);
	CONFIRM_QUITLEVEL.setPos(-50,100);
	CONFIRM_RESTART.setPos(-50,100);
		
	CONFIRM_RESET.setparam(PARAM_IMAGE,"LINEAR:textures/ui/options_reset.image");
	CONFIRM_QUITGAME.setparam(PARAM_IMAGE,"LINEAR:textures/ui/options_home.image");
	CONFIRM_QUITLEVEL.setparam(PARAM_IMAGE,"LINEAR:textures/ui/options_quitlevel.image");
	CONFIRM_RESTART.setparam(PARAM_IMAGE,"LINEAR:textures/ui/options_restart.image");
	CONFIRM_QUESTION.setparam(PARAM_IMAGE,"LINEAR:textures/ui/ui_questionmark.image");
	
	CONFIRM_QUESTION.setPivot(PIVOTX_CENTER,PIVOTY_TOP);
	CONFIRM_QUESTION.setSize(128,128);
	CONFIRM_QUESTION.setPos(-10,230);
	
	BYES=Widget(PANELCONFIRM,UI_PUSHBUTTON);
	BYES.setPivot(PIVOTX_RIGHT,PIVOTY _BOTTOM);
	BYES.setPos(110,BBACK.getY());
	BYES.setSize(BBACK.getW(),BBACK.getH());
	BYES.setparam(PARAM_THEME,"LINEAR:textures/ui/menu_yes_normal.image,textures/ui/menu_yes_normal.image,textures/ui/menu_yes_pressed.image");

	BNO=Widget(PANELCONFIRM,UI_PUSHBUTTON);
	BNO.setPivot(PIVOTX_LEFT,PIVOTY_BOTTOM);
	BNO.setPos(138,BBACK.getY());
	BNO.setSize(BBACK.getW(),BBACK.getH());
	BNO.setparam(PARAM_THEME,"LINEAR:textures/ui/menu_no_normal.image,textures/ui/menu_no_normal.image,textures/ui/menu_no_pressed.image");
	
	CURSOR=Widget(HUD,UI_ICON);
	CURSOR.setPivot(PIVOTX_LEFT,PIVOTY_TOP);
	CURSOR.setSize(64,64);
	CURSOR.setParam(PARAM_IMAGE,"LINEAR:textures/ui/hand-cursor.image");
	CURSOR.hide();
	CURSOR.enableGhost(1);
	
	BSNDDOWN.raise();
	BMUSICDOWN.raise();
	
	addListener(ON_EVENT,"PAUSE","e_pause");
	addListener(ON_EVENT,"OPTIONS","e_options");
	
	fCall("refreshSoundBars");
}

void e_pause() {
	is_options=0;
	debugLog("ui.options -> pausing");
	analytics_trackview("/options/play");		
	this.show();
	
	LABEL_LEVEL.show();
	string theme=["sc.loader"->getTheme() as string];
	string theme_level=["sc.loader"->getLevel() as string];
	theme=["ui.home"->themeToName(theme) as string];
	LABEL_LEVEL.setParam(PARAM_TEXT,"# "+theme +" - "+theme_level); // LEVEL

	CURSOR.hide();
	CURSOR_WIDGET=BCONTINUE;
	LPAUSED.show();
	LOPTIONS.hide();
	PANELPAUSE.show();
	PANELOPTIONS.hide();
	PANELSOUND.fadeIn(1,"");
	PANELCONFIRM.fadeOut(1,"");
	BRESTART.fadeIn(1,"");
	BQUITLEVEL.fadeIn(1,"");
	BBACK.fadeOut(1,"");
	BCONTINUE.fadeIn(1,"");
	HUD.fadeIn(200,"");
	BCONTINUE.setparam(PARAM_ONCLICK,"cbBackPause");	
	BNO.setparam(PARAM_ONCLICK,"cbNoPause");	
	addListener(ON_TIMEOUT_MSEC,"1","cbRegQuit");
	
	PREVIOUS_SFX_VOL=float(appPropertyGet(APPNAME,"sfxvol","1.0"))*100;
	PREVIOUS_MUSIC_VOL=float(appPropertyGet(APPNAME,"musicvol","0.5"))*100;
	
	gpad.onButtonDown("cbGamepad");
}
void e_options() {
	is_options=1;
	debugLog("ui.options -> options");	
	analytics_trackview("/options/lobby");		
	this.show();
	LABEL_LEVEL.setParam(PARAM_TEXT,"");
	LABEL_LEVEL.hide();
	
	CURSOR.hide();
	CURSOR_WIDGET=BBACK;
	LPAUSED.hide();
	LOPTIONS.show();
	PANELPAUSE.hide();
	PANELOPTIONS.show();
	PANELSOUND.fadeIn(1,"");
	PANELCONFIRM.fadeOut(1,"");
	BRESET.fadeIn(1,"");
	if (!is_ios)
		BQUITGAME.fadeIn(1,"");
	BBACK.fadeIn(1,"");
	BCONTINUE.fadeOut(1,"");
	HUD.fadeIn(200,"");
	BBACK.setparam(PARAM_ONCLICK,"cbBackOptions");	
	BNO.setparam(PARAM_ONCLICK,"cbNoOptions");
	addListener(ON_TIMEOUT_MSEC,"1","cbRegQuit");	
	
	PREVIOUS_SFX_VOL=float(appPropertyGet(APPNAME,"sfxvol","1.0"))*100;
	PREVIOUS_MUSIC_VOL=float(appPropertyGet(APPNAME,"musicvol","0.5"))*100;
	
	gpad.onButtonDown("cbGamepad");
}
void cbRegQuit() {
	addListener(ON_QUIT,"cbAppQuit");	
}
void cbNoOptions() {
	sfx.play();
	CURSOR_WIDGET=BBACK;
	BBACK.fadeIn(200,"");
	PANELCONFIRM.fadeOut(200,"");
	PANELSOUND.fadeIn(200,"");
	BRESET.fadeIn(200,"");
	if (!is_ios)
		BQUITGAME.fadeIn(200,"");
}
void cbNoPause() {
	sfx.play();
	CURSOR_WIDGET=BCONTINUE;
	BCONTINUE.fadeIn(200,"");
	PANELCONFIRM.fadeOut(200,"");
	PANELSOUND.fadeIn(200,"");
	BRESTART.fadeIn(200,"");
	BQUITLEVEL.fadeIn(200,"");
}
void storeAnalytics() {
	int volsnd=int(float(appPropertyGet(APPNAME,"sfxvol","1.0"))*100);
	int volmusic=int(float(appPropertyGet(APPNAME,"musicvol","0.5"))*100);
	if (volsnd!=PREVIOUS_SFX_VOL) {
		analytics_trackevent("options","sound_volume","",volsnd);
	}
	if (volmusic!=PREVIOUS_MUSIC_VOL) {
		analytics_trackevent("options","music_volume","",volmusic);
	}
	analytics_dispatch();
}
void cbBackOptions() {
	sfx.play();
	storeAnalytics();
	clearListeners(ON_QUIT);
	gpad.onButtonDown("");
	sendEvent("RESUME","ui.home");
	HUD.fadeOut(200,"cbHide");
}
void cbBackPause() {
	sfx.play();
	storeAnalytics();
	clearListeners(ON_QUIT);
	gpad.onButtonDown("");
	sendEvent("RESUME","ui.play");
	HUD.fadeOut(200,"cbHide");
}
void cbHide() {
	this.hide();
	gpad.onButtonDown("");
}

int CONFIRM_QUESTION_OFFSET = 85;
int CONFIRM_QUESTION_X = -100;

void cbReset() {
	sfx.play();
	CURSOR_WIDGET=BNO;
	PANELCONFIRM.fadeIn(200,"");
	PANELSOUND.fadeOut(200,"");
	BBACK.fadeOut(200,"");
	BQUITGAME.fadeOut(200,"");	
	BYES.setparam(PARAM_ONCLICK,"cbYesReset");	
	CONFIRM_QUITGAME.hide();
	CONFIRM_QUITLEVEL.hide();
	CONFIRM_RESET.show();
	CONFIRM_RESTART.hide();
	
	CONFIRM_QUESTION.setPos(CONFIRM_QUESTION_X,BRESET.getY()+CONFIRM_QUESTION_OFFSET);
	CONFIRM_QUESTION.show();
}
void cbQuitGame() {
	sfx.play();
	CURSOR_WIDGET=BNO;
	PANELCONFIRM.fadeIn(200,"");
	PANELSOUND.fadeOut(200,"");
	BBACK.fadeOut(200,"");
	BRESET.fadeOut(200,"");
	BYES.setparam(PARAM_ONCLICK,"cbYesQuitGame");	
	CONFIRM_QUITGAME.show();
	CONFIRM_QUITLEVEL.hide();
	CONFIRM_RESET.hide();
	CONFIRM_RESTART.hide();
	
	CONFIRM_QUESTION.setPos(CONFIRM_QUESTION_X,BQUITGAME.getY()+CONFIRM_QUESTION_OFFSET);
	CONFIRM_QUESTION.show();
}
void cbRestart() {
	sfx.play();
	if (is_hide_restart) {
		fCall("cbYesRestart");
		return;
	}
	CURSOR_WIDGET=BNO;
	PANELCONFIRM.fadeIn(200,"");
	PANELSOUND.fadeOut(200,"");
	BCONTINUE.fadeOut(200,"");
	BQUITLEVEL.fadeOut(200,"");
	BYES.setparam(PARAM_ONCLICK,"cbYesRestart");	
	CONFIRM_QUITGAME.hide();
	CONFIRM_QUITLEVEL.hide();
	CONFIRM_RESET.hide();
	CONFIRM_RESTART.show();
	
	CONFIRM_QUESTION.setPos(CONFIRM_QUESTION_X,BRESTART.getY()+CONFIRM_QUESTION_OFFSET);
	CONFIRM_QUESTION.show();
}
void cbQuitLevel() {
	sfx.play();
	CURSOR_WIDGET=BNO;
	PANELCONFIRM.fadeIn(200,"");
	PANELSOUND.fadeOut(200,"");
	BCONTINUE.fadeOut(200,"");
	BRESTART.fadeOut(200,"");	
	BYES.setparam(PARAM_ONCLICK,"cbYesQuitLevel");	
	CONFIRM_QUITGAME.hide();
	CONFIRM_QUITLEVEL.show();
	CONFIRM_RESET.hide();
	CONFIRM_RESTART.hide();
	
	CONFIRM_QUESTION.setPos(CONFIRM_QUESTION_X,BQUITLEVEL.getY()+CONFIRM_QUESTION_OFFSET);
	CONFIRM_QUESTION.show();
}
void cbYesReset() {
	sfx.play();
	//mental note: count how many levels we are resetting
	analytics_trackevent("options","resetlevels","",1);
	cbBackOptions();	
	sendEvent("RESETLEVELS","sc.control");	
}
public void cbYesQuitGame() {
	sfx.play();
	analytics_trackevent("options","quitgame","",1);
	appPropertySet(APPNAME,"state","");
	appPropertyFlush();
	system("halt");
}
void cbYesRestart() {
	is_hide_restart=1;
	appPropertySet(APPNAME,"opt_restart","1");
	sfx.play();
	analytics_trackevent("options","retrylevel",["sc.loader"->getTheme() as string],["sc.loader"->getLevel() as int]);
	analytics_trackview("/play/"+["sc.loader"->getTheme() as string]+"/"+["sc.loader"->getLevel() as string]+"/retry");
	cbBackPause();
	sendEvent("RESTARTLEVEL","sc.control");	
}
void cbYesQuitLevel() {
	sfx.play();
	analytics_trackevent("options","quitlevel",["sc.loader"->getTheme() as string],["sc.loader"->getLevel() as int]);
	analytics_trackview("/play/"+["sc.loader"->getTheme() as string]+"/"+["sc.loader"->getLevel() as string]+"/quit");
	cbBackPause();
	sendEvent("QUITLEVEL","sc.control");	
}
void refreshSoundBars() {
	float music_vol=float(appPropertyGet(APPNAME,"musicvol","0.5"));
	float snd_vol=float(appPropertyGet(APPNAME,"sfxvol","1.0"));
	if (music_vol>0.0) MUSIC_OFF.hide();
	else MUSIC_OFF.show();
	if (snd_vol>0.0) SND_OFF.hide();
	else SND_OFF.show();
	BMUSICBAR.setSize(int(float(BUTTON_SIZE*2)*music_vol),BUTTON_SIZE);
	BSNDBAR.setSize(int(float(BUTTON_SIZE*2)*snd_vol),BUTTON_SIZE);
	sfx.setVolume(snd_vol);
	sendEvent("VOLUME","sc.control");
	sendEvent("VOLUME","ui.play");
	sendEvent("VOLUME","ui.home");
	sendEvent("VOLUME","ui.brief");
	sendEvent("VOLUME","ui.debrief");
	sendEvent("VOLUME","hero");
}
void cbSoundOff() {
	appPropertySet(APPNAME,"sfxvol",string(0.0));
	appPropertyFlush();
	refreshSoundBars();
}
void cbSoundDown() {
	float vol=float(appPropertyGet(APPNAME,"sfxvol","1.0"));
	vol=max(0.0,vol-0.25);
	appPropertySet(APPNAME,"sfxvol",string(vol));
	appPropertyFlush();
	refreshSoundBars();
	sfx.play();
}
void cbSoundUp() {
	float vol=float(appPropertyGet(APPNAME,"sfxvol","1.0"));
	vol=min(1.0,vol+0.25);
	appPropertySet(APPNAME,"sfxvol",string(vol));
	appPropertyFlush();
	refreshSoundBars();
	sfx.play();
}
void cbMusicOff() {
	appPropertySet(APPNAME,"musicvol",string(0.0));
	appPropertyFlush();
	refreshSoundBars();
}
void cbMusicDown() {
	float vol=float(appPropertyGet(APPNAME,"musicvol","0.5"));
	vol=max(0.0,vol-0.25);
	appPropertySet(APPNAME,"musicvol",string(vol));
	appPropertyFlush();
	refreshSoundBars();
	sfx.play();
}
void cbMusicUp() {
	float vol=float(appPropertyGet(APPNAME,"musicvol","0.5"));
	vol=min(1.0,vol+0.25);
	appPropertySet(APPNAME,"musicvol",string(vol));
	appPropertyFlush();
	refreshSoundBars();
	sfx.play();
}
void cbAppQuit() {
	if (this.isVisible()) {
		if (PANELOPTIONS.isVisible()) {
			cbBackOptions();
		}
		else if (PANELPAUSE.isVisible()) {
			cbBackPause();
		}
	}
}
void cbGamepad(int _controller,int _action) {
	if (_action==GAMEPAD_B) {
		cbAppQuit();
		return;
	}
	if (gpad.isDPAD(_action) || gpad.isABXY(_action)) {
		if (CURSOR.isVisible()) {
			if (_action==GAMEPAD_UP) {
				if (CURSOR_WIDGET==BBACK) {	CURSOR_WIDGET=BQUITGAME; }
				else if (CURSOR_WIDGET==BCONTINUE) {	CURSOR_WIDGET=BQUITLEVEL; }
				else if (CURSOR_WIDGET==BQUITGAME) { CURSOR_WIDGET=BRESET; }
				else if (CURSOR_WIDGET==BQUITLEVEL) { CURSOR_WIDGET=BRESTART; }
				else if (CURSOR_WIDGET==BMUSICDOWN) { CURSOR_WIDGET=BSNDDOWN; }
				else if (CURSOR_WIDGET==BMUSICUP) { CURSOR_WIDGET=BSNDUP; }
			}
			else if (_action==GAMEPAD_DOWN) {
				if (CURSOR_WIDGET==BRESET) { CURSOR_WIDGET=BQUITGAME; }
				else if (CURSOR_WIDGET==BRESTART) { CURSOR_WIDGET=BQUITLEVEL; }
				else if (CURSOR_WIDGET==BSNDDOWN) { CURSOR_WIDGET=BMUSICDOWN; }
				else if (CURSOR_WIDGET==BSNDUP) { CURSOR_WIDGET=BMUSICUP; }
				else if (CURSOR_WIDGET==BQUITLEVEL) { CURSOR_WIDGET=BCONTINUE; }
				else if (CURSOR_WIDGET==BQUITGAME) { CURSOR_WIDGET=BBACK; }
				else if (CURSOR_WIDGET==BMUSICDOWN || CURSOR_WIDGET==BMUSICUP) { 
					if (is_options) CURSOR_WIDGET=BBACK;
					else CURSOR_WIDGET=BCONTINUE;
				}
				else if(CURSOR_WIDGET ==bfacebook) {CURSOR_WIDGET = BMUSICUP;}
			}
			else if (_action==GAMEPAD_LEFT) {
				if (CURSOR_WIDGET==BSNDUP) { CURSOR_WIDGET=BSNDDOWN; }
				else if (CURSOR_WIDGET==BMUSICUP) { CURSOR_WIDGET=BMUSICDOWN; }
				else if (CURSOR_WIDGET==BSNDDOWN) { 
					if (is_options) CURSOR_WIDGET=BRESET;
					else CURSOR_WIDGET=BCONTINUE;
				}
				else if (CURSOR_WIDGET==BMUSICDOWN) { 
					if (is_options) CURSOR_WIDGET=BQUITGAME;
					else CURSOR_WIDGET=BQUITLEVEL;
				}
				else if (CURSOR_WIDGET==BNO) { CURSOR_WIDGET=BYES; }
				else if(CURSOR_WIDGET ==bfacebook) {CURSOR_WIDGET = BMUSICUP;}
			}
			else if (_action==GAMEPAD_RIGHT) {
				if (CURSOR_WIDGET==BSNDDOWN) { CURSOR_WIDGET=BSNDUP; }
				else if (CURSOR_WIDGET==BMUSICDOWN) { CURSOR_WIDGET=BMUSICUP; }
				else if (CURSOR_WIDGET==BMUSICUP || CURSOR_WIDGET==BSNDUP) { CURSOR_WIDGET=bfacebook; }
				else if (CURSOR_WIDGET==BRESTART || CURSOR_WIDGET==BRESET) { 
					CURSOR_WIDGET=BSNDDOWN;
				}
				else if (CURSOR_WIDGET==BQUITGAME || CURSOR_WIDGET==BQUITLEVEL) { 
					CURSOR_WIDGET=BMUSICDOWN;
				}
				else if (CURSOR_WIDGET==BYES) { CURSOR_WIDGET=BNO; }
			}
			else if (_action==GAMEPAD_A) {
				CURSOR_WIDGET.doAction();
			}			
		}
		else {
			CURSOR.show();
		}
		//position cursor
		CURSOR.setParent(CURSOR_WIDGET);
		CURSOR.setPos( (CURSOR_WIDGET.getW()*2)/3,CURSOR_WIDGET.getH()/2);			
	}
}

void cbFacebookshare() {
	//facebook_share("Test","http://www.facebook.com/bunnymaze3d", "Test desc", "http://www.facebook.com/bunnymaze3d");
}

void cbFacebook() {
	openURL("http://www.facebook.com/bunnymaze3d");
}
void cbTwitter() {
	openURL("http://www.twitter.com/bunnymaze3d");
}
