 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib gui gamepad sound
#hive 1

String APPNAME = "bunnymaze";
Layout HUD;
Gamepad gpad;
Widget STORY1,STORY2;
Sound music;
string reply_tag,reply_event;

void init() {
	setTag("ui.story");
	this.hide();
	
	//add HUD container
	HUD=Layout();
	HUD.setBaseSize(800,480,"nofit");
	
	gpad=Gamepad();
	
	addListener(ON_EVENT,"SHOW","showStory");
}
void showStory(string _tag,string _reply) {
	reply_tag=_tag;
	reply_event=_reply;
	HUD.delChildren();

	Widget BG=Widget(HUD,UI_PANEL); 
	BG.setSize("100%","100%");
	BG.setParam(PARAM_COLOR,"0,0,0,255");
	
	this.show();
	HUD.fadeIn(200,""); 

	STORY1=Widget(HUD,UI_ICON);
	STORY1.setParam(PARAM_IMAGE,"LINEAR:textures/ui/story1.image");
	STORY1.hide();  
	
	STORY2=Widget(STORY1,UI_ICON);
	STORY2.setParam(PARAM_IMAGE,"LINEAR:textures/ui/story2.image");
	STORY2.hide();
	  
	STORY1.onLoad("storyLoaded");
	
	music=Sound("sounds/story.audio","e_volume");
}
void e_volume() {
	music.setVolume(float(appPropertyGet(APPNAME,"musicvol","1.0")));
	music.loop("sounds/story.audio",1);
	music.play();
}
void storyLoaded() {
	STORY1.setPos(0,0);
	STORY1.setSize(HUD.getRealH()*2,HUD.getRealH());
	STORY2.setSize(HUD.getRealH()*2,HUD.getRealH());
	STORY2.setPos(HUD.getRealH()*2,0);		

	STORY1.fadeIn(500,"");
	STORY2.fadeIn(500,"");
	
	int w=HUD.getRealH()*4 - HUD.getRealW();
	STORY1.animate("X","L0:0;S0:300;S-"+string(w*0.1)+":2000;S-"+string(w*0.8)+":10000;S-"+string(w)+":18000","hideStory");
	addListener(ON_TIMEOUT_MSEC,"1000","cbRegMouse");
}
void cbRegMouse() {
	addListener(ON_MOUSEDOWN,"hideStory");
	gpad.onButtonDown("hideStory");
}
void hideStory() {	
	clearListeners(ON_MOUSEDOWN);
	gpad.onButtonDown("");
	HUD.fadeOut(200,"hideFinished");
}
void hideFinished() {
	sendEvent(reply_event,reply_tag);
	this.hide();
	HUD.delChildren();
	STORY1=0;
	STORY2=0;
	music.stop();
	music=0;	
}
