 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/
 
#using stdlib gui gamepad
#hive 1

Layout HUD;
Widget TUTICON1,TUTICON2,TUTICON3,TUTICON4,TUTHAND,TAPTOCONTINUE,HANDPARENT;
String REPLY_TAG,REPLY_EVENT;
Gamepad gpad;
Timer twait;
int CONST_TIMER_WAIT=1000;
int show_controller=0;

void init() {
	setTag("ui.tutorial");
	
	gpad=Gamepad();
	twait=Timer();
	
	//add HUD container
	HUD=Layout();
	HUD.setBaseSize(800,480,"autofit");
  
	addListener(ON_EVENT,"SHOW","e_show");
	addListener(ON_EVENT,"HIDE","e_hide");

}
void e_hide() {
	HUD.fadeOut(300,"cbHide");
}
void cbHide() {
	this.hide();
	HUD.delChildren();
}
//SINGLE IMAGE
void loadStaticTutorial(string _image) {
	TUTICON1=Widget(HUD,UI_ICON);
	TUTICON1.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	TUTICON1.setSize(512,256);
	TUTICON1.setPos(400,240);
	TUTICON1.setParam(PARAM_IMAGE,"LINEAR:textures/tutorial/"+_image+".image");
	addListener(ON_MOUSEUP,"cbTapContinue");		
	gpad.onButtonDown("cbTapContinue");
}
//2 IMAGES
void loadStaticTutorial(string _image1,string _image2) {
	TUTICON1=Widget(HUD,UI_ICON);
	TUTICON1.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	TUTICON1.setSize(512,256);
	TUTICON1.setPos(400,240);
	TUTICON1.setParam(PARAM_IMAGE,"LINEAR:textures/tutorial/"+_image1+".image");
	
	TUTICON2=Widget(HUD,UI_ICON);
	TUTICON2.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	TUTICON2.setSize(512,256);
	TUTICON2.setPos(400,240);
	TUTICON2.setParam(PARAM_IMAGE,"LINEAR:textures/tutorial/"+_image2+".image");
	TUTICON2.hide();
	
	addListener(ON_TIMEOUT_MSEC,"1500","cbStaticSwap1");
	
	addListener(ON_MOUSEUP,"cbTapContinue");		
	gpad.onButtonDown("cbTapContinue");
}
void cbStaticSwap1() {
	TUTICON1.fadeOut(200,"");
	TUTICON2.fadeIn(200,"cbStaticFade2");
}
void cbStaticFade2() {
	addListener(ON_TIMEOUT_MSEC,"3000","cbStaticSwap2");
}
void cbStaticSwap2() {
	TUTICON2.fadeOut(200,"cbStaticFade3");
}
void cbStaticFade3() {
	TUTICON1.fadeIn(200,"cbStaticFade4");
}
void cbStaticFade4() {
	addListener(ON_TIMEOUT_MSEC,"1500","cbStaticSwap1");
}
//3 IMAGES
void loadStaticTutorial(string _image1,string _image2,string _image3) {
	TUTICON1=Widget(HUD,UI_ICON);
	TUTICON1.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	TUTICON1.setSize(512,256);
	TUTICON1.setPos(400,240);
	TUTICON1.setParam(PARAM_IMAGE,"LINEAR:textures/tutorial/"+_image1+".image");
	
	TUTICON2=Widget(HUD,UI_ICON);
	TUTICON2.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	TUTICON2.setSize(512,256);
	TUTICON2.setPos(400,240);
	TUTICON2.setParam(PARAM_IMAGE,"LINEAR:textures/tutorial/"+_image2+".image");
	TUTICON2.hide();
 
	TUTICON3=Widget(HUD,UI_ICON);
	TUTICON3.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	TUTICON3.setSize(512,256);
	TUTICON3.setPos(400,240);
	TUTICON3.setParam(PARAM_IMAGE,"LINEAR:textures/tutorial/"+_image3+".image");
	TUTICON3.hide();
	
	addListener(ON_TIMEOUT_MSEC,"1500","cb3StaticSwap1");
	
	addListener(ON_MOUSEUP,"cbTapContinue");		
	gpad.onButtonDown("cbTapContinue");
}
void loadStaticTutorial(string _image1,string _image2,string _image3,string _image4) {
	TUTICON1=Widget(HUD,UI_ICON);
	TUTICON1.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	TUTICON1.setSize(512,256);
	TUTICON1.setPos(400,240);
	TUTICON1.setParam(PARAM_IMAGE,"LINEAR:textures/tutorial/"+_image1+".image");
	
	TUTICON2=Widget(HUD,UI_ICON);
	TUTICON2.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	TUTICON2.setSize(512,256);
	TUTICON2.setPos(400,240);
	TUTICON2.setParam(PARAM_IMAGE,"LINEAR:textures/tutorial/"+_image2+".image");
	TUTICON2.hide();
 
	TUTICON3=Widget(HUD,UI_ICON);
	TUTICON3.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	TUTICON3.setSize(512,256);
	TUTICON3.setPos(400,240);
	TUTICON3.setParam(PARAM_IMAGE,"LINEAR:textures/tutorial/"+_image3+".image");
	TUTICON3.hide();
	
	TUTICON4=Widget(HUD,UI_ICON);
	TUTICON4.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	TUTICON4.setSize(512,256);
	TUTICON4.setPos(400,240);
	TUTICON4.setParam(PARAM_IMAGE,"LINEAR:textures/tutorial/"+_image4+".image");
	TUTICON4.hide();
}
void cb3StaticSwap1() {
	TUTICON1.fadeOut(200,"");
	TUTICON2.fadeIn(200,"cb3StaticFade2");
}
void cb3StaticFade2() {
	addListener(ON_TIMEOUT_MSEC,"1500","cb3StaticSwap2");
}
void cb3StaticSwap2() {
	TUTICON2.fadeOut(200,"");
	TUTICON3.fadeIn(200,"cb3StaticFade3");
}
void cb3StaticFade3() {
	addListener(ON_TIMEOUT_MSEC,"3000","cb3StaticFade4");
}
void cb3StaticFade4() {
	TUTICON3.fadeOut(200,"cb3StaticFade5");
}
void cb3StaticFade5() {
	TUTICON1.fadeIn(200,"cb3StaticFade6");
}
void cb3StaticFade6() {
	addListener(ON_TIMEOUT_MSEC,"1500","cb3StaticSwap1");
}
void addControllerImage(string _image,int _dpad) {
	Widget w=Widget(TUTICON1,UI_ICON);
	w.setSize(64,64);
	if (_dpad) {
		w.setPos(40,330);
		w.setPivot(PIVOTX_LEFT,PIVOTY_BOTTOM);
	}
	else {
		w.setPos(512 - 40,330);
		w.setPivot(PIVOTX_RIGHT,PIVOTY_BOTTOM);
	}
	w.setParam(PARAM_IMAGE,_image);
}
void e_show(string _theme,int _level,string _replytag,string _replyevent) {
	REPLY_TAG=_replytag;
	REPLY_EVENT=_replyevent;
	
	this.hide();
	HUD.hide();
	HUD.delChildren();
	
	clearListeners(ON_MOUSEUP);
	clearListeners(ON_TIMEOUT_MSEC);
	
	twait.start();
	
	if (_theme=="forest") {
		if (_level==1) {
			//goals+swipe-left
			
			loadStaticTutorial("1","1b","2","2b");
			fcall("tutorial10_SETUP");
			//clearListeners(ON_MOUSEUP);
			//addListener(ON_MOUSEUP,"tutorial10_INIT");		
			//gpad.onButtonDown("tutorial10_INIT");
		}
		// else if (_level==2) {
			// //swipe back
			// loadStaticTutorial("2","2b");
			// TUTHAND=Widget(TUTICON1,UI_ICON);
			// TUTHAND.setSize(128,128);
			// TUTHAND.setParam(PARAM_IMAGE,"LINEAR:textures/tutorial/tuthand.image");			
			// fCall("cbAnimateHandTut1_2");
			// if (show_controller) addControllerImage("LINEAR:textures/ui/controller_dpadd.image",1);
		// }
		else if (_level==2) { loadStaticTutorial("5");  if (show_controller) addControllerImage("LINEAR:textures/ui/controller_buttona.image",0); }//tap to jump
		else if (_level==3) { loadStaticTutorial("4");  }//avoid clunnies
		else if (_level==4) { loadStaticTutorial("3");  }//gather clocks
		else if (_level==7) { loadStaticTutorial("6b"); if (show_controller) addControllerImage("LINEAR:textures/ui/controller_buttonb.image",0); }	//invisibility
		else if (_level==8) { loadStaticTutorial("6a"); if (show_controller) addControllerImage("LINEAR:textures/ui/controller_buttonx.image",0); } //shoes
		else if (_level==9) { loadStaticTutorial("6c"); if (show_controller) addControllerImage("LINEAR:textures/ui/controller_buttony.image",0); } //rocks
		else if (_level==13){ loadStaticTutorial("8","8b","8c"); }//hedgehog
		else if (_level==15){ loadStaticTutorial("7"); }//log
		else { sendEvent(REPLY_EVENT,REPLY_TAG); return; }
	}
	else if (_theme=="docks") {
		if (_level==8) { loadStaticTutorial("9","9b"); }//pier
		else { sendEvent(REPLY_EVENT,REPLY_TAG); return; }
	}
	else if (_theme=="desert") {
		if (_level==8) { loadStaticTutorial("10"); }//quicksand
		else if (_level==15) { loadStaticTutorial("11"); }//skull
		else { sendEvent(REPLY_EVENT,REPLY_TAG); return; }
	}
	else if (_theme=="snow") {
		if (_level==4) { loadStaticTutorial("12"); }//penguin
		else { sendEvent(REPLY_EVENT,REPLY_TAG); return; }
	}
	else {
		sendEvent(REPLY_EVENT,REPLY_TAG);
		return;
	}
	
	this.show();
	HUD.fadeIn(500,"cbTapStart");

	TAPTOCONTINUE=Widget(HUD,UI_ICON);
	TAPTOCONTINUE.setPivot(PIVOTX_RIGHT,PIVOTY_BOTTOM);
	TAPTOCONTINUE.setSize(64,64);
	TAPTOCONTINUE.setPos(790,470);
	TAPTOCONTINUE.setOpacity(0.0);
	TAPTOCONTINUE.setparam(PARAM_IMAGE,"LINEAR:textures/ui/ui_taptocontinue_normal.image");	
}
void cbTapStart() { addListener(ON_TIMEOUT_MSEC,"1000","cbTapAnim"); }
void cbTapAnim() {
	if (!this.isVisible()) return;
	TAPTOCONTINUE.animate("A","L1:0;L1:300;L0.1:1300","cbTapAnim");
}


void tutorial10_SETUP() {
	//if (twait.getMSec()<CONST_TIMER_WAIT) return;
	TUTICON1.fadeOut(100,"");
	TUTICON2.fadeOut(100,"");	
	
	clearListeners(ON_TIMEOUT_MSEC);
	clearListeners(ON_MOUSEUP);
	
	HANDPARENT = Widget(HUD,UI_ICON);
	HANDPARENT.setPivot(PIVOTX_CENTER,PIVOTY_MIDDLE);
	HANDPARENT.setSize(512,256);
	HANDPARENT.setPos(400,240);
	TUTHAND=Widget(HANDPARENT,UI_ICON);
	TUTHAND.setSize(128,128);
	TUTHAND.setParam(PARAM_IMAGE,"LINEAR:textures/tutorial/tuthand.image");
	twait.start();
	addListener(ON_MOUSEUP,"tutorial11_SETUP");		
	gpad.onButtonDown("tutorial11_SETUP");
	fcall("cbAnimateHandTut1_1");	
	}

void cbAnimateHandTut1_1() {		
 	TUTICON4.fadeOut(100,"");
	TUTICON3.fadeOut(100,"");
	TUTICON2.fadeOut(100,"");
	TUTICON1.fadeIn(100,"");
	TUTHAND.show();
	TUTHAND.clearanimate(string());
	TUTHAND.animate("X","60:200;L350:800;L350:1200","cbAnimateHandTut1_2");
	TUTHAND.animate("Y","L110:0;90:400;95:700","");
	TUTHAND.animate("A","L0:0;L0:20;L1:100;L1:1100;L0:1200","");
	if (show_controller) addControllerImage("LINEAR:textures/ui/controller_dpadlr.image",1);
}

void cbAnimateHandTut1_2() {
	TUTICON1.fadeOut(200,"");
	TUTICON2.fadeIn(200,"");
	TUTICON3.fadeOut(100,"");
	TUTICON4.fadeOut(100,"");
	addListener(ON_TIMEOUT_MSEC,"1500","cbAnimateHandTut1_1");
}
void tutorial11_SETUP(){
	if (twait.getMSec()<CONST_TIMER_WAIT) return;
	TUTICON1.fadeOut(100,"cbAnimateHandTut1_3");
	TUTICON2.fadeOut(100,"");	
	clearListeners(ON_TIMEOUT_MSEC);
	clearListeners(ON_MOUSEUP);
	addListener(ON_MOUSEUP,"cbTapContinue");		
	gpad.onButtonDown("cbTapContinue");
}
void cbAnimateHandTut1_3() {
	TUTICON1.fadeOut(100,"");
	TUTICON4.fadeOut(100,"");
 	TUTICON2.fadeOut(100,"");
	TUTICON3.fadeIn(100,"");	
	TUTHAND.clearanimate(string());
	TUTHAND.animate("X","200:100;200:200","");
	TUTHAND.animate("Y","20:0;190:600;200:1000","cbAnimateHandTut1_4");
	TUTHAND.animate("A","L0:0;L0:20;L1:100;L1:600;L0:700","");	
	if (show_controller) addControllerImage("LINEAR:textures/ui/controller_dpadd.image",1);
}
void cbAnimateHandTut1_4() {
	TUTICON1.fadeOut(100,"");
	TUTICON2.fadeOut(100,"");
	TUTICON3.fadeOut(200,"");
	TUTICON4.fadeIn(200,"");
	addListener(ON_TIMEOUT_MSEC,"1500","cbAnimateHandTut1_3");
}


void cbTapContinue() {
	if (twait.getMSec()<CONST_TIMER_WAIT) return;
	clearListeners(ON_MOUSEUP);		
	clearListeners(ON_TIMEOUT_MSEC);
	gpad.onButtonDown("");
	sendEvent(REPLY_EVENT,REPLY_TAG);
}
public int showController() {
	show_controller=1;
	return 1;
}


