 /****************************************************************************
 * This file is part of Bunny Maze Application                                *
 *                                                                           *
 * Copyright (c) 2011, Eyelead Software. All rights reserved.                *
 * PROPRIETARY AND CONFIDENTIAL                                              *
 *                                                                           *
 * This file is subject to the terms and conditions of the                   *
 * Commercial Software License Agreement by and between                      *
 * Qualcomm Incorporated and Eyelead Software S.A                            *
 * as made and entered on September 30th, 2011                               *
 *****************************************************************************/

#using stdlib game
#hive 1
String APPNAME = "bunnymaze";

int crack_state=0;
vfile actor;

public void reset() {
	crack_state=0;
	actor.setMaster("reset",0);
	this.setPos(float3(0.0,2.0,0.0));
}
void init()
{ 
	//set entity tag
	debugLog("Loading trap: "+getTag());
	this.setChannel("prox.radius",2.0);
	actor=vfopen(this.path()+"/../../"+getTag(),"r");
	actor.onComplete("reset");
}
public string isLoaded() {
	return "1";
}
public void regEvents() {
	addListener(ON_ENTITYENTER,"e_enter");
	addListener(ON_ENTITYLEAVE,"e_leave");
}
void e_enter(string _tag) {
	if (_tag=="hero") {
		if (crack_state<2) {
			["hero"->setSpeedTrap(0.7)];
			crack_state++;
			if (crack_state==1) {
				actor.setMaster("crack",0);
				["hero"->playIcecrack(0)];
			}
			else {
				actor.setMaster("collapse",0);
				["hero"->playIcecrack(1)];
			}
		}
		if (crack_state==2) {
			Event e=Event("CRACK","hero");
			e.addArg(actor.getPos());
			e.sendEvent();
		}
	}
}
void e_leave(string _tag) {
	if (_tag=="hero") {
		["hero"->setSpeedTrap(1.0)];
	}
}
public void savestate() {
	appPropertySet(APPNAME,getTag()+"_CRACKED",string(crack_state));
}
public void loadstate() {
	crack_state=int(appPropertyGet(APPNAME,getTag()+"_CRACKED",string(crack_state)));
	if (crack_state==1) {
		actor.setMaster("crack",0);
	}
	else if (crack_state==2) {
		actor.setMaster("collapse",0);
	}
}
public int validate() {
	return (crack_state<2);
}
